/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2ElementwiseSupgAdvection.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseSupgAdvection::toMatrix_P2ElementwiseSupgAdvection_macro_2D( real_t * RESTRICT  _data_cp_times_deltaEdge, real_t * RESTRICT  _data_cp_times_deltaVertex, idx_t * RESTRICT  _data_dstEdge, idx_t * RESTRICT  _data_dstVertex, idx_t * RESTRICT  _data_srcEdge, idx_t * RESTRICT  _data_srcVertex, real_t * RESTRICT  _data_uxEdge, real_t * RESTRICT  _data_uxVertex, real_t * RESTRICT  _data_uyEdge, real_t * RESTRICT  _data_uyVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       const real_t tmp_kernel_op_0 = 1.3333333333333333;
       const real_t tmp_kernel_op_1 = 1.3333333333333333;
       const real_t tmp_kernel_op_2 = tmp_kernel_op_0 + tmp_kernel_op_1 - 3.0;
       const real_t tmp_kernel_op_3 = tmp_kernel_op_0*0.33333333333333331;
       const real_t tmp_kernel_op_4 = 0.1111111111111111;
       const real_t tmp_kernel_op_5 = tmp_kernel_op_4*2.0;
       const real_t tmp_kernel_op_6 = tmp_kernel_op_5 - 0.33333333333333331;
       const real_t tmp_kernel_op_7 = 0.1111111111111111;
       const real_t tmp_kernel_op_8 = tmp_kernel_op_7*2.0;
       const real_t tmp_kernel_op_9 = tmp_kernel_op_8 - 0.33333333333333331;
       const real_t tmp_kernel_op_10 = tmp_kernel_op_1 - tmp_kernel_op_3 + tmp_kernel_op_7*-4.0;
       const real_t tmp_kernel_op_11 = tmp_kernel_op_0 - tmp_kernel_op_3 + tmp_kernel_op_4*-4.0;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_3 + tmp_kernel_op_5 + tmp_kernel_op_8 - 1.0;
       const real_t tmp_kernel_op_17 = 0.80000000000000004;
       const real_t tmp_kernel_op_18 = 2.3999999999999999;
       const real_t tmp_kernel_op_19 = tmp_kernel_op_17 + tmp_kernel_op_18 - 3.0;
       const real_t tmp_kernel_op_20 = tmp_kernel_op_17*0.59999999999999998;
       const real_t tmp_kernel_op_21 = 0.040000000000000008;
       const real_t tmp_kernel_op_22 = tmp_kernel_op_21*2.0;
       const real_t tmp_kernel_op_23 = tmp_kernel_op_22 - 0.20000000000000001;
       const real_t tmp_kernel_op_24 = 0.35999999999999999;
       const real_t tmp_kernel_op_25 = tmp_kernel_op_24*2.0;
       const real_t tmp_kernel_op_26 = tmp_kernel_op_25 - 0.59999999999999998;
       const real_t tmp_kernel_op_27 = tmp_kernel_op_18 - tmp_kernel_op_20 + tmp_kernel_op_24*-4.0;
       const real_t tmp_kernel_op_28 = tmp_kernel_op_17 - tmp_kernel_op_20 + tmp_kernel_op_21*-4.0;
       const real_t tmp_kernel_op_29 = tmp_kernel_op_20 + tmp_kernel_op_22 + tmp_kernel_op_25 - 1.3999999999999999;
       const real_t tmp_kernel_op_34 = 2.3999999999999999;
       const real_t tmp_kernel_op_35 = 0.80000000000000004;
       const real_t tmp_kernel_op_36 = tmp_kernel_op_34 + tmp_kernel_op_35 - 3.0;
       const real_t tmp_kernel_op_37 = tmp_kernel_op_34*0.20000000000000001;
       const real_t tmp_kernel_op_38 = 0.35999999999999999;
       const real_t tmp_kernel_op_39 = tmp_kernel_op_38*2.0;
       const real_t tmp_kernel_op_40 = tmp_kernel_op_39 - 0.59999999999999998;
       const real_t tmp_kernel_op_41 = 0.040000000000000008;
       const real_t tmp_kernel_op_42 = tmp_kernel_op_41*2.0;
       const real_t tmp_kernel_op_43 = tmp_kernel_op_42 - 0.20000000000000001;
       const real_t tmp_kernel_op_44 = tmp_kernel_op_35 - tmp_kernel_op_37 + tmp_kernel_op_41*-4.0;
       const real_t tmp_kernel_op_45 = tmp_kernel_op_34 - tmp_kernel_op_37 + tmp_kernel_op_38*-4.0;
       const real_t tmp_kernel_op_46 = tmp_kernel_op_37 + tmp_kernel_op_39 + tmp_kernel_op_42 - 1.3999999999999999;
       const real_t tmp_kernel_op_51 = 0.80000000000000004;
       const real_t tmp_kernel_op_52 = 0.80000000000000004;
       const real_t tmp_kernel_op_53 = tmp_kernel_op_51 + tmp_kernel_op_52 - 3.0;
       const real_t tmp_kernel_op_54 = tmp_kernel_op_51*0.20000000000000001;
       const real_t tmp_kernel_op_55 = 0.040000000000000008;
       const real_t tmp_kernel_op_56 = tmp_kernel_op_55*2.0;
       const real_t tmp_kernel_op_57 = tmp_kernel_op_56 - 0.20000000000000001;
       const real_t tmp_kernel_op_58 = 0.040000000000000008;
       const real_t tmp_kernel_op_59 = tmp_kernel_op_58*2.0;
       const real_t tmp_kernel_op_60 = tmp_kernel_op_59 - 0.20000000000000001;
       const real_t tmp_kernel_op_61 = tmp_kernel_op_52 - tmp_kernel_op_54 + tmp_kernel_op_58*-4.0;
       const real_t tmp_kernel_op_62 = tmp_kernel_op_51 - tmp_kernel_op_54 + tmp_kernel_op_55*-4.0;
       const real_t tmp_kernel_op_63 = tmp_kernel_op_54 + tmp_kernel_op_56 + tmp_kernel_op_59 - 0.20000000000000018;
       const real_t tmp_kernel_op_68 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_71 = tmp_kernel_op_17 - 1.0;
       const real_t tmp_kernel_op_74 = tmp_kernel_op_34 - 1.0;
       const real_t tmp_kernel_op_77 = tmp_kernel_op_51 - 1.0;
       const real_t tmp_kernel_op_81 = tmp_kernel_op_1 - 1.0;
       const real_t tmp_kernel_op_83 = tmp_kernel_op_18 - 1.0;
       const real_t tmp_kernel_op_85 = tmp_kernel_op_35 - 1.0;
       const real_t tmp_kernel_op_87 = tmp_kernel_op_52 - 1.0;
       const real_t tmp_kernel_op_90 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_1;
       const real_t tmp_kernel_op_91 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_92 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_1;
       const real_t tmp_kernel_op_93 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_95 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_18;
       const real_t tmp_kernel_op_96 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_17;
       const real_t tmp_kernel_op_97 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_18;
       const real_t tmp_kernel_op_98 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_17;
       const real_t tmp_kernel_op_100 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_35;
       const real_t tmp_kernel_op_101 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_34;
       const real_t tmp_kernel_op_102 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_35;
       const real_t tmp_kernel_op_103 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_34;
       const real_t tmp_kernel_op_105 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_52;
       const real_t tmp_kernel_op_106 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_51;
       const real_t tmp_kernel_op_107 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_52;
       const real_t tmp_kernel_op_108 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_51;
       const real_t tmp_kernel_op_111 = -tmp_kernel_op_0 + 1.3333333333333335;
       const real_t tmp_kernel_op_113 = -tmp_kernel_op_17 - 0.79999999999999982;
       const real_t tmp_kernel_op_115 = -tmp_kernel_op_34 + 2.3999999999999999;
       const real_t tmp_kernel_op_117 = -tmp_kernel_op_51 + 2.3999999999999999;
       const real_t tmp_kernel_op_120 = -tmp_kernel_op_1 + 1.3333333333333335;
       const real_t tmp_kernel_op_122 = -tmp_kernel_op_18 + 2.3999999999999999;
       const real_t tmp_kernel_op_124 = -tmp_kernel_op_35 - 0.79999999999999982;
       const real_t tmp_kernel_op_126 = -tmp_kernel_op_52 + 2.3999999999999999;
       {
          /* FaceType.GRAY */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t cp_times_delta_dof_0 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t cp_times_delta_dof_1 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t cp_times_delta_dof_2 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t cp_times_delta_dof_3 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t cp_times_delta_dof_4 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t cp_times_delta_dof_5 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ux_dof_3 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t uy_dof_3 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t tmp_kernel_op_13 = tmp_kernel_op_10*ux_dof_4 + tmp_kernel_op_11*ux_dof_5 + tmp_kernel_op_12*ux_dof_0 + tmp_kernel_op_3*ux_dof_3 + tmp_kernel_op_6*ux_dof_1 + tmp_kernel_op_9*ux_dof_2;
             const real_t tmp_kernel_op_14 = tmp_kernel_op_10*uy_dof_4 + tmp_kernel_op_11*uy_dof_5 + tmp_kernel_op_12*uy_dof_0 + tmp_kernel_op_3*uy_dof_3 + tmp_kernel_op_6*uy_dof_1 + tmp_kernel_op_9*uy_dof_2;
             const real_t tmp_kernel_op_15 = tmp_kernel_op_13*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_2 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_2) + tmp_kernel_op_14*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_2 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_2);
             const real_t tmp_kernel_op_16 = abs_det_jac_affine_GRAY*(cp_times_delta_dof_0*tmp_kernel_op_12 + cp_times_delta_dof_1*tmp_kernel_op_6 + cp_times_delta_dof_2*tmp_kernel_op_9 + cp_times_delta_dof_3*tmp_kernel_op_3 + cp_times_delta_dof_4*tmp_kernel_op_10 + cp_times_delta_dof_5*tmp_kernel_op_11)*-0.28125;
             const real_t tmp_kernel_op_30 = tmp_kernel_op_20*ux_dof_3 + tmp_kernel_op_23*ux_dof_1 + tmp_kernel_op_26*ux_dof_2 + tmp_kernel_op_27*ux_dof_4 + tmp_kernel_op_28*ux_dof_5 + tmp_kernel_op_29*ux_dof_0;
             const real_t tmp_kernel_op_31 = tmp_kernel_op_20*uy_dof_3 + tmp_kernel_op_23*uy_dof_1 + tmp_kernel_op_26*uy_dof_2 + tmp_kernel_op_27*uy_dof_4 + tmp_kernel_op_28*uy_dof_5 + tmp_kernel_op_29*uy_dof_0;
             const real_t tmp_kernel_op_32 = tmp_kernel_op_30*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_19 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_19) + tmp_kernel_op_31*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_19 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_19);
             const real_t tmp_kernel_op_33 = abs_det_jac_affine_GRAY*(cp_times_delta_dof_0*tmp_kernel_op_29 + cp_times_delta_dof_1*tmp_kernel_op_23 + cp_times_delta_dof_2*tmp_kernel_op_26 + cp_times_delta_dof_3*tmp_kernel_op_20 + cp_times_delta_dof_4*tmp_kernel_op_27 + cp_times_delta_dof_5*tmp_kernel_op_28)*0.26041666666666669;
             const real_t tmp_kernel_op_47 = tmp_kernel_op_37*ux_dof_3 + tmp_kernel_op_40*ux_dof_1 + tmp_kernel_op_43*ux_dof_2 + tmp_kernel_op_44*ux_dof_4 + tmp_kernel_op_45*ux_dof_5 + tmp_kernel_op_46*ux_dof_0;
             const real_t tmp_kernel_op_48 = tmp_kernel_op_37*uy_dof_3 + tmp_kernel_op_40*uy_dof_1 + tmp_kernel_op_43*uy_dof_2 + tmp_kernel_op_44*uy_dof_4 + tmp_kernel_op_45*uy_dof_5 + tmp_kernel_op_46*uy_dof_0;
             const real_t tmp_kernel_op_49 = tmp_kernel_op_47*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_36 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_36) + tmp_kernel_op_48*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_36 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_36);
             const real_t tmp_kernel_op_50 = abs_det_jac_affine_GRAY*(cp_times_delta_dof_0*tmp_kernel_op_46 + cp_times_delta_dof_1*tmp_kernel_op_40 + cp_times_delta_dof_2*tmp_kernel_op_43 + cp_times_delta_dof_3*tmp_kernel_op_37 + cp_times_delta_dof_4*tmp_kernel_op_44 + cp_times_delta_dof_5*tmp_kernel_op_45)*0.26041666666666669;
             const real_t tmp_kernel_op_64 = tmp_kernel_op_54*ux_dof_3 + tmp_kernel_op_57*ux_dof_1 + tmp_kernel_op_60*ux_dof_2 + tmp_kernel_op_61*ux_dof_4 + tmp_kernel_op_62*ux_dof_5 + tmp_kernel_op_63*ux_dof_0;
             const real_t tmp_kernel_op_65 = tmp_kernel_op_54*uy_dof_3 + tmp_kernel_op_57*uy_dof_1 + tmp_kernel_op_60*uy_dof_2 + tmp_kernel_op_61*uy_dof_4 + tmp_kernel_op_62*uy_dof_5 + tmp_kernel_op_63*uy_dof_0;
             const real_t tmp_kernel_op_66 = tmp_kernel_op_64*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_53 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_53) + tmp_kernel_op_65*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_53 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_53);
             const real_t tmp_kernel_op_67 = abs_det_jac_affine_GRAY*(cp_times_delta_dof_0*tmp_kernel_op_63 + cp_times_delta_dof_1*tmp_kernel_op_57 + cp_times_delta_dof_2*tmp_kernel_op_60 + cp_times_delta_dof_3*tmp_kernel_op_54 + cp_times_delta_dof_4*tmp_kernel_op_61 + cp_times_delta_dof_5*tmp_kernel_op_62)*0.26041666666666669;
             const real_t tmp_kernel_op_69 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_13*tmp_kernel_op_68 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_14*tmp_kernel_op_68;
             const real_t tmp_kernel_op_70 = tmp_kernel_op_15*tmp_kernel_op_16;
             const real_t tmp_kernel_op_72 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_30*tmp_kernel_op_71 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_31*tmp_kernel_op_71;
             const real_t tmp_kernel_op_73 = tmp_kernel_op_32*tmp_kernel_op_33;
             const real_t tmp_kernel_op_75 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_47*tmp_kernel_op_74 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_48*tmp_kernel_op_74;
             const real_t tmp_kernel_op_76 = tmp_kernel_op_49*tmp_kernel_op_50;
             const real_t tmp_kernel_op_78 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_64*tmp_kernel_op_77 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_65*tmp_kernel_op_77;
             const real_t tmp_kernel_op_79 = tmp_kernel_op_66*tmp_kernel_op_67;
             const real_t tmp_kernel_op_80 = tmp_kernel_op_69*tmp_kernel_op_70 + tmp_kernel_op_72*tmp_kernel_op_73 + tmp_kernel_op_75*tmp_kernel_op_76 + tmp_kernel_op_78*tmp_kernel_op_79;
             const real_t tmp_kernel_op_82 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_13*tmp_kernel_op_81 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_14*tmp_kernel_op_81;
             const real_t tmp_kernel_op_84 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_30*tmp_kernel_op_83 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_31*tmp_kernel_op_83;
             const real_t tmp_kernel_op_86 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_47*tmp_kernel_op_85 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_48*tmp_kernel_op_85;
             const real_t tmp_kernel_op_88 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_64*tmp_kernel_op_87 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_65*tmp_kernel_op_87;
             const real_t tmp_kernel_op_89 = tmp_kernel_op_70*tmp_kernel_op_82 + tmp_kernel_op_73*tmp_kernel_op_84 + tmp_kernel_op_76*tmp_kernel_op_86 + tmp_kernel_op_79*tmp_kernel_op_88;
             const real_t tmp_kernel_op_94 = tmp_kernel_op_13*(tmp_kernel_op_90 + tmp_kernel_op_91) + tmp_kernel_op_14*(tmp_kernel_op_92 + tmp_kernel_op_93);
             const real_t tmp_kernel_op_99 = tmp_kernel_op_30*(tmp_kernel_op_95 + tmp_kernel_op_96) + tmp_kernel_op_31*(tmp_kernel_op_97 + tmp_kernel_op_98);
             const real_t tmp_kernel_op_104 = tmp_kernel_op_47*(tmp_kernel_op_100 + tmp_kernel_op_101) + tmp_kernel_op_48*(tmp_kernel_op_102 + tmp_kernel_op_103);
             const real_t tmp_kernel_op_109 = tmp_kernel_op_64*(tmp_kernel_op_105 + tmp_kernel_op_106) + tmp_kernel_op_65*(tmp_kernel_op_107 + tmp_kernel_op_108);
             const real_t tmp_kernel_op_110 = tmp_kernel_op_104*tmp_kernel_op_76 + tmp_kernel_op_109*tmp_kernel_op_79 + tmp_kernel_op_70*tmp_kernel_op_94 + tmp_kernel_op_73*tmp_kernel_op_99;
             const real_t tmp_kernel_op_112 = tmp_kernel_op_13*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_111 - tmp_kernel_op_90) + tmp_kernel_op_14*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_111 - tmp_kernel_op_92);
             const real_t tmp_kernel_op_114 = tmp_kernel_op_30*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_113 - tmp_kernel_op_95) + tmp_kernel_op_31*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_113 - tmp_kernel_op_97);
             const real_t tmp_kernel_op_116 = tmp_kernel_op_47*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_115 - tmp_kernel_op_100) + tmp_kernel_op_48*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_115 - tmp_kernel_op_102);
             const real_t tmp_kernel_op_118 = tmp_kernel_op_64*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_117 - tmp_kernel_op_105) + tmp_kernel_op_65*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_117 - tmp_kernel_op_107);
             const real_t tmp_kernel_op_119 = tmp_kernel_op_112*tmp_kernel_op_70 + tmp_kernel_op_114*tmp_kernel_op_73 + tmp_kernel_op_116*tmp_kernel_op_76 + tmp_kernel_op_118*tmp_kernel_op_79;
             const real_t tmp_kernel_op_121 = tmp_kernel_op_13*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_120 - tmp_kernel_op_91) + tmp_kernel_op_14*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_120 - tmp_kernel_op_93);
             const real_t tmp_kernel_op_123 = tmp_kernel_op_30*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_122 - tmp_kernel_op_96) + tmp_kernel_op_31*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_122 - tmp_kernel_op_98);
             const real_t tmp_kernel_op_125 = tmp_kernel_op_47*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_124 - tmp_kernel_op_101) + tmp_kernel_op_48*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_124 - tmp_kernel_op_103);
             const real_t tmp_kernel_op_127 = tmp_kernel_op_64*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_126 - tmp_kernel_op_106) + tmp_kernel_op_65*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_126 - tmp_kernel_op_108);
             const real_t tmp_kernel_op_128 = tmp_kernel_op_121*tmp_kernel_op_70 + tmp_kernel_op_123*tmp_kernel_op_73 + tmp_kernel_op_125*tmp_kernel_op_76 + tmp_kernel_op_127*tmp_kernel_op_79;
             const real_t tmp_kernel_op_129 = tmp_kernel_op_16*tmp_kernel_op_69;
             const real_t tmp_kernel_op_130 = tmp_kernel_op_33*tmp_kernel_op_72;
             const real_t tmp_kernel_op_131 = tmp_kernel_op_50*tmp_kernel_op_75;
             const real_t tmp_kernel_op_132 = tmp_kernel_op_67*tmp_kernel_op_78;
             const real_t tmp_kernel_op_133 = tmp_kernel_op_129*tmp_kernel_op_82 + tmp_kernel_op_130*tmp_kernel_op_84 + tmp_kernel_op_131*tmp_kernel_op_86 + tmp_kernel_op_132*tmp_kernel_op_88;
             const real_t tmp_kernel_op_134 = tmp_kernel_op_104*tmp_kernel_op_131 + tmp_kernel_op_109*tmp_kernel_op_132 + tmp_kernel_op_129*tmp_kernel_op_94 + tmp_kernel_op_130*tmp_kernel_op_99;
             const real_t tmp_kernel_op_135 = tmp_kernel_op_112*tmp_kernel_op_129 + tmp_kernel_op_114*tmp_kernel_op_130 + tmp_kernel_op_116*tmp_kernel_op_131 + tmp_kernel_op_118*tmp_kernel_op_132;
             const real_t tmp_kernel_op_136 = tmp_kernel_op_121*tmp_kernel_op_129 + tmp_kernel_op_123*tmp_kernel_op_130 + tmp_kernel_op_125*tmp_kernel_op_131 + tmp_kernel_op_127*tmp_kernel_op_132;
             const real_t tmp_kernel_op_137 = tmp_kernel_op_16*tmp_kernel_op_82;
             const real_t tmp_kernel_op_138 = tmp_kernel_op_33*tmp_kernel_op_84;
             const real_t tmp_kernel_op_139 = tmp_kernel_op_50*tmp_kernel_op_86;
             const real_t tmp_kernel_op_140 = tmp_kernel_op_67*tmp_kernel_op_88;
             const real_t tmp_kernel_op_141 = tmp_kernel_op_104*tmp_kernel_op_139 + tmp_kernel_op_109*tmp_kernel_op_140 + tmp_kernel_op_137*tmp_kernel_op_94 + tmp_kernel_op_138*tmp_kernel_op_99;
             const real_t tmp_kernel_op_142 = tmp_kernel_op_112*tmp_kernel_op_137 + tmp_kernel_op_114*tmp_kernel_op_138 + tmp_kernel_op_116*tmp_kernel_op_139 + tmp_kernel_op_118*tmp_kernel_op_140;
             const real_t tmp_kernel_op_143 = tmp_kernel_op_121*tmp_kernel_op_137 + tmp_kernel_op_123*tmp_kernel_op_138 + tmp_kernel_op_125*tmp_kernel_op_139 + tmp_kernel_op_127*tmp_kernel_op_140;
             const real_t tmp_kernel_op_144 = tmp_kernel_op_16*tmp_kernel_op_94;
             const real_t tmp_kernel_op_145 = tmp_kernel_op_33*tmp_kernel_op_99;
             const real_t tmp_kernel_op_146 = tmp_kernel_op_104*tmp_kernel_op_50;
             const real_t tmp_kernel_op_147 = tmp_kernel_op_109*tmp_kernel_op_67;
             const real_t tmp_kernel_op_148 = tmp_kernel_op_112*tmp_kernel_op_144 + tmp_kernel_op_114*tmp_kernel_op_145 + tmp_kernel_op_116*tmp_kernel_op_146 + tmp_kernel_op_118*tmp_kernel_op_147;
             const real_t tmp_kernel_op_149 = tmp_kernel_op_121*tmp_kernel_op_144 + tmp_kernel_op_123*tmp_kernel_op_145 + tmp_kernel_op_125*tmp_kernel_op_146 + tmp_kernel_op_127*tmp_kernel_op_147;
             const real_t tmp_kernel_op_150 = tmp_kernel_op_112*tmp_kernel_op_121*tmp_kernel_op_16 + tmp_kernel_op_114*tmp_kernel_op_123*tmp_kernel_op_33 + tmp_kernel_op_116*tmp_kernel_op_125*tmp_kernel_op_50 + tmp_kernel_op_118*tmp_kernel_op_127*tmp_kernel_op_67;
             const real_t elMat_0_0 = (tmp_kernel_op_15*tmp_kernel_op_15)*tmp_kernel_op_16 + (tmp_kernel_op_32*tmp_kernel_op_32)*tmp_kernel_op_33 + (tmp_kernel_op_49*tmp_kernel_op_49)*tmp_kernel_op_50 + (tmp_kernel_op_66*tmp_kernel_op_66)*tmp_kernel_op_67;
             const real_t elMat_0_1 = tmp_kernel_op_80;
             const real_t elMat_0_2 = tmp_kernel_op_89;
             const real_t elMat_0_3 = tmp_kernel_op_110;
             const real_t elMat_0_4 = tmp_kernel_op_119;
             const real_t elMat_0_5 = tmp_kernel_op_128;
             const real_t elMat_1_0 = tmp_kernel_op_80;
             const real_t elMat_1_1 = tmp_kernel_op_16*(tmp_kernel_op_69*tmp_kernel_op_69) + tmp_kernel_op_33*(tmp_kernel_op_72*tmp_kernel_op_72) + tmp_kernel_op_50*(tmp_kernel_op_75*tmp_kernel_op_75) + tmp_kernel_op_67*(tmp_kernel_op_78*tmp_kernel_op_78);
             const real_t elMat_1_2 = tmp_kernel_op_133;
             const real_t elMat_1_3 = tmp_kernel_op_134;
             const real_t elMat_1_4 = tmp_kernel_op_135;
             const real_t elMat_1_5 = tmp_kernel_op_136;
             const real_t elMat_2_0 = tmp_kernel_op_89;
             const real_t elMat_2_1 = tmp_kernel_op_133;
             const real_t elMat_2_2 = tmp_kernel_op_16*(tmp_kernel_op_82*tmp_kernel_op_82) + tmp_kernel_op_33*(tmp_kernel_op_84*tmp_kernel_op_84) + tmp_kernel_op_50*(tmp_kernel_op_86*tmp_kernel_op_86) + tmp_kernel_op_67*(tmp_kernel_op_88*tmp_kernel_op_88);
             const real_t elMat_2_3 = tmp_kernel_op_141;
             const real_t elMat_2_4 = tmp_kernel_op_142;
             const real_t elMat_2_5 = tmp_kernel_op_143;
             const real_t elMat_3_0 = tmp_kernel_op_110;
             const real_t elMat_3_1 = tmp_kernel_op_134;
             const real_t elMat_3_2 = tmp_kernel_op_141;
             const real_t elMat_3_3 = (tmp_kernel_op_104*tmp_kernel_op_104)*tmp_kernel_op_50 + (tmp_kernel_op_109*tmp_kernel_op_109)*tmp_kernel_op_67 + tmp_kernel_op_16*(tmp_kernel_op_94*tmp_kernel_op_94) + tmp_kernel_op_33*(tmp_kernel_op_99*tmp_kernel_op_99);
             const real_t elMat_3_4 = tmp_kernel_op_148;
             const real_t elMat_3_5 = tmp_kernel_op_149;
             const real_t elMat_4_0 = tmp_kernel_op_119;
             const real_t elMat_4_1 = tmp_kernel_op_135;
             const real_t elMat_4_2 = tmp_kernel_op_142;
             const real_t elMat_4_3 = tmp_kernel_op_148;
             const real_t elMat_4_4 = (tmp_kernel_op_112*tmp_kernel_op_112)*tmp_kernel_op_16 + (tmp_kernel_op_114*tmp_kernel_op_114)*tmp_kernel_op_33 + (tmp_kernel_op_116*tmp_kernel_op_116)*tmp_kernel_op_50 + (tmp_kernel_op_118*tmp_kernel_op_118)*tmp_kernel_op_67;
             const real_t elMat_4_5 = tmp_kernel_op_150;
             const real_t elMat_5_0 = tmp_kernel_op_128;
             const real_t elMat_5_1 = tmp_kernel_op_136;
             const real_t elMat_5_2 = tmp_kernel_op_143;
             const real_t elMat_5_3 = tmp_kernel_op_149;
             const real_t elMat_5_4 = tmp_kernel_op_150;
             const real_t elMat_5_5 = (tmp_kernel_op_121*tmp_kernel_op_121)*tmp_kernel_op_16 + (tmp_kernel_op_123*tmp_kernel_op_123)*tmp_kernel_op_33 + (tmp_kernel_op_125*tmp_kernel_op_125)*tmp_kernel_op_50 + (tmp_kernel_op_127*tmp_kernel_op_127)*tmp_kernel_op_67;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< real_t > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[3] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_1_0));
             _data_mat[7] = ((real_t)(elMat_1_1));
             _data_mat[8] = ((real_t)(elMat_1_2));
             _data_mat[9] = ((real_t)(elMat_1_3));
             _data_mat[10] = ((real_t)(elMat_1_4));
             _data_mat[11] = ((real_t)(elMat_1_5));
             _data_mat[12] = ((real_t)(elMat_2_0));
             _data_mat[13] = ((real_t)(elMat_2_1));
             _data_mat[14] = ((real_t)(elMat_2_2));
             _data_mat[15] = ((real_t)(elMat_2_3));
             _data_mat[16] = ((real_t)(elMat_2_4));
             _data_mat[17] = ((real_t)(elMat_2_5));
             _data_mat[18] = ((real_t)(elMat_3_0));
             _data_mat[19] = ((real_t)(elMat_3_1));
             _data_mat[20] = ((real_t)(elMat_3_2));
             _data_mat[21] = ((real_t)(elMat_3_3));
             _data_mat[22] = ((real_t)(elMat_3_4));
             _data_mat[23] = ((real_t)(elMat_3_5));
             _data_mat[24] = ((real_t)(elMat_4_0));
             _data_mat[25] = ((real_t)(elMat_4_1));
             _data_mat[26] = ((real_t)(elMat_4_2));
             _data_mat[27] = ((real_t)(elMat_4_3));
             _data_mat[28] = ((real_t)(elMat_4_4));
             _data_mat[29] = ((real_t)(elMat_4_5));
             _data_mat[30] = ((real_t)(elMat_5_0));
             _data_mat[31] = ((real_t)(elMat_5_1));
             _data_mat[32] = ((real_t)(elMat_5_2));
             _data_mat[33] = ((real_t)(elMat_5_3));
             _data_mat[34] = ((real_t)(elMat_5_4));
             _data_mat[35] = ((real_t)(elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       const real_t tmp_moved_constant_0 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_2 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_1;
       const real_t tmp_moved_constant_3 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_4 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_18;
       const real_t tmp_moved_constant_5 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_17;
       const real_t tmp_moved_constant_6 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_18;
       const real_t tmp_moved_constant_7 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_17;
       const real_t tmp_moved_constant_8 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_35;
       const real_t tmp_moved_constant_9 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_34;
       const real_t tmp_moved_constant_10 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_35;
       const real_t tmp_moved_constant_11 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_34;
       const real_t tmp_moved_constant_12 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_52;
       const real_t tmp_moved_constant_13 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_51;
       const real_t tmp_moved_constant_14 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_52;
       const real_t tmp_moved_constant_15 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_51;
       {
          /* FaceType.BLUE */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t cp_times_delta_dof_0 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t cp_times_delta_dof_1 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t cp_times_delta_dof_2 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t cp_times_delta_dof_3 = _data_cp_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t cp_times_delta_dof_4 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t cp_times_delta_dof_5 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t ux_dof_3 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t uy_dof_3 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t tmp_kernel_op_13 = tmp_kernel_op_10*ux_dof_4 + tmp_kernel_op_11*ux_dof_5 + tmp_kernel_op_12*ux_dof_0 + tmp_kernel_op_3*ux_dof_3 + tmp_kernel_op_6*ux_dof_1 + tmp_kernel_op_9*ux_dof_2;
             const real_t tmp_kernel_op_14 = tmp_kernel_op_10*uy_dof_4 + tmp_kernel_op_11*uy_dof_5 + tmp_kernel_op_12*uy_dof_0 + tmp_kernel_op_3*uy_dof_3 + tmp_kernel_op_6*uy_dof_1 + tmp_kernel_op_9*uy_dof_2;
             const real_t tmp_kernel_op_15 = tmp_kernel_op_13*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_2 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_2) + tmp_kernel_op_14*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_2 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_2);
             const real_t tmp_kernel_op_16 = abs_det_jac_affine_BLUE*(cp_times_delta_dof_0*tmp_kernel_op_12 + cp_times_delta_dof_1*tmp_kernel_op_6 + cp_times_delta_dof_2*tmp_kernel_op_9 + cp_times_delta_dof_3*tmp_kernel_op_3 + cp_times_delta_dof_4*tmp_kernel_op_10 + cp_times_delta_dof_5*tmp_kernel_op_11)*-0.28125;
             const real_t tmp_kernel_op_30 = tmp_kernel_op_20*ux_dof_3 + tmp_kernel_op_23*ux_dof_1 + tmp_kernel_op_26*ux_dof_2 + tmp_kernel_op_27*ux_dof_4 + tmp_kernel_op_28*ux_dof_5 + tmp_kernel_op_29*ux_dof_0;
             const real_t tmp_kernel_op_31 = tmp_kernel_op_20*uy_dof_3 + tmp_kernel_op_23*uy_dof_1 + tmp_kernel_op_26*uy_dof_2 + tmp_kernel_op_27*uy_dof_4 + tmp_kernel_op_28*uy_dof_5 + tmp_kernel_op_29*uy_dof_0;
             const real_t tmp_kernel_op_32 = tmp_kernel_op_30*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_19 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_19) + tmp_kernel_op_31*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_19 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_19);
             const real_t tmp_kernel_op_33 = abs_det_jac_affine_BLUE*(cp_times_delta_dof_0*tmp_kernel_op_29 + cp_times_delta_dof_1*tmp_kernel_op_23 + cp_times_delta_dof_2*tmp_kernel_op_26 + cp_times_delta_dof_3*tmp_kernel_op_20 + cp_times_delta_dof_4*tmp_kernel_op_27 + cp_times_delta_dof_5*tmp_kernel_op_28)*0.26041666666666669;
             const real_t tmp_kernel_op_47 = tmp_kernel_op_37*ux_dof_3 + tmp_kernel_op_40*ux_dof_1 + tmp_kernel_op_43*ux_dof_2 + tmp_kernel_op_44*ux_dof_4 + tmp_kernel_op_45*ux_dof_5 + tmp_kernel_op_46*ux_dof_0;
             const real_t tmp_kernel_op_48 = tmp_kernel_op_37*uy_dof_3 + tmp_kernel_op_40*uy_dof_1 + tmp_kernel_op_43*uy_dof_2 + tmp_kernel_op_44*uy_dof_4 + tmp_kernel_op_45*uy_dof_5 + tmp_kernel_op_46*uy_dof_0;
             const real_t tmp_kernel_op_49 = tmp_kernel_op_47*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_36 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_36) + tmp_kernel_op_48*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_36 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_36);
             const real_t tmp_kernel_op_50 = abs_det_jac_affine_BLUE*(cp_times_delta_dof_0*tmp_kernel_op_46 + cp_times_delta_dof_1*tmp_kernel_op_40 + cp_times_delta_dof_2*tmp_kernel_op_43 + cp_times_delta_dof_3*tmp_kernel_op_37 + cp_times_delta_dof_4*tmp_kernel_op_44 + cp_times_delta_dof_5*tmp_kernel_op_45)*0.26041666666666669;
             const real_t tmp_kernel_op_64 = tmp_kernel_op_54*ux_dof_3 + tmp_kernel_op_57*ux_dof_1 + tmp_kernel_op_60*ux_dof_2 + tmp_kernel_op_61*ux_dof_4 + tmp_kernel_op_62*ux_dof_5 + tmp_kernel_op_63*ux_dof_0;
             const real_t tmp_kernel_op_65 = tmp_kernel_op_54*uy_dof_3 + tmp_kernel_op_57*uy_dof_1 + tmp_kernel_op_60*uy_dof_2 + tmp_kernel_op_61*uy_dof_4 + tmp_kernel_op_62*uy_dof_5 + tmp_kernel_op_63*uy_dof_0;
             const real_t tmp_kernel_op_66 = tmp_kernel_op_64*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_53 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_53) + tmp_kernel_op_65*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_53 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_53);
             const real_t tmp_kernel_op_67 = abs_det_jac_affine_BLUE*(cp_times_delta_dof_0*tmp_kernel_op_63 + cp_times_delta_dof_1*tmp_kernel_op_57 + cp_times_delta_dof_2*tmp_kernel_op_60 + cp_times_delta_dof_3*tmp_kernel_op_54 + cp_times_delta_dof_4*tmp_kernel_op_61 + cp_times_delta_dof_5*tmp_kernel_op_62)*0.26041666666666669;
             const real_t tmp_kernel_op_69 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_13*tmp_kernel_op_68 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_14*tmp_kernel_op_68;
             const real_t tmp_kernel_op_70 = tmp_kernel_op_15*tmp_kernel_op_16;
             const real_t tmp_kernel_op_72 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_30*tmp_kernel_op_71 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_31*tmp_kernel_op_71;
             const real_t tmp_kernel_op_73 = tmp_kernel_op_32*tmp_kernel_op_33;
             const real_t tmp_kernel_op_75 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_47*tmp_kernel_op_74 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_48*tmp_kernel_op_74;
             const real_t tmp_kernel_op_76 = tmp_kernel_op_49*tmp_kernel_op_50;
             const real_t tmp_kernel_op_78 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_64*tmp_kernel_op_77 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_65*tmp_kernel_op_77;
             const real_t tmp_kernel_op_79 = tmp_kernel_op_66*tmp_kernel_op_67;
             const real_t tmp_kernel_op_80 = tmp_kernel_op_69*tmp_kernel_op_70 + tmp_kernel_op_72*tmp_kernel_op_73 + tmp_kernel_op_75*tmp_kernel_op_76 + tmp_kernel_op_78*tmp_kernel_op_79;
             const real_t tmp_kernel_op_82 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_13*tmp_kernel_op_81 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_14*tmp_kernel_op_81;
             const real_t tmp_kernel_op_84 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_30*tmp_kernel_op_83 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_31*tmp_kernel_op_83;
             const real_t tmp_kernel_op_86 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_47*tmp_kernel_op_85 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_48*tmp_kernel_op_85;
             const real_t tmp_kernel_op_88 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_64*tmp_kernel_op_87 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_65*tmp_kernel_op_87;
             const real_t tmp_kernel_op_89 = tmp_kernel_op_70*tmp_kernel_op_82 + tmp_kernel_op_73*tmp_kernel_op_84 + tmp_kernel_op_76*tmp_kernel_op_86 + tmp_kernel_op_79*tmp_kernel_op_88;
             const real_t tmp_kernel_op_94 = tmp_kernel_op_13*(tmp_moved_constant_0 + tmp_moved_constant_1) + tmp_kernel_op_14*(tmp_moved_constant_2 + tmp_moved_constant_3);
             const real_t tmp_kernel_op_99 = tmp_kernel_op_30*(tmp_moved_constant_4 + tmp_moved_constant_5) + tmp_kernel_op_31*(tmp_moved_constant_6 + tmp_moved_constant_7);
             const real_t tmp_kernel_op_104 = tmp_kernel_op_47*(tmp_moved_constant_8 + tmp_moved_constant_9) + tmp_kernel_op_48*(tmp_moved_constant_10 + tmp_moved_constant_11);
             const real_t tmp_kernel_op_109 = tmp_kernel_op_64*(tmp_moved_constant_12 + tmp_moved_constant_13) + tmp_kernel_op_65*(tmp_moved_constant_14 + tmp_moved_constant_15);
             const real_t tmp_kernel_op_110 = tmp_kernel_op_104*tmp_kernel_op_76 + tmp_kernel_op_109*tmp_kernel_op_79 + tmp_kernel_op_70*tmp_kernel_op_94 + tmp_kernel_op_73*tmp_kernel_op_99;
             const real_t tmp_kernel_op_112 = tmp_kernel_op_13*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_111 - tmp_moved_constant_0) + tmp_kernel_op_14*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_111 - tmp_moved_constant_2);
             const real_t tmp_kernel_op_114 = tmp_kernel_op_30*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_113 - tmp_moved_constant_4) + tmp_kernel_op_31*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_113 - tmp_moved_constant_6);
             const real_t tmp_kernel_op_116 = tmp_kernel_op_47*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_115 - tmp_moved_constant_8) + tmp_kernel_op_48*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_115 - tmp_moved_constant_10);
             const real_t tmp_kernel_op_118 = tmp_kernel_op_64*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_117 - tmp_moved_constant_12) + tmp_kernel_op_65*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_117 - tmp_moved_constant_14);
             const real_t tmp_kernel_op_119 = tmp_kernel_op_112*tmp_kernel_op_70 + tmp_kernel_op_114*tmp_kernel_op_73 + tmp_kernel_op_116*tmp_kernel_op_76 + tmp_kernel_op_118*tmp_kernel_op_79;
             const real_t tmp_kernel_op_121 = tmp_kernel_op_13*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_120 - tmp_moved_constant_1) + tmp_kernel_op_14*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_120 - tmp_moved_constant_3);
             const real_t tmp_kernel_op_123 = tmp_kernel_op_30*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_122 - tmp_moved_constant_5) + tmp_kernel_op_31*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_122 - tmp_moved_constant_7);
             const real_t tmp_kernel_op_125 = tmp_kernel_op_47*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_124 - tmp_moved_constant_9) + tmp_kernel_op_48*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_124 - tmp_moved_constant_11);
             const real_t tmp_kernel_op_127 = tmp_kernel_op_64*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_126 - tmp_moved_constant_13) + tmp_kernel_op_65*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_126 - tmp_moved_constant_15);
             const real_t tmp_kernel_op_128 = tmp_kernel_op_121*tmp_kernel_op_70 + tmp_kernel_op_123*tmp_kernel_op_73 + tmp_kernel_op_125*tmp_kernel_op_76 + tmp_kernel_op_127*tmp_kernel_op_79;
             const real_t tmp_kernel_op_129 = tmp_kernel_op_16*tmp_kernel_op_69;
             const real_t tmp_kernel_op_130 = tmp_kernel_op_33*tmp_kernel_op_72;
             const real_t tmp_kernel_op_131 = tmp_kernel_op_50*tmp_kernel_op_75;
             const real_t tmp_kernel_op_132 = tmp_kernel_op_67*tmp_kernel_op_78;
             const real_t tmp_kernel_op_133 = tmp_kernel_op_129*tmp_kernel_op_82 + tmp_kernel_op_130*tmp_kernel_op_84 + tmp_kernel_op_131*tmp_kernel_op_86 + tmp_kernel_op_132*tmp_kernel_op_88;
             const real_t tmp_kernel_op_134 = tmp_kernel_op_104*tmp_kernel_op_131 + tmp_kernel_op_109*tmp_kernel_op_132 + tmp_kernel_op_129*tmp_kernel_op_94 + tmp_kernel_op_130*tmp_kernel_op_99;
             const real_t tmp_kernel_op_135 = tmp_kernel_op_112*tmp_kernel_op_129 + tmp_kernel_op_114*tmp_kernel_op_130 + tmp_kernel_op_116*tmp_kernel_op_131 + tmp_kernel_op_118*tmp_kernel_op_132;
             const real_t tmp_kernel_op_136 = tmp_kernel_op_121*tmp_kernel_op_129 + tmp_kernel_op_123*tmp_kernel_op_130 + tmp_kernel_op_125*tmp_kernel_op_131 + tmp_kernel_op_127*tmp_kernel_op_132;
             const real_t tmp_kernel_op_137 = tmp_kernel_op_16*tmp_kernel_op_82;
             const real_t tmp_kernel_op_138 = tmp_kernel_op_33*tmp_kernel_op_84;
             const real_t tmp_kernel_op_139 = tmp_kernel_op_50*tmp_kernel_op_86;
             const real_t tmp_kernel_op_140 = tmp_kernel_op_67*tmp_kernel_op_88;
             const real_t tmp_kernel_op_141 = tmp_kernel_op_104*tmp_kernel_op_139 + tmp_kernel_op_109*tmp_kernel_op_140 + tmp_kernel_op_137*tmp_kernel_op_94 + tmp_kernel_op_138*tmp_kernel_op_99;
             const real_t tmp_kernel_op_142 = tmp_kernel_op_112*tmp_kernel_op_137 + tmp_kernel_op_114*tmp_kernel_op_138 + tmp_kernel_op_116*tmp_kernel_op_139 + tmp_kernel_op_118*tmp_kernel_op_140;
             const real_t tmp_kernel_op_143 = tmp_kernel_op_121*tmp_kernel_op_137 + tmp_kernel_op_123*tmp_kernel_op_138 + tmp_kernel_op_125*tmp_kernel_op_139 + tmp_kernel_op_127*tmp_kernel_op_140;
             const real_t tmp_kernel_op_144 = tmp_kernel_op_16*tmp_kernel_op_94;
             const real_t tmp_kernel_op_145 = tmp_kernel_op_33*tmp_kernel_op_99;
             const real_t tmp_kernel_op_146 = tmp_kernel_op_104*tmp_kernel_op_50;
             const real_t tmp_kernel_op_147 = tmp_kernel_op_109*tmp_kernel_op_67;
             const real_t tmp_kernel_op_148 = tmp_kernel_op_112*tmp_kernel_op_144 + tmp_kernel_op_114*tmp_kernel_op_145 + tmp_kernel_op_116*tmp_kernel_op_146 + tmp_kernel_op_118*tmp_kernel_op_147;
             const real_t tmp_kernel_op_149 = tmp_kernel_op_121*tmp_kernel_op_144 + tmp_kernel_op_123*tmp_kernel_op_145 + tmp_kernel_op_125*tmp_kernel_op_146 + tmp_kernel_op_127*tmp_kernel_op_147;
             const real_t tmp_kernel_op_150 = tmp_kernel_op_112*tmp_kernel_op_121*tmp_kernel_op_16 + tmp_kernel_op_114*tmp_kernel_op_123*tmp_kernel_op_33 + tmp_kernel_op_116*tmp_kernel_op_125*tmp_kernel_op_50 + tmp_kernel_op_118*tmp_kernel_op_127*tmp_kernel_op_67;
             const real_t elMat_0_0 = (tmp_kernel_op_15*tmp_kernel_op_15)*tmp_kernel_op_16 + (tmp_kernel_op_32*tmp_kernel_op_32)*tmp_kernel_op_33 + (tmp_kernel_op_49*tmp_kernel_op_49)*tmp_kernel_op_50 + (tmp_kernel_op_66*tmp_kernel_op_66)*tmp_kernel_op_67;
             const real_t elMat_0_1 = tmp_kernel_op_80;
             const real_t elMat_0_2 = tmp_kernel_op_89;
             const real_t elMat_0_3 = tmp_kernel_op_110;
             const real_t elMat_0_4 = tmp_kernel_op_119;
             const real_t elMat_0_5 = tmp_kernel_op_128;
             const real_t elMat_1_0 = tmp_kernel_op_80;
             const real_t elMat_1_1 = tmp_kernel_op_16*(tmp_kernel_op_69*tmp_kernel_op_69) + tmp_kernel_op_33*(tmp_kernel_op_72*tmp_kernel_op_72) + tmp_kernel_op_50*(tmp_kernel_op_75*tmp_kernel_op_75) + tmp_kernel_op_67*(tmp_kernel_op_78*tmp_kernel_op_78);
             const real_t elMat_1_2 = tmp_kernel_op_133;
             const real_t elMat_1_3 = tmp_kernel_op_134;
             const real_t elMat_1_4 = tmp_kernel_op_135;
             const real_t elMat_1_5 = tmp_kernel_op_136;
             const real_t elMat_2_0 = tmp_kernel_op_89;
             const real_t elMat_2_1 = tmp_kernel_op_133;
             const real_t elMat_2_2 = tmp_kernel_op_16*(tmp_kernel_op_82*tmp_kernel_op_82) + tmp_kernel_op_33*(tmp_kernel_op_84*tmp_kernel_op_84) + tmp_kernel_op_50*(tmp_kernel_op_86*tmp_kernel_op_86) + tmp_kernel_op_67*(tmp_kernel_op_88*tmp_kernel_op_88);
             const real_t elMat_2_3 = tmp_kernel_op_141;
             const real_t elMat_2_4 = tmp_kernel_op_142;
             const real_t elMat_2_5 = tmp_kernel_op_143;
             const real_t elMat_3_0 = tmp_kernel_op_110;
             const real_t elMat_3_1 = tmp_kernel_op_134;
             const real_t elMat_3_2 = tmp_kernel_op_141;
             const real_t elMat_3_3 = (tmp_kernel_op_104*tmp_kernel_op_104)*tmp_kernel_op_50 + (tmp_kernel_op_109*tmp_kernel_op_109)*tmp_kernel_op_67 + tmp_kernel_op_16*(tmp_kernel_op_94*tmp_kernel_op_94) + tmp_kernel_op_33*(tmp_kernel_op_99*tmp_kernel_op_99);
             const real_t elMat_3_4 = tmp_kernel_op_148;
             const real_t elMat_3_5 = tmp_kernel_op_149;
             const real_t elMat_4_0 = tmp_kernel_op_119;
             const real_t elMat_4_1 = tmp_kernel_op_135;
             const real_t elMat_4_2 = tmp_kernel_op_142;
             const real_t elMat_4_3 = tmp_kernel_op_148;
             const real_t elMat_4_4 = (tmp_kernel_op_112*tmp_kernel_op_112)*tmp_kernel_op_16 + (tmp_kernel_op_114*tmp_kernel_op_114)*tmp_kernel_op_33 + (tmp_kernel_op_116*tmp_kernel_op_116)*tmp_kernel_op_50 + (tmp_kernel_op_118*tmp_kernel_op_118)*tmp_kernel_op_67;
             const real_t elMat_4_5 = tmp_kernel_op_150;
             const real_t elMat_5_0 = tmp_kernel_op_128;
             const real_t elMat_5_1 = tmp_kernel_op_136;
             const real_t elMat_5_2 = tmp_kernel_op_143;
             const real_t elMat_5_3 = tmp_kernel_op_149;
             const real_t elMat_5_4 = tmp_kernel_op_150;
             const real_t elMat_5_5 = (tmp_kernel_op_121*tmp_kernel_op_121)*tmp_kernel_op_16 + (tmp_kernel_op_123*tmp_kernel_op_123)*tmp_kernel_op_33 + (tmp_kernel_op_125*tmp_kernel_op_125)*tmp_kernel_op_50 + (tmp_kernel_op_127*tmp_kernel_op_127)*tmp_kernel_op_67;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< real_t > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_1_0));
             _data_mat[7] = ((real_t)(elMat_1_1));
             _data_mat[8] = ((real_t)(elMat_1_2));
             _data_mat[9] = ((real_t)(elMat_1_3));
             _data_mat[10] = ((real_t)(elMat_1_4));
             _data_mat[11] = ((real_t)(elMat_1_5));
             _data_mat[12] = ((real_t)(elMat_2_0));
             _data_mat[13] = ((real_t)(elMat_2_1));
             _data_mat[14] = ((real_t)(elMat_2_2));
             _data_mat[15] = ((real_t)(elMat_2_3));
             _data_mat[16] = ((real_t)(elMat_2_4));
             _data_mat[17] = ((real_t)(elMat_2_5));
             _data_mat[18] = ((real_t)(elMat_3_0));
             _data_mat[19] = ((real_t)(elMat_3_1));
             _data_mat[20] = ((real_t)(elMat_3_2));
             _data_mat[21] = ((real_t)(elMat_3_3));
             _data_mat[22] = ((real_t)(elMat_3_4));
             _data_mat[23] = ((real_t)(elMat_3_5));
             _data_mat[24] = ((real_t)(elMat_4_0));
             _data_mat[25] = ((real_t)(elMat_4_1));
             _data_mat[26] = ((real_t)(elMat_4_2));
             _data_mat[27] = ((real_t)(elMat_4_3));
             _data_mat[28] = ((real_t)(elMat_4_4));
             _data_mat[29] = ((real_t)(elMat_4_5));
             _data_mat[30] = ((real_t)(elMat_5_0));
             _data_mat[31] = ((real_t)(elMat_5_1));
             _data_mat[32] = ((real_t)(elMat_5_2));
             _data_mat[33] = ((real_t)(elMat_5_3));
             _data_mat[34] = ((real_t)(elMat_5_4));
             _data_mat[35] = ((real_t)(elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
