/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2ElementwiseSupgDiffusion.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseSupgDiffusion::toMatrix_P2ElementwiseSupgDiffusion_macro_2D( real_t * RESTRICT  _data_diffusivity_times_deltaEdge, real_t * RESTRICT  _data_diffusivity_times_deltaVertex, idx_t * RESTRICT  _data_dstEdge, idx_t * RESTRICT  _data_dstVertex, idx_t * RESTRICT  _data_srcEdge, idx_t * RESTRICT  _data_srcVertex, real_t * RESTRICT  _data_wxEdge, real_t * RESTRICT  _data_wxVertex, real_t * RESTRICT  _data_wyEdge, real_t * RESTRICT  _data_wyVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       const real_t tmp_kernel_op_0 = jac_affine_inv_0_0_GRAY*4.0;
       const real_t tmp_kernel_op_1 = jac_affine_inv_1_0_GRAY*4.0;
       const real_t tmp_kernel_op_2 = tmp_kernel_op_0 + tmp_kernel_op_1;
       const real_t tmp_kernel_op_3 = jac_affine_inv_0_1_GRAY*4.0;
       const real_t tmp_kernel_op_4 = jac_affine_inv_1_1_GRAY*4.0;
       const real_t tmp_kernel_op_5 = tmp_kernel_op_3 + tmp_kernel_op_4;
       const real_t tmp_kernel_op_6 = abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_2 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_5 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_2 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_5);
       const real_t tmp_kernel_op_7 = 1.3333333333333333;
       const real_t tmp_kernel_op_8 = 1.3333333333333333;
       const real_t tmp_kernel_op_9 = tmp_kernel_op_7 + tmp_kernel_op_8 - 3.0;
       const real_t tmp_kernel_op_10 = tmp_kernel_op_7*0.33333333333333331;
       const real_t tmp_kernel_op_11 = 0.1111111111111111;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_11*2.0;
       const real_t tmp_kernel_op_13 = tmp_kernel_op_12 - 0.33333333333333331;
       const real_t tmp_kernel_op_14 = 0.1111111111111111;
       const real_t tmp_kernel_op_15 = tmp_kernel_op_14*2.0;
       const real_t tmp_kernel_op_16 = tmp_kernel_op_15 - 0.33333333333333331;
       const real_t tmp_kernel_op_17 = -tmp_kernel_op_10 + tmp_kernel_op_14*-4.0 + tmp_kernel_op_8;
       const real_t tmp_kernel_op_18 = -tmp_kernel_op_10 + tmp_kernel_op_11*-4.0 + tmp_kernel_op_7;
       const real_t tmp_kernel_op_19 = tmp_kernel_op_10 + tmp_kernel_op_12 + tmp_kernel_op_15 - 1.0;
       const real_t tmp_kernel_op_24 = 0.80000000000000004;
       const real_t tmp_kernel_op_25 = 2.3999999999999999;
       const real_t tmp_kernel_op_26 = tmp_kernel_op_24 + tmp_kernel_op_25 - 3.0;
       const real_t tmp_kernel_op_27 = tmp_kernel_op_24*0.59999999999999998;
       const real_t tmp_kernel_op_28 = 0.040000000000000008;
       const real_t tmp_kernel_op_29 = tmp_kernel_op_28*2.0;
       const real_t tmp_kernel_op_30 = tmp_kernel_op_29 - 0.20000000000000001;
       const real_t tmp_kernel_op_31 = 0.35999999999999999;
       const real_t tmp_kernel_op_32 = tmp_kernel_op_31*2.0;
       const real_t tmp_kernel_op_33 = tmp_kernel_op_32 - 0.59999999999999998;
       const real_t tmp_kernel_op_34 = tmp_kernel_op_25 - tmp_kernel_op_27 + tmp_kernel_op_31*-4.0;
       const real_t tmp_kernel_op_35 = tmp_kernel_op_24 - tmp_kernel_op_27 + tmp_kernel_op_28*-4.0;
       const real_t tmp_kernel_op_36 = tmp_kernel_op_27 + tmp_kernel_op_29 + tmp_kernel_op_32 - 1.3999999999999999;
       const real_t tmp_kernel_op_41 = 2.3999999999999999;
       const real_t tmp_kernel_op_42 = 0.80000000000000004;
       const real_t tmp_kernel_op_43 = tmp_kernel_op_41 + tmp_kernel_op_42 - 3.0;
       const real_t tmp_kernel_op_44 = tmp_kernel_op_41*0.20000000000000001;
       const real_t tmp_kernel_op_45 = 0.35999999999999999;
       const real_t tmp_kernel_op_46 = tmp_kernel_op_45*2.0;
       const real_t tmp_kernel_op_47 = tmp_kernel_op_46 - 0.59999999999999998;
       const real_t tmp_kernel_op_48 = 0.040000000000000008;
       const real_t tmp_kernel_op_49 = tmp_kernel_op_48*2.0;
       const real_t tmp_kernel_op_50 = tmp_kernel_op_49 - 0.20000000000000001;
       const real_t tmp_kernel_op_51 = tmp_kernel_op_42 - tmp_kernel_op_44 + tmp_kernel_op_48*-4.0;
       const real_t tmp_kernel_op_52 = tmp_kernel_op_41 - tmp_kernel_op_44 + tmp_kernel_op_45*-4.0;
       const real_t tmp_kernel_op_53 = tmp_kernel_op_44 + tmp_kernel_op_46 + tmp_kernel_op_49 - 1.3999999999999999;
       const real_t tmp_kernel_op_58 = 0.80000000000000004;
       const real_t tmp_kernel_op_59 = 0.80000000000000004;
       const real_t tmp_kernel_op_60 = tmp_kernel_op_58 + tmp_kernel_op_59 - 3.0;
       const real_t tmp_kernel_op_61 = tmp_kernel_op_58*0.20000000000000001;
       const real_t tmp_kernel_op_62 = 0.040000000000000008;
       const real_t tmp_kernel_op_63 = tmp_kernel_op_62*2.0;
       const real_t tmp_kernel_op_64 = tmp_kernel_op_63 - 0.20000000000000001;
       const real_t tmp_kernel_op_65 = 0.040000000000000008;
       const real_t tmp_kernel_op_66 = tmp_kernel_op_65*2.0;
       const real_t tmp_kernel_op_67 = tmp_kernel_op_66 - 0.20000000000000001;
       const real_t tmp_kernel_op_68 = tmp_kernel_op_59 - tmp_kernel_op_61 + tmp_kernel_op_65*-4.0;
       const real_t tmp_kernel_op_69 = tmp_kernel_op_58 - tmp_kernel_op_61 + tmp_kernel_op_62*-4.0;
       const real_t tmp_kernel_op_70 = tmp_kernel_op_61 + tmp_kernel_op_63 + tmp_kernel_op_66 - 0.20000000000000018;
       const real_t tmp_kernel_op_75 = abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*4.0 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*4.0);
       const real_t tmp_kernel_op_76 = abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*4.0 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*4.0);
       const real_t tmp_kernel_op_77 = jac_affine_inv_1_0_GRAY*8.0;
       const real_t tmp_kernel_op_78 = jac_affine_inv_1_1_GRAY*8.0;
       const real_t tmp_kernel_op_79 = abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_77 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_78);
       const real_t tmp_kernel_op_80 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_0 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_3;
       const real_t tmp_kernel_op_81 = abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(-tmp_kernel_op_0 - tmp_kernel_op_77) + jac_affine_inv_1_1_GRAY*(-tmp_kernel_op_3 - tmp_kernel_op_78) - tmp_kernel_op_80);
       const real_t tmp_kernel_op_82 = abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-8.0 - tmp_kernel_op_1) + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-8.0 - tmp_kernel_op_4) - tmp_kernel_op_80);
       const real_t tmp_kernel_op_83 = tmp_kernel_op_7 - 1.0;
       const real_t tmp_kernel_op_85 = tmp_kernel_op_24 - 1.0;
       const real_t tmp_kernel_op_87 = tmp_kernel_op_41 - 1.0;
       const real_t tmp_kernel_op_89 = tmp_kernel_op_58 - 1.0;
       const real_t tmp_kernel_op_91 = tmp_kernel_op_8 - 1.0;
       const real_t tmp_kernel_op_93 = tmp_kernel_op_25 - 1.0;
       const real_t tmp_kernel_op_95 = tmp_kernel_op_42 - 1.0;
       const real_t tmp_kernel_op_97 = tmp_kernel_op_59 - 1.0;
       const real_t tmp_kernel_op_99 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_8;
       const real_t tmp_kernel_op_100 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_7;
       const real_t tmp_kernel_op_101 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_8;
       const real_t tmp_kernel_op_102 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_7;
       const real_t tmp_kernel_op_104 = tmp_kernel_op_0*0.59999999999999998;
       const real_t tmp_kernel_op_105 = tmp_kernel_op_1*0.20000000000000001;
       const real_t tmp_kernel_op_106 = tmp_kernel_op_3*0.59999999999999998;
       const real_t tmp_kernel_op_107 = tmp_kernel_op_4*0.20000000000000001;
       const real_t tmp_kernel_op_109 = tmp_kernel_op_0*0.20000000000000001;
       const real_t tmp_kernel_op_110 = tmp_kernel_op_1*0.59999999999999998;
       const real_t tmp_kernel_op_111 = tmp_kernel_op_3*0.20000000000000001;
       const real_t tmp_kernel_op_112 = tmp_kernel_op_4*0.59999999999999998;
       const real_t tmp_kernel_op_114 = tmp_kernel_op_0*0.20000000000000001;
       const real_t tmp_kernel_op_115 = tmp_kernel_op_1*0.20000000000000001;
       const real_t tmp_kernel_op_116 = tmp_kernel_op_3*0.20000000000000001;
       const real_t tmp_kernel_op_117 = tmp_kernel_op_4*0.20000000000000001;
       const real_t tmp_kernel_op_119 = -tmp_kernel_op_7 + 1.3333333333333335;
       const real_t tmp_kernel_op_121 = -tmp_kernel_op_24 - 0.79999999999999982;
       const real_t tmp_kernel_op_123 = -tmp_kernel_op_41 + 2.3999999999999999;
       const real_t tmp_kernel_op_125 = -tmp_kernel_op_58 + 2.3999999999999999;
       const real_t tmp_kernel_op_127 = -tmp_kernel_op_8 + 1.3333333333333335;
       const real_t tmp_kernel_op_129 = -tmp_kernel_op_25 + 2.3999999999999999;
       const real_t tmp_kernel_op_131 = -tmp_kernel_op_42 - 0.79999999999999982;
       const real_t tmp_kernel_op_133 = -tmp_kernel_op_59 + 2.3999999999999999;
       {
          /* FaceType.GRAY */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t diffusivity_times_delta_dof_0 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t diffusivity_times_delta_dof_1 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t diffusivity_times_delta_dof_2 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t diffusivity_times_delta_dof_3 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t diffusivity_times_delta_dof_4 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t diffusivity_times_delta_dof_5 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t wx_dof_0 = _data_wxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t wx_dof_1 = _data_wxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t wx_dof_2 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t wx_dof_3 = _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t wx_dof_4 = _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t wx_dof_5 = _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t wy_dof_0 = _data_wyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t wy_dof_1 = _data_wyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t wy_dof_2 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t wy_dof_3 = _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t wy_dof_4 = _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t wy_dof_5 = _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t tmp_kernel_op_20 = tmp_kernel_op_10*wx_dof_3 + tmp_kernel_op_13*wx_dof_1 + tmp_kernel_op_16*wx_dof_2 + tmp_kernel_op_17*wx_dof_4 + tmp_kernel_op_18*wx_dof_5 + tmp_kernel_op_19*wx_dof_0;
             const real_t tmp_kernel_op_21 = tmp_kernel_op_10*wy_dof_3 + tmp_kernel_op_13*wy_dof_1 + tmp_kernel_op_16*wy_dof_2 + tmp_kernel_op_17*wy_dof_4 + tmp_kernel_op_18*wy_dof_5 + tmp_kernel_op_19*wy_dof_0;
             const real_t tmp_kernel_op_22 = diffusivity_times_delta_dof_0*tmp_kernel_op_19*-0.28125 + diffusivity_times_delta_dof_1*tmp_kernel_op_13*-0.28125 + diffusivity_times_delta_dof_2*tmp_kernel_op_16*-0.28125 + diffusivity_times_delta_dof_3*tmp_kernel_op_10*-0.28125 + diffusivity_times_delta_dof_4*tmp_kernel_op_17*-0.28125 + diffusivity_times_delta_dof_5*tmp_kernel_op_18*-0.28125;
             const real_t tmp_kernel_op_23 = tmp_kernel_op_22*(tmp_kernel_op_20*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_9 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_9) + tmp_kernel_op_21*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_9 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_9));
             const real_t tmp_kernel_op_37 = tmp_kernel_op_27*wx_dof_3 + tmp_kernel_op_30*wx_dof_1 + tmp_kernel_op_33*wx_dof_2 + tmp_kernel_op_34*wx_dof_4 + tmp_kernel_op_35*wx_dof_5 + tmp_kernel_op_36*wx_dof_0;
             const real_t tmp_kernel_op_38 = tmp_kernel_op_27*wy_dof_3 + tmp_kernel_op_30*wy_dof_1 + tmp_kernel_op_33*wy_dof_2 + tmp_kernel_op_34*wy_dof_4 + tmp_kernel_op_35*wy_dof_5 + tmp_kernel_op_36*wy_dof_0;
             const real_t tmp_kernel_op_39 = diffusivity_times_delta_dof_0*tmp_kernel_op_36*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_30*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_33*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_27*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_34*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_35*0.26041666666666669;
             const real_t tmp_kernel_op_40 = tmp_kernel_op_39*(tmp_kernel_op_37*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_26 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_26) + tmp_kernel_op_38*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_26 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_26));
             const real_t tmp_kernel_op_54 = tmp_kernel_op_44*wx_dof_3 + tmp_kernel_op_47*wx_dof_1 + tmp_kernel_op_50*wx_dof_2 + tmp_kernel_op_51*wx_dof_4 + tmp_kernel_op_52*wx_dof_5 + tmp_kernel_op_53*wx_dof_0;
             const real_t tmp_kernel_op_55 = tmp_kernel_op_44*wy_dof_3 + tmp_kernel_op_47*wy_dof_1 + tmp_kernel_op_50*wy_dof_2 + tmp_kernel_op_51*wy_dof_4 + tmp_kernel_op_52*wy_dof_5 + tmp_kernel_op_53*wy_dof_0;
             const real_t tmp_kernel_op_56 = diffusivity_times_delta_dof_0*tmp_kernel_op_53*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_47*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_50*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_44*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_51*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_52*0.26041666666666669;
             const real_t tmp_kernel_op_57 = tmp_kernel_op_56*(tmp_kernel_op_54*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_43 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_43) + tmp_kernel_op_55*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_43 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_43));
             const real_t tmp_kernel_op_71 = tmp_kernel_op_61*wx_dof_3 + tmp_kernel_op_64*wx_dof_1 + tmp_kernel_op_67*wx_dof_2 + tmp_kernel_op_68*wx_dof_4 + tmp_kernel_op_69*wx_dof_5 + tmp_kernel_op_70*wx_dof_0;
             const real_t tmp_kernel_op_72 = tmp_kernel_op_61*wy_dof_3 + tmp_kernel_op_64*wy_dof_1 + tmp_kernel_op_67*wy_dof_2 + tmp_kernel_op_68*wy_dof_4 + tmp_kernel_op_69*wy_dof_5 + tmp_kernel_op_70*wy_dof_0;
             const real_t tmp_kernel_op_73 = diffusivity_times_delta_dof_0*tmp_kernel_op_70*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_64*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_67*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_61*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_68*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_69*0.26041666666666669;
             const real_t tmp_kernel_op_74 = tmp_kernel_op_73*(tmp_kernel_op_71*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_60 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_60) + tmp_kernel_op_72*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_60 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_60));
             const real_t tmp_kernel_op_84 = tmp_kernel_op_22*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_20*tmp_kernel_op_83 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_21*tmp_kernel_op_83);
             const real_t tmp_kernel_op_86 = tmp_kernel_op_39*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_37*tmp_kernel_op_85 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_38*tmp_kernel_op_85);
             const real_t tmp_kernel_op_88 = tmp_kernel_op_56*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_54*tmp_kernel_op_87 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_55*tmp_kernel_op_87);
             const real_t tmp_kernel_op_90 = tmp_kernel_op_73*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_71*tmp_kernel_op_89 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_72*tmp_kernel_op_89);
             const real_t tmp_kernel_op_92 = tmp_kernel_op_22*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_20*tmp_kernel_op_91 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_21*tmp_kernel_op_91);
             const real_t tmp_kernel_op_94 = tmp_kernel_op_39*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_37*tmp_kernel_op_93 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_38*tmp_kernel_op_93);
             const real_t tmp_kernel_op_96 = tmp_kernel_op_56*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_54*tmp_kernel_op_95 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_55*tmp_kernel_op_95);
             const real_t tmp_kernel_op_98 = tmp_kernel_op_73*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_71*tmp_kernel_op_97 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_72*tmp_kernel_op_97);
             const real_t tmp_kernel_op_103 = tmp_kernel_op_22*(tmp_kernel_op_20*(tmp_kernel_op_100 + tmp_kernel_op_99) + tmp_kernel_op_21*(tmp_kernel_op_101 + tmp_kernel_op_102));
             const real_t tmp_kernel_op_108 = tmp_kernel_op_39*(tmp_kernel_op_37*(tmp_kernel_op_104 + tmp_kernel_op_105) + tmp_kernel_op_38*(tmp_kernel_op_106 + tmp_kernel_op_107));
             const real_t tmp_kernel_op_113 = tmp_kernel_op_56*(tmp_kernel_op_54*(tmp_kernel_op_109 + tmp_kernel_op_110) + tmp_kernel_op_55*(tmp_kernel_op_111 + tmp_kernel_op_112));
             const real_t tmp_kernel_op_118 = tmp_kernel_op_73*(tmp_kernel_op_71*(tmp_kernel_op_114 + tmp_kernel_op_115) + tmp_kernel_op_72*(tmp_kernel_op_116 + tmp_kernel_op_117));
             const real_t tmp_kernel_op_120 = tmp_kernel_op_22*(tmp_kernel_op_20*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_119 - tmp_kernel_op_99) + tmp_kernel_op_21*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_119 - tmp_kernel_op_101));
             const real_t tmp_kernel_op_122 = tmp_kernel_op_39*(tmp_kernel_op_37*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_121 - tmp_kernel_op_104) + tmp_kernel_op_38*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_121 - tmp_kernel_op_106));
             const real_t tmp_kernel_op_124 = tmp_kernel_op_56*(tmp_kernel_op_54*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_123 - tmp_kernel_op_109) + tmp_kernel_op_55*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_123 - tmp_kernel_op_111));
             const real_t tmp_kernel_op_126 = tmp_kernel_op_73*(tmp_kernel_op_71*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_125 - tmp_kernel_op_114) + tmp_kernel_op_72*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_125 - tmp_kernel_op_116));
             const real_t tmp_kernel_op_128 = tmp_kernel_op_22*(tmp_kernel_op_20*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_127 - tmp_kernel_op_100) + tmp_kernel_op_21*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_127 - tmp_kernel_op_102));
             const real_t tmp_kernel_op_130 = tmp_kernel_op_39*(tmp_kernel_op_37*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_129 - tmp_kernel_op_105) + tmp_kernel_op_38*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_129 - tmp_kernel_op_107));
             const real_t tmp_kernel_op_132 = tmp_kernel_op_56*(tmp_kernel_op_54*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_131 - tmp_kernel_op_110) + tmp_kernel_op_55*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_131 - tmp_kernel_op_112));
             const real_t tmp_kernel_op_134 = tmp_kernel_op_73*(tmp_kernel_op_71*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_133 - tmp_kernel_op_115) + tmp_kernel_op_72*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_133 - tmp_kernel_op_117));
             const real_t elMat_0_0 = tmp_kernel_op_23*tmp_kernel_op_6 + tmp_kernel_op_40*tmp_kernel_op_6 + tmp_kernel_op_57*tmp_kernel_op_6 + tmp_kernel_op_6*tmp_kernel_op_74;
             const real_t elMat_0_1 = tmp_kernel_op_23*tmp_kernel_op_75 + tmp_kernel_op_40*tmp_kernel_op_75 + tmp_kernel_op_57*tmp_kernel_op_75 + tmp_kernel_op_74*tmp_kernel_op_75;
             const real_t elMat_0_2 = tmp_kernel_op_23*tmp_kernel_op_76 + tmp_kernel_op_40*tmp_kernel_op_76 + tmp_kernel_op_57*tmp_kernel_op_76 + tmp_kernel_op_74*tmp_kernel_op_76;
             const real_t elMat_0_3 = tmp_kernel_op_23*tmp_kernel_op_79 + tmp_kernel_op_40*tmp_kernel_op_79 + tmp_kernel_op_57*tmp_kernel_op_79 + tmp_kernel_op_74*tmp_kernel_op_79;
             const real_t elMat_0_4 = tmp_kernel_op_23*tmp_kernel_op_81 + tmp_kernel_op_40*tmp_kernel_op_81 + tmp_kernel_op_57*tmp_kernel_op_81 + tmp_kernel_op_74*tmp_kernel_op_81;
             const real_t elMat_0_5 = tmp_kernel_op_23*tmp_kernel_op_82 + tmp_kernel_op_40*tmp_kernel_op_82 + tmp_kernel_op_57*tmp_kernel_op_82 + tmp_kernel_op_74*tmp_kernel_op_82;
             const real_t elMat_1_0 = tmp_kernel_op_6*tmp_kernel_op_84 + tmp_kernel_op_6*tmp_kernel_op_86 + tmp_kernel_op_6*tmp_kernel_op_88 + tmp_kernel_op_6*tmp_kernel_op_90;
             const real_t elMat_1_1 = tmp_kernel_op_75*tmp_kernel_op_84 + tmp_kernel_op_75*tmp_kernel_op_86 + tmp_kernel_op_75*tmp_kernel_op_88 + tmp_kernel_op_75*tmp_kernel_op_90;
             const real_t elMat_1_2 = tmp_kernel_op_76*tmp_kernel_op_84 + tmp_kernel_op_76*tmp_kernel_op_86 + tmp_kernel_op_76*tmp_kernel_op_88 + tmp_kernel_op_76*tmp_kernel_op_90;
             const real_t elMat_1_3 = tmp_kernel_op_79*tmp_kernel_op_84 + tmp_kernel_op_79*tmp_kernel_op_86 + tmp_kernel_op_79*tmp_kernel_op_88 + tmp_kernel_op_79*tmp_kernel_op_90;
             const real_t elMat_1_4 = tmp_kernel_op_81*tmp_kernel_op_84 + tmp_kernel_op_81*tmp_kernel_op_86 + tmp_kernel_op_81*tmp_kernel_op_88 + tmp_kernel_op_81*tmp_kernel_op_90;
             const real_t elMat_1_5 = tmp_kernel_op_82*tmp_kernel_op_84 + tmp_kernel_op_82*tmp_kernel_op_86 + tmp_kernel_op_82*tmp_kernel_op_88 + tmp_kernel_op_82*tmp_kernel_op_90;
             const real_t elMat_2_0 = tmp_kernel_op_6*tmp_kernel_op_92 + tmp_kernel_op_6*tmp_kernel_op_94 + tmp_kernel_op_6*tmp_kernel_op_96 + tmp_kernel_op_6*tmp_kernel_op_98;
             const real_t elMat_2_1 = tmp_kernel_op_75*tmp_kernel_op_92 + tmp_kernel_op_75*tmp_kernel_op_94 + tmp_kernel_op_75*tmp_kernel_op_96 + tmp_kernel_op_75*tmp_kernel_op_98;
             const real_t elMat_2_2 = tmp_kernel_op_76*tmp_kernel_op_92 + tmp_kernel_op_76*tmp_kernel_op_94 + tmp_kernel_op_76*tmp_kernel_op_96 + tmp_kernel_op_76*tmp_kernel_op_98;
             const real_t elMat_2_3 = tmp_kernel_op_79*tmp_kernel_op_92 + tmp_kernel_op_79*tmp_kernel_op_94 + tmp_kernel_op_79*tmp_kernel_op_96 + tmp_kernel_op_79*tmp_kernel_op_98;
             const real_t elMat_2_4 = tmp_kernel_op_81*tmp_kernel_op_92 + tmp_kernel_op_81*tmp_kernel_op_94 + tmp_kernel_op_81*tmp_kernel_op_96 + tmp_kernel_op_81*tmp_kernel_op_98;
             const real_t elMat_2_5 = tmp_kernel_op_82*tmp_kernel_op_92 + tmp_kernel_op_82*tmp_kernel_op_94 + tmp_kernel_op_82*tmp_kernel_op_96 + tmp_kernel_op_82*tmp_kernel_op_98;
             const real_t elMat_3_0 = tmp_kernel_op_103*tmp_kernel_op_6 + tmp_kernel_op_108*tmp_kernel_op_6 + tmp_kernel_op_113*tmp_kernel_op_6 + tmp_kernel_op_118*tmp_kernel_op_6;
             const real_t elMat_3_1 = tmp_kernel_op_103*tmp_kernel_op_75 + tmp_kernel_op_108*tmp_kernel_op_75 + tmp_kernel_op_113*tmp_kernel_op_75 + tmp_kernel_op_118*tmp_kernel_op_75;
             const real_t elMat_3_2 = tmp_kernel_op_103*tmp_kernel_op_76 + tmp_kernel_op_108*tmp_kernel_op_76 + tmp_kernel_op_113*tmp_kernel_op_76 + tmp_kernel_op_118*tmp_kernel_op_76;
             const real_t elMat_3_3 = tmp_kernel_op_103*tmp_kernel_op_79 + tmp_kernel_op_108*tmp_kernel_op_79 + tmp_kernel_op_113*tmp_kernel_op_79 + tmp_kernel_op_118*tmp_kernel_op_79;
             const real_t elMat_3_4 = tmp_kernel_op_103*tmp_kernel_op_81 + tmp_kernel_op_108*tmp_kernel_op_81 + tmp_kernel_op_113*tmp_kernel_op_81 + tmp_kernel_op_118*tmp_kernel_op_81;
             const real_t elMat_3_5 = tmp_kernel_op_103*tmp_kernel_op_82 + tmp_kernel_op_108*tmp_kernel_op_82 + tmp_kernel_op_113*tmp_kernel_op_82 + tmp_kernel_op_118*tmp_kernel_op_82;
             const real_t elMat_4_0 = tmp_kernel_op_120*tmp_kernel_op_6 + tmp_kernel_op_122*tmp_kernel_op_6 + tmp_kernel_op_124*tmp_kernel_op_6 + tmp_kernel_op_126*tmp_kernel_op_6;
             const real_t elMat_4_1 = tmp_kernel_op_120*tmp_kernel_op_75 + tmp_kernel_op_122*tmp_kernel_op_75 + tmp_kernel_op_124*tmp_kernel_op_75 + tmp_kernel_op_126*tmp_kernel_op_75;
             const real_t elMat_4_2 = tmp_kernel_op_120*tmp_kernel_op_76 + tmp_kernel_op_122*tmp_kernel_op_76 + tmp_kernel_op_124*tmp_kernel_op_76 + tmp_kernel_op_126*tmp_kernel_op_76;
             const real_t elMat_4_3 = tmp_kernel_op_120*tmp_kernel_op_79 + tmp_kernel_op_122*tmp_kernel_op_79 + tmp_kernel_op_124*tmp_kernel_op_79 + tmp_kernel_op_126*tmp_kernel_op_79;
             const real_t elMat_4_4 = tmp_kernel_op_120*tmp_kernel_op_81 + tmp_kernel_op_122*tmp_kernel_op_81 + tmp_kernel_op_124*tmp_kernel_op_81 + tmp_kernel_op_126*tmp_kernel_op_81;
             const real_t elMat_4_5 = tmp_kernel_op_120*tmp_kernel_op_82 + tmp_kernel_op_122*tmp_kernel_op_82 + tmp_kernel_op_124*tmp_kernel_op_82 + tmp_kernel_op_126*tmp_kernel_op_82;
             const real_t elMat_5_0 = tmp_kernel_op_128*tmp_kernel_op_6 + tmp_kernel_op_130*tmp_kernel_op_6 + tmp_kernel_op_132*tmp_kernel_op_6 + tmp_kernel_op_134*tmp_kernel_op_6;
             const real_t elMat_5_1 = tmp_kernel_op_128*tmp_kernel_op_75 + tmp_kernel_op_130*tmp_kernel_op_75 + tmp_kernel_op_132*tmp_kernel_op_75 + tmp_kernel_op_134*tmp_kernel_op_75;
             const real_t elMat_5_2 = tmp_kernel_op_128*tmp_kernel_op_76 + tmp_kernel_op_130*tmp_kernel_op_76 + tmp_kernel_op_132*tmp_kernel_op_76 + tmp_kernel_op_134*tmp_kernel_op_76;
             const real_t elMat_5_3 = tmp_kernel_op_128*tmp_kernel_op_79 + tmp_kernel_op_130*tmp_kernel_op_79 + tmp_kernel_op_132*tmp_kernel_op_79 + tmp_kernel_op_134*tmp_kernel_op_79;
             const real_t elMat_5_4 = tmp_kernel_op_128*tmp_kernel_op_81 + tmp_kernel_op_130*tmp_kernel_op_81 + tmp_kernel_op_132*tmp_kernel_op_81 + tmp_kernel_op_134*tmp_kernel_op_81;
             const real_t elMat_5_5 = tmp_kernel_op_128*tmp_kernel_op_82 + tmp_kernel_op_130*tmp_kernel_op_82 + tmp_kernel_op_132*tmp_kernel_op_82 + tmp_kernel_op_134*tmp_kernel_op_82;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< real_t > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[3] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_1_0));
             _data_mat[7] = ((real_t)(elMat_1_1));
             _data_mat[8] = ((real_t)(elMat_1_2));
             _data_mat[9] = ((real_t)(elMat_1_3));
             _data_mat[10] = ((real_t)(elMat_1_4));
             _data_mat[11] = ((real_t)(elMat_1_5));
             _data_mat[12] = ((real_t)(elMat_2_0));
             _data_mat[13] = ((real_t)(elMat_2_1));
             _data_mat[14] = ((real_t)(elMat_2_2));
             _data_mat[15] = ((real_t)(elMat_2_3));
             _data_mat[16] = ((real_t)(elMat_2_4));
             _data_mat[17] = ((real_t)(elMat_2_5));
             _data_mat[18] = ((real_t)(elMat_3_0));
             _data_mat[19] = ((real_t)(elMat_3_1));
             _data_mat[20] = ((real_t)(elMat_3_2));
             _data_mat[21] = ((real_t)(elMat_3_3));
             _data_mat[22] = ((real_t)(elMat_3_4));
             _data_mat[23] = ((real_t)(elMat_3_5));
             _data_mat[24] = ((real_t)(elMat_4_0));
             _data_mat[25] = ((real_t)(elMat_4_1));
             _data_mat[26] = ((real_t)(elMat_4_2));
             _data_mat[27] = ((real_t)(elMat_4_3));
             _data_mat[28] = ((real_t)(elMat_4_4));
             _data_mat[29] = ((real_t)(elMat_4_5));
             _data_mat[30] = ((real_t)(elMat_5_0));
             _data_mat[31] = ((real_t)(elMat_5_1));
             _data_mat[32] = ((real_t)(elMat_5_2));
             _data_mat[33] = ((real_t)(elMat_5_3));
             _data_mat[34] = ((real_t)(elMat_5_4));
             _data_mat[35] = ((real_t)(elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       const real_t tmp_moved_constant_0 = jac_affine_inv_0_0_BLUE*4.0;
       const real_t tmp_moved_constant_1 = jac_affine_inv_1_0_BLUE*4.0;
       const real_t tmp_moved_constant_2 = tmp_moved_constant_0 + tmp_moved_constant_1;
       const real_t tmp_moved_constant_3 = jac_affine_inv_0_1_BLUE*4.0;
       const real_t tmp_moved_constant_4 = jac_affine_inv_1_1_BLUE*4.0;
       const real_t tmp_moved_constant_5 = tmp_moved_constant_3 + tmp_moved_constant_4;
       const real_t tmp_moved_constant_6 = abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*tmp_moved_constant_2 + jac_affine_inv_0_1_BLUE*tmp_moved_constant_5 + jac_affine_inv_1_0_BLUE*tmp_moved_constant_2 + jac_affine_inv_1_1_BLUE*tmp_moved_constant_5);
       const real_t tmp_moved_constant_7 = abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*4.0 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*4.0);
       const real_t tmp_moved_constant_8 = abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*4.0 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*4.0);
       const real_t tmp_moved_constant_9 = jac_affine_inv_1_0_BLUE*8.0;
       const real_t tmp_moved_constant_10 = jac_affine_inv_1_1_BLUE*8.0;
       const real_t tmp_moved_constant_11 = abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*tmp_moved_constant_9 + jac_affine_inv_0_1_BLUE*tmp_moved_constant_10);
       const real_t tmp_moved_constant_12 = jac_affine_inv_1_0_BLUE*tmp_moved_constant_0 + jac_affine_inv_1_1_BLUE*tmp_moved_constant_3;
       const real_t tmp_moved_constant_13 = abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(-tmp_moved_constant_0 - tmp_moved_constant_9) + jac_affine_inv_1_1_BLUE*(-tmp_moved_constant_10 - tmp_moved_constant_3) - tmp_moved_constant_12);
       const real_t tmp_moved_constant_14 = abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-8.0 - tmp_moved_constant_1) + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-8.0 - tmp_moved_constant_4) - tmp_moved_constant_12);
       const real_t tmp_moved_constant_15 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_8;
       const real_t tmp_moved_constant_16 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_7;
       const real_t tmp_moved_constant_17 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_8;
       const real_t tmp_moved_constant_18 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_7;
       const real_t tmp_moved_constant_19 = tmp_moved_constant_0*0.59999999999999998;
       const real_t tmp_moved_constant_20 = tmp_moved_constant_1*0.20000000000000001;
       const real_t tmp_moved_constant_21 = tmp_moved_constant_3*0.59999999999999998;
       const real_t tmp_moved_constant_22 = tmp_moved_constant_4*0.20000000000000001;
       const real_t tmp_moved_constant_23 = tmp_moved_constant_0*0.20000000000000001;
       const real_t tmp_moved_constant_24 = tmp_moved_constant_1*0.59999999999999998;
       const real_t tmp_moved_constant_25 = tmp_moved_constant_3*0.20000000000000001;
       const real_t tmp_moved_constant_26 = tmp_moved_constant_4*0.59999999999999998;
       const real_t tmp_moved_constant_27 = tmp_moved_constant_0*0.20000000000000001;
       const real_t tmp_moved_constant_28 = tmp_moved_constant_1*0.20000000000000001;
       const real_t tmp_moved_constant_29 = tmp_moved_constant_3*0.20000000000000001;
       const real_t tmp_moved_constant_30 = tmp_moved_constant_4*0.20000000000000001;
       {
          /* FaceType.BLUE */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t diffusivity_times_delta_dof_0 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t diffusivity_times_delta_dof_1 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t diffusivity_times_delta_dof_2 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t diffusivity_times_delta_dof_3 = _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t diffusivity_times_delta_dof_4 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t diffusivity_times_delta_dof_5 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t wx_dof_0 = _data_wxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t wx_dof_1 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t wx_dof_2 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t wx_dof_3 = _data_wxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t wx_dof_4 = _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t wx_dof_5 = _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t wy_dof_0 = _data_wyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t wy_dof_1 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t wy_dof_2 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t wy_dof_3 = _data_wyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t wy_dof_4 = _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t wy_dof_5 = _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t tmp_kernel_op_20 = tmp_kernel_op_10*wx_dof_3 + tmp_kernel_op_13*wx_dof_1 + tmp_kernel_op_16*wx_dof_2 + tmp_kernel_op_17*wx_dof_4 + tmp_kernel_op_18*wx_dof_5 + tmp_kernel_op_19*wx_dof_0;
             const real_t tmp_kernel_op_21 = tmp_kernel_op_10*wy_dof_3 + tmp_kernel_op_13*wy_dof_1 + tmp_kernel_op_16*wy_dof_2 + tmp_kernel_op_17*wy_dof_4 + tmp_kernel_op_18*wy_dof_5 + tmp_kernel_op_19*wy_dof_0;
             const real_t tmp_kernel_op_22 = diffusivity_times_delta_dof_0*tmp_kernel_op_19*-0.28125 + diffusivity_times_delta_dof_1*tmp_kernel_op_13*-0.28125 + diffusivity_times_delta_dof_2*tmp_kernel_op_16*-0.28125 + diffusivity_times_delta_dof_3*tmp_kernel_op_10*-0.28125 + diffusivity_times_delta_dof_4*tmp_kernel_op_17*-0.28125 + diffusivity_times_delta_dof_5*tmp_kernel_op_18*-0.28125;
             const real_t tmp_kernel_op_23 = tmp_kernel_op_22*(tmp_kernel_op_20*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_9 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_9) + tmp_kernel_op_21*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_9 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_9));
             const real_t tmp_kernel_op_37 = tmp_kernel_op_27*wx_dof_3 + tmp_kernel_op_30*wx_dof_1 + tmp_kernel_op_33*wx_dof_2 + tmp_kernel_op_34*wx_dof_4 + tmp_kernel_op_35*wx_dof_5 + tmp_kernel_op_36*wx_dof_0;
             const real_t tmp_kernel_op_38 = tmp_kernel_op_27*wy_dof_3 + tmp_kernel_op_30*wy_dof_1 + tmp_kernel_op_33*wy_dof_2 + tmp_kernel_op_34*wy_dof_4 + tmp_kernel_op_35*wy_dof_5 + tmp_kernel_op_36*wy_dof_0;
             const real_t tmp_kernel_op_39 = diffusivity_times_delta_dof_0*tmp_kernel_op_36*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_30*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_33*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_27*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_34*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_35*0.26041666666666669;
             const real_t tmp_kernel_op_40 = tmp_kernel_op_39*(tmp_kernel_op_37*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_26 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_26) + tmp_kernel_op_38*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_26 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_26));
             const real_t tmp_kernel_op_54 = tmp_kernel_op_44*wx_dof_3 + tmp_kernel_op_47*wx_dof_1 + tmp_kernel_op_50*wx_dof_2 + tmp_kernel_op_51*wx_dof_4 + tmp_kernel_op_52*wx_dof_5 + tmp_kernel_op_53*wx_dof_0;
             const real_t tmp_kernel_op_55 = tmp_kernel_op_44*wy_dof_3 + tmp_kernel_op_47*wy_dof_1 + tmp_kernel_op_50*wy_dof_2 + tmp_kernel_op_51*wy_dof_4 + tmp_kernel_op_52*wy_dof_5 + tmp_kernel_op_53*wy_dof_0;
             const real_t tmp_kernel_op_56 = diffusivity_times_delta_dof_0*tmp_kernel_op_53*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_47*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_50*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_44*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_51*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_52*0.26041666666666669;
             const real_t tmp_kernel_op_57 = tmp_kernel_op_56*(tmp_kernel_op_54*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_43 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_43) + tmp_kernel_op_55*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_43 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_43));
             const real_t tmp_kernel_op_71 = tmp_kernel_op_61*wx_dof_3 + tmp_kernel_op_64*wx_dof_1 + tmp_kernel_op_67*wx_dof_2 + tmp_kernel_op_68*wx_dof_4 + tmp_kernel_op_69*wx_dof_5 + tmp_kernel_op_70*wx_dof_0;
             const real_t tmp_kernel_op_72 = tmp_kernel_op_61*wy_dof_3 + tmp_kernel_op_64*wy_dof_1 + tmp_kernel_op_67*wy_dof_2 + tmp_kernel_op_68*wy_dof_4 + tmp_kernel_op_69*wy_dof_5 + tmp_kernel_op_70*wy_dof_0;
             const real_t tmp_kernel_op_73 = diffusivity_times_delta_dof_0*tmp_kernel_op_70*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_64*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_67*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_61*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_68*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_69*0.26041666666666669;
             const real_t tmp_kernel_op_74 = tmp_kernel_op_73*(tmp_kernel_op_71*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_60 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_60) + tmp_kernel_op_72*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_60 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_60));
             const real_t tmp_kernel_op_84 = tmp_kernel_op_22*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_20*tmp_kernel_op_83 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_21*tmp_kernel_op_83);
             const real_t tmp_kernel_op_86 = tmp_kernel_op_39*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_37*tmp_kernel_op_85 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_38*tmp_kernel_op_85);
             const real_t tmp_kernel_op_88 = tmp_kernel_op_56*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_54*tmp_kernel_op_87 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_55*tmp_kernel_op_87);
             const real_t tmp_kernel_op_90 = tmp_kernel_op_73*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_71*tmp_kernel_op_89 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_72*tmp_kernel_op_89);
             const real_t tmp_kernel_op_92 = tmp_kernel_op_22*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_20*tmp_kernel_op_91 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_21*tmp_kernel_op_91);
             const real_t tmp_kernel_op_94 = tmp_kernel_op_39*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_37*tmp_kernel_op_93 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_38*tmp_kernel_op_93);
             const real_t tmp_kernel_op_96 = tmp_kernel_op_56*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_54*tmp_kernel_op_95 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_55*tmp_kernel_op_95);
             const real_t tmp_kernel_op_98 = tmp_kernel_op_73*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_71*tmp_kernel_op_97 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_72*tmp_kernel_op_97);
             const real_t tmp_kernel_op_103 = tmp_kernel_op_22*(tmp_kernel_op_20*(tmp_moved_constant_15 + tmp_moved_constant_16) + tmp_kernel_op_21*(tmp_moved_constant_17 + tmp_moved_constant_18));
             const real_t tmp_kernel_op_108 = tmp_kernel_op_39*(tmp_kernel_op_37*(tmp_moved_constant_19 + tmp_moved_constant_20) + tmp_kernel_op_38*(tmp_moved_constant_21 + tmp_moved_constant_22));
             const real_t tmp_kernel_op_113 = tmp_kernel_op_56*(tmp_kernel_op_54*(tmp_moved_constant_23 + tmp_moved_constant_24) + tmp_kernel_op_55*(tmp_moved_constant_25 + tmp_moved_constant_26));
             const real_t tmp_kernel_op_118 = tmp_kernel_op_73*(tmp_kernel_op_71*(tmp_moved_constant_27 + tmp_moved_constant_28) + tmp_kernel_op_72*(tmp_moved_constant_29 + tmp_moved_constant_30));
             const real_t tmp_kernel_op_120 = tmp_kernel_op_22*(tmp_kernel_op_20*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_119 - tmp_moved_constant_15) + tmp_kernel_op_21*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_119 - tmp_moved_constant_17));
             const real_t tmp_kernel_op_122 = tmp_kernel_op_39*(tmp_kernel_op_37*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_121 - tmp_moved_constant_19) + tmp_kernel_op_38*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_121 - tmp_moved_constant_21));
             const real_t tmp_kernel_op_124 = tmp_kernel_op_56*(tmp_kernel_op_54*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_123 - tmp_moved_constant_23) + tmp_kernel_op_55*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_123 - tmp_moved_constant_25));
             const real_t tmp_kernel_op_126 = tmp_kernel_op_73*(tmp_kernel_op_71*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_125 - tmp_moved_constant_27) + tmp_kernel_op_72*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_125 - tmp_moved_constant_29));
             const real_t tmp_kernel_op_128 = tmp_kernel_op_22*(tmp_kernel_op_20*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_127 - tmp_moved_constant_16) + tmp_kernel_op_21*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_127 - tmp_moved_constant_18));
             const real_t tmp_kernel_op_130 = tmp_kernel_op_39*(tmp_kernel_op_37*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_129 - tmp_moved_constant_20) + tmp_kernel_op_38*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_129 - tmp_moved_constant_22));
             const real_t tmp_kernel_op_132 = tmp_kernel_op_56*(tmp_kernel_op_54*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_131 - tmp_moved_constant_24) + tmp_kernel_op_55*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_131 - tmp_moved_constant_26));
             const real_t tmp_kernel_op_134 = tmp_kernel_op_73*(tmp_kernel_op_71*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_133 - tmp_moved_constant_28) + tmp_kernel_op_72*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_133 - tmp_moved_constant_30));
             const real_t elMat_0_0 = tmp_kernel_op_23*tmp_moved_constant_6 + tmp_kernel_op_40*tmp_moved_constant_6 + tmp_kernel_op_57*tmp_moved_constant_6 + tmp_kernel_op_74*tmp_moved_constant_6;
             const real_t elMat_0_1 = tmp_kernel_op_23*tmp_moved_constant_7 + tmp_kernel_op_40*tmp_moved_constant_7 + tmp_kernel_op_57*tmp_moved_constant_7 + tmp_kernel_op_74*tmp_moved_constant_7;
             const real_t elMat_0_2 = tmp_kernel_op_23*tmp_moved_constant_8 + tmp_kernel_op_40*tmp_moved_constant_8 + tmp_kernel_op_57*tmp_moved_constant_8 + tmp_kernel_op_74*tmp_moved_constant_8;
             const real_t elMat_0_3 = tmp_kernel_op_23*tmp_moved_constant_11 + tmp_kernel_op_40*tmp_moved_constant_11 + tmp_kernel_op_57*tmp_moved_constant_11 + tmp_kernel_op_74*tmp_moved_constant_11;
             const real_t elMat_0_4 = tmp_kernel_op_23*tmp_moved_constant_13 + tmp_kernel_op_40*tmp_moved_constant_13 + tmp_kernel_op_57*tmp_moved_constant_13 + tmp_kernel_op_74*tmp_moved_constant_13;
             const real_t elMat_0_5 = tmp_kernel_op_23*tmp_moved_constant_14 + tmp_kernel_op_40*tmp_moved_constant_14 + tmp_kernel_op_57*tmp_moved_constant_14 + tmp_kernel_op_74*tmp_moved_constant_14;
             const real_t elMat_1_0 = tmp_kernel_op_84*tmp_moved_constant_6 + tmp_kernel_op_86*tmp_moved_constant_6 + tmp_kernel_op_88*tmp_moved_constant_6 + tmp_kernel_op_90*tmp_moved_constant_6;
             const real_t elMat_1_1 = tmp_kernel_op_84*tmp_moved_constant_7 + tmp_kernel_op_86*tmp_moved_constant_7 + tmp_kernel_op_88*tmp_moved_constant_7 + tmp_kernel_op_90*tmp_moved_constant_7;
             const real_t elMat_1_2 = tmp_kernel_op_84*tmp_moved_constant_8 + tmp_kernel_op_86*tmp_moved_constant_8 + tmp_kernel_op_88*tmp_moved_constant_8 + tmp_kernel_op_90*tmp_moved_constant_8;
             const real_t elMat_1_3 = tmp_kernel_op_84*tmp_moved_constant_11 + tmp_kernel_op_86*tmp_moved_constant_11 + tmp_kernel_op_88*tmp_moved_constant_11 + tmp_kernel_op_90*tmp_moved_constant_11;
             const real_t elMat_1_4 = tmp_kernel_op_84*tmp_moved_constant_13 + tmp_kernel_op_86*tmp_moved_constant_13 + tmp_kernel_op_88*tmp_moved_constant_13 + tmp_kernel_op_90*tmp_moved_constant_13;
             const real_t elMat_1_5 = tmp_kernel_op_84*tmp_moved_constant_14 + tmp_kernel_op_86*tmp_moved_constant_14 + tmp_kernel_op_88*tmp_moved_constant_14 + tmp_kernel_op_90*tmp_moved_constant_14;
             const real_t elMat_2_0 = tmp_kernel_op_92*tmp_moved_constant_6 + tmp_kernel_op_94*tmp_moved_constant_6 + tmp_kernel_op_96*tmp_moved_constant_6 + tmp_kernel_op_98*tmp_moved_constant_6;
             const real_t elMat_2_1 = tmp_kernel_op_92*tmp_moved_constant_7 + tmp_kernel_op_94*tmp_moved_constant_7 + tmp_kernel_op_96*tmp_moved_constant_7 + tmp_kernel_op_98*tmp_moved_constant_7;
             const real_t elMat_2_2 = tmp_kernel_op_92*tmp_moved_constant_8 + tmp_kernel_op_94*tmp_moved_constant_8 + tmp_kernel_op_96*tmp_moved_constant_8 + tmp_kernel_op_98*tmp_moved_constant_8;
             const real_t elMat_2_3 = tmp_kernel_op_92*tmp_moved_constant_11 + tmp_kernel_op_94*tmp_moved_constant_11 + tmp_kernel_op_96*tmp_moved_constant_11 + tmp_kernel_op_98*tmp_moved_constant_11;
             const real_t elMat_2_4 = tmp_kernel_op_92*tmp_moved_constant_13 + tmp_kernel_op_94*tmp_moved_constant_13 + tmp_kernel_op_96*tmp_moved_constant_13 + tmp_kernel_op_98*tmp_moved_constant_13;
             const real_t elMat_2_5 = tmp_kernel_op_92*tmp_moved_constant_14 + tmp_kernel_op_94*tmp_moved_constant_14 + tmp_kernel_op_96*tmp_moved_constant_14 + tmp_kernel_op_98*tmp_moved_constant_14;
             const real_t elMat_3_0 = tmp_kernel_op_103*tmp_moved_constant_6 + tmp_kernel_op_108*tmp_moved_constant_6 + tmp_kernel_op_113*tmp_moved_constant_6 + tmp_kernel_op_118*tmp_moved_constant_6;
             const real_t elMat_3_1 = tmp_kernel_op_103*tmp_moved_constant_7 + tmp_kernel_op_108*tmp_moved_constant_7 + tmp_kernel_op_113*tmp_moved_constant_7 + tmp_kernel_op_118*tmp_moved_constant_7;
             const real_t elMat_3_2 = tmp_kernel_op_103*tmp_moved_constant_8 + tmp_kernel_op_108*tmp_moved_constant_8 + tmp_kernel_op_113*tmp_moved_constant_8 + tmp_kernel_op_118*tmp_moved_constant_8;
             const real_t elMat_3_3 = tmp_kernel_op_103*tmp_moved_constant_11 + tmp_kernel_op_108*tmp_moved_constant_11 + tmp_kernel_op_113*tmp_moved_constant_11 + tmp_kernel_op_118*tmp_moved_constant_11;
             const real_t elMat_3_4 = tmp_kernel_op_103*tmp_moved_constant_13 + tmp_kernel_op_108*tmp_moved_constant_13 + tmp_kernel_op_113*tmp_moved_constant_13 + tmp_kernel_op_118*tmp_moved_constant_13;
             const real_t elMat_3_5 = tmp_kernel_op_103*tmp_moved_constant_14 + tmp_kernel_op_108*tmp_moved_constant_14 + tmp_kernel_op_113*tmp_moved_constant_14 + tmp_kernel_op_118*tmp_moved_constant_14;
             const real_t elMat_4_0 = tmp_kernel_op_120*tmp_moved_constant_6 + tmp_kernel_op_122*tmp_moved_constant_6 + tmp_kernel_op_124*tmp_moved_constant_6 + tmp_kernel_op_126*tmp_moved_constant_6;
             const real_t elMat_4_1 = tmp_kernel_op_120*tmp_moved_constant_7 + tmp_kernel_op_122*tmp_moved_constant_7 + tmp_kernel_op_124*tmp_moved_constant_7 + tmp_kernel_op_126*tmp_moved_constant_7;
             const real_t elMat_4_2 = tmp_kernel_op_120*tmp_moved_constant_8 + tmp_kernel_op_122*tmp_moved_constant_8 + tmp_kernel_op_124*tmp_moved_constant_8 + tmp_kernel_op_126*tmp_moved_constant_8;
             const real_t elMat_4_3 = tmp_kernel_op_120*tmp_moved_constant_11 + tmp_kernel_op_122*tmp_moved_constant_11 + tmp_kernel_op_124*tmp_moved_constant_11 + tmp_kernel_op_126*tmp_moved_constant_11;
             const real_t elMat_4_4 = tmp_kernel_op_120*tmp_moved_constant_13 + tmp_kernel_op_122*tmp_moved_constant_13 + tmp_kernel_op_124*tmp_moved_constant_13 + tmp_kernel_op_126*tmp_moved_constant_13;
             const real_t elMat_4_5 = tmp_kernel_op_120*tmp_moved_constant_14 + tmp_kernel_op_122*tmp_moved_constant_14 + tmp_kernel_op_124*tmp_moved_constant_14 + tmp_kernel_op_126*tmp_moved_constant_14;
             const real_t elMat_5_0 = tmp_kernel_op_128*tmp_moved_constant_6 + tmp_kernel_op_130*tmp_moved_constant_6 + tmp_kernel_op_132*tmp_moved_constant_6 + tmp_kernel_op_134*tmp_moved_constant_6;
             const real_t elMat_5_1 = tmp_kernel_op_128*tmp_moved_constant_7 + tmp_kernel_op_130*tmp_moved_constant_7 + tmp_kernel_op_132*tmp_moved_constant_7 + tmp_kernel_op_134*tmp_moved_constant_7;
             const real_t elMat_5_2 = tmp_kernel_op_128*tmp_moved_constant_8 + tmp_kernel_op_130*tmp_moved_constant_8 + tmp_kernel_op_132*tmp_moved_constant_8 + tmp_kernel_op_134*tmp_moved_constant_8;
             const real_t elMat_5_3 = tmp_kernel_op_128*tmp_moved_constant_11 + tmp_kernel_op_130*tmp_moved_constant_11 + tmp_kernel_op_132*tmp_moved_constant_11 + tmp_kernel_op_134*tmp_moved_constant_11;
             const real_t elMat_5_4 = tmp_kernel_op_128*tmp_moved_constant_13 + tmp_kernel_op_130*tmp_moved_constant_13 + tmp_kernel_op_132*tmp_moved_constant_13 + tmp_kernel_op_134*tmp_moved_constant_13;
             const real_t elMat_5_5 = tmp_kernel_op_128*tmp_moved_constant_14 + tmp_kernel_op_130*tmp_moved_constant_14 + tmp_kernel_op_132*tmp_moved_constant_14 + tmp_kernel_op_134*tmp_moved_constant_14;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< real_t > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_1_0));
             _data_mat[7] = ((real_t)(elMat_1_1));
             _data_mat[8] = ((real_t)(elMat_1_2));
             _data_mat[9] = ((real_t)(elMat_1_3));
             _data_mat[10] = ((real_t)(elMat_1_4));
             _data_mat[11] = ((real_t)(elMat_1_5));
             _data_mat[12] = ((real_t)(elMat_2_0));
             _data_mat[13] = ((real_t)(elMat_2_1));
             _data_mat[14] = ((real_t)(elMat_2_2));
             _data_mat[15] = ((real_t)(elMat_2_3));
             _data_mat[16] = ((real_t)(elMat_2_4));
             _data_mat[17] = ((real_t)(elMat_2_5));
             _data_mat[18] = ((real_t)(elMat_3_0));
             _data_mat[19] = ((real_t)(elMat_3_1));
             _data_mat[20] = ((real_t)(elMat_3_2));
             _data_mat[21] = ((real_t)(elMat_3_3));
             _data_mat[22] = ((real_t)(elMat_3_4));
             _data_mat[23] = ((real_t)(elMat_3_5));
             _data_mat[24] = ((real_t)(elMat_4_0));
             _data_mat[25] = ((real_t)(elMat_4_1));
             _data_mat[26] = ((real_t)(elMat_4_2));
             _data_mat[27] = ((real_t)(elMat_4_3));
             _data_mat[28] = ((real_t)(elMat_4_4));
             _data_mat[29] = ((real_t)(elMat_4_5));
             _data_mat[30] = ((real_t)(elMat_5_0));
             _data_mat[31] = ((real_t)(elMat_5_1));
             _data_mat[32] = ((real_t)(elMat_5_2));
             _data_mat[33] = ((real_t)(elMat_5_3));
             _data_mat[34] = ((real_t)(elMat_5_4));
             _data_mat[35] = ((real_t)(elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
