/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2ElementwiseSupgMass.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseSupgMass::computeInverseDiagonalOperatorValues_P2ElementwiseSupgMass_macro_2D( real_t * RESTRICT  _data_deltaEdge, real_t * RESTRICT  _data_deltaVertex, real_t * RESTRICT  _data_invDiag_Edge, real_t * RESTRICT  _data_invDiag_Vertex, real_t * RESTRICT  _data_uxEdge, real_t * RESTRICT  _data_uxVertex, real_t * RESTRICT  _data_uyEdge, real_t * RESTRICT  _data_uyVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       const real_t tmp_kernel_op_0 = 0.66666666666666663;
       const real_t tmp_kernel_op_1 = tmp_kernel_op_0*0.66666666666666663;
       const real_t tmp_kernel_op_2 = 0.027777777777777776;
       const real_t tmp_kernel_op_3 = tmp_kernel_op_2*2.0;
       const real_t tmp_kernel_op_4 = 0.44444444444444442;
       const real_t tmp_kernel_op_5 = tmp_kernel_op_4*2.0;
       const real_t tmp_kernel_op_6 = tmp_kernel_op_1 + tmp_kernel_op_3 + tmp_kernel_op_5 - 1.5;
       const real_t tmp_kernel_op_7 = 2.6666666666666665;
       const real_t tmp_kernel_op_8 = tmp_kernel_op_0 + tmp_kernel_op_7 - 3.0;
       const real_t tmp_kernel_op_9 = tmp_kernel_op_3 - 0.16666666666666666;
       const real_t tmp_kernel_op_10 = tmp_kernel_op_5 - 0.66666666666666663;
       const real_t tmp_kernel_op_11 = -tmp_kernel_op_1 + tmp_kernel_op_4*-4.0 + tmp_kernel_op_7;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_0 - tmp_kernel_op_1 + tmp_kernel_op_2*-4.0;
       const real_t tmp_kernel_op_16 = 2.6666666666666665;
       const real_t tmp_kernel_op_17 = tmp_kernel_op_16*0.16666666666666666;
       const real_t tmp_kernel_op_18 = 0.44444444444444442;
       const real_t tmp_kernel_op_19 = tmp_kernel_op_18*2.0;
       const real_t tmp_kernel_op_20 = 0.027777777777777776;
       const real_t tmp_kernel_op_21 = tmp_kernel_op_20*2.0;
       const real_t tmp_kernel_op_22 = tmp_kernel_op_17 + tmp_kernel_op_19 + tmp_kernel_op_21 - 1.5;
       const real_t tmp_kernel_op_23 = 0.66666666666666663;
       const real_t tmp_kernel_op_24 = tmp_kernel_op_16 + tmp_kernel_op_23 - 3.0;
       const real_t tmp_kernel_op_25 = tmp_kernel_op_19 - 0.66666666666666663;
       const real_t tmp_kernel_op_26 = tmp_kernel_op_21 - 0.16666666666666666;
       const real_t tmp_kernel_op_27 = -tmp_kernel_op_17 + tmp_kernel_op_20*-4.0 + tmp_kernel_op_23;
       const real_t tmp_kernel_op_28 = tmp_kernel_op_16 - tmp_kernel_op_17 + tmp_kernel_op_18*-4.0;
       const real_t tmp_kernel_op_32 = 0.66666666666666663;
       const real_t tmp_kernel_op_33 = tmp_kernel_op_32*0.16666666666666666;
       const real_t tmp_kernel_op_34 = 0.027777777777777776;
       const real_t tmp_kernel_op_35 = tmp_kernel_op_34*2.0;
       const real_t tmp_kernel_op_36 = 0.027777777777777776;
       const real_t tmp_kernel_op_37 = tmp_kernel_op_36*2.0;
       const real_t tmp_kernel_op_38 = tmp_kernel_op_33 + tmp_kernel_op_35 + tmp_kernel_op_37;
       const real_t tmp_kernel_op_39 = 0.66666666666666663;
       const real_t tmp_kernel_op_40 = tmp_kernel_op_32 + tmp_kernel_op_39 - 3.0;
       const real_t tmp_kernel_op_41 = tmp_kernel_op_35 - 0.16666666666666666;
       const real_t tmp_kernel_op_42 = tmp_kernel_op_37 - 0.16666666666666666;
       const real_t tmp_kernel_op_43 = -tmp_kernel_op_33 + tmp_kernel_op_36*-4.0 + tmp_kernel_op_39;
       const real_t tmp_kernel_op_44 = tmp_kernel_op_32 - tmp_kernel_op_33 + tmp_kernel_op_34*-4.0;
       const real_t tmp_kernel_op_48 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_49 = tmp_kernel_op_16 - 1.0;
       const real_t tmp_kernel_op_50 = tmp_kernel_op_32 - 1.0;
       const real_t tmp_kernel_op_51 = tmp_kernel_op_7 - 1.0;
       const real_t tmp_kernel_op_52 = tmp_kernel_op_23 - 1.0;
       const real_t tmp_kernel_op_53 = tmp_kernel_op_39 - 1.0;
       const real_t tmp_kernel_op_54 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_7;
       const real_t tmp_kernel_op_55 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_56 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_7;
       const real_t tmp_kernel_op_57 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_58 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_23;
       const real_t tmp_kernel_op_59 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_16;
       const real_t tmp_kernel_op_60 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_23;
       const real_t tmp_kernel_op_61 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_16;
       const real_t tmp_kernel_op_62 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_39;
       const real_t tmp_kernel_op_63 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_32;
       const real_t tmp_kernel_op_64 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_39;
       const real_t tmp_kernel_op_65 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_32;
       const real_t tmp_kernel_op_66 = -tmp_kernel_op_0 - 1.333333333333333;
       const real_t tmp_kernel_op_67 = -tmp_kernel_op_16 + 2.666666666666667;
       const real_t tmp_kernel_op_68 = -tmp_kernel_op_32 + 2.666666666666667;
       const real_t tmp_kernel_op_69 = -tmp_kernel_op_7 + 2.666666666666667;
       const real_t tmp_kernel_op_70 = -tmp_kernel_op_23 - 1.333333333333333;
       const real_t tmp_kernel_op_71 = -tmp_kernel_op_39 + 2.666666666666667;
       {
          /* FaceType.GRAY */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t delta_dof_0 = _data_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t delta_dof_1 = _data_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t delta_dof_2 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t delta_dof_3 = _data_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t delta_dof_4 = _data_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t delta_dof_5 = _data_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ux_dof_3 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t uy_dof_3 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t tmp_kernel_op_13 = tmp_kernel_op_1*ux_dof_3 + tmp_kernel_op_10*ux_dof_2 + tmp_kernel_op_11*ux_dof_4 + tmp_kernel_op_12*ux_dof_5 + tmp_kernel_op_6*ux_dof_0 + tmp_kernel_op_9*ux_dof_1;
             const real_t tmp_kernel_op_14 = tmp_kernel_op_1*uy_dof_3 + tmp_kernel_op_10*uy_dof_2 + tmp_kernel_op_11*uy_dof_4 + tmp_kernel_op_12*uy_dof_5 + tmp_kernel_op_6*uy_dof_0 + tmp_kernel_op_9*uy_dof_1;
             const real_t tmp_kernel_op_15 = abs_det_jac_affine_GRAY*(delta_dof_0*tmp_kernel_op_6 + delta_dof_1*tmp_kernel_op_9 + delta_dof_2*tmp_kernel_op_10 + delta_dof_3*tmp_kernel_op_1 + delta_dof_4*tmp_kernel_op_11 + delta_dof_5*tmp_kernel_op_12)*0.16666666666666666;
             const real_t tmp_kernel_op_29 = tmp_kernel_op_17*ux_dof_3 + tmp_kernel_op_22*ux_dof_0 + tmp_kernel_op_25*ux_dof_1 + tmp_kernel_op_26*ux_dof_2 + tmp_kernel_op_27*ux_dof_4 + tmp_kernel_op_28*ux_dof_5;
             const real_t tmp_kernel_op_30 = tmp_kernel_op_17*uy_dof_3 + tmp_kernel_op_22*uy_dof_0 + tmp_kernel_op_25*uy_dof_1 + tmp_kernel_op_26*uy_dof_2 + tmp_kernel_op_27*uy_dof_4 + tmp_kernel_op_28*uy_dof_5;
             const real_t tmp_kernel_op_31 = abs_det_jac_affine_GRAY*(delta_dof_0*tmp_kernel_op_22 + delta_dof_1*tmp_kernel_op_25 + delta_dof_2*tmp_kernel_op_26 + delta_dof_3*tmp_kernel_op_17 + delta_dof_4*tmp_kernel_op_27 + delta_dof_5*tmp_kernel_op_28)*0.16666666666666666;
             const real_t tmp_kernel_op_45 = tmp_kernel_op_33*ux_dof_3 + tmp_kernel_op_38*ux_dof_0 + tmp_kernel_op_41*ux_dof_1 + tmp_kernel_op_42*ux_dof_2 + tmp_kernel_op_43*ux_dof_4 + tmp_kernel_op_44*ux_dof_5;
             const real_t tmp_kernel_op_46 = tmp_kernel_op_33*uy_dof_3 + tmp_kernel_op_38*uy_dof_0 + tmp_kernel_op_41*uy_dof_1 + tmp_kernel_op_42*uy_dof_2 + tmp_kernel_op_43*uy_dof_4 + tmp_kernel_op_44*uy_dof_5;
             const real_t tmp_kernel_op_47 = abs_det_jac_affine_GRAY*(delta_dof_0*tmp_kernel_op_38 + delta_dof_1*tmp_kernel_op_41 + delta_dof_2*tmp_kernel_op_42 + delta_dof_3*tmp_kernel_op_33 + delta_dof_4*tmp_kernel_op_43 + delta_dof_5*tmp_kernel_op_44)*0.16666666666666666;
             const real_t elMatDiag_0 = tmp_kernel_op_15*tmp_kernel_op_6*(tmp_kernel_op_13*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_8 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_8) + tmp_kernel_op_14*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_8 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_8)) + tmp_kernel_op_22*tmp_kernel_op_31*(tmp_kernel_op_29*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_24 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_24) + tmp_kernel_op_30*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_24 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_24)) + tmp_kernel_op_38*tmp_kernel_op_47*(tmp_kernel_op_45*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_40 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_40) + tmp_kernel_op_46*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_40 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_40));
             const real_t elMatDiag_1 = tmp_kernel_op_15*tmp_kernel_op_9*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_13*tmp_kernel_op_48 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_14*tmp_kernel_op_48) + tmp_kernel_op_25*tmp_kernel_op_31*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_29*tmp_kernel_op_49 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_30*tmp_kernel_op_49) + tmp_kernel_op_41*tmp_kernel_op_47*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_45*tmp_kernel_op_50 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_46*tmp_kernel_op_50);
             const real_t elMatDiag_2 = tmp_kernel_op_10*tmp_kernel_op_15*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_13*tmp_kernel_op_51 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_14*tmp_kernel_op_51) + tmp_kernel_op_26*tmp_kernel_op_31*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_29*tmp_kernel_op_52 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_30*tmp_kernel_op_52) + tmp_kernel_op_42*tmp_kernel_op_47*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_45*tmp_kernel_op_53 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_46*tmp_kernel_op_53);
             const real_t elMatDiag_3 = tmp_kernel_op_1*tmp_kernel_op_15*(tmp_kernel_op_13*(tmp_kernel_op_54 + tmp_kernel_op_55) + tmp_kernel_op_14*(tmp_kernel_op_56 + tmp_kernel_op_57)) + tmp_kernel_op_17*tmp_kernel_op_31*(tmp_kernel_op_29*(tmp_kernel_op_58 + tmp_kernel_op_59) + tmp_kernel_op_30*(tmp_kernel_op_60 + tmp_kernel_op_61)) + tmp_kernel_op_33*tmp_kernel_op_47*(tmp_kernel_op_45*(tmp_kernel_op_62 + tmp_kernel_op_63) + tmp_kernel_op_46*(tmp_kernel_op_64 + tmp_kernel_op_65));
             const real_t elMatDiag_4 = tmp_kernel_op_11*tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_66 - tmp_kernel_op_54) + tmp_kernel_op_14*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_66 - tmp_kernel_op_56)) + tmp_kernel_op_27*tmp_kernel_op_31*(tmp_kernel_op_29*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_67 - tmp_kernel_op_58) + tmp_kernel_op_30*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_67 - tmp_kernel_op_60)) + tmp_kernel_op_43*tmp_kernel_op_47*(tmp_kernel_op_45*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_68 - tmp_kernel_op_62) + tmp_kernel_op_46*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_68 - tmp_kernel_op_64));
             const real_t elMatDiag_5 = tmp_kernel_op_12*tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_69 - tmp_kernel_op_55) + tmp_kernel_op_14*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_69 - tmp_kernel_op_57)) + tmp_kernel_op_28*tmp_kernel_op_31*(tmp_kernel_op_29*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_70 - tmp_kernel_op_59) + tmp_kernel_op_30*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_70 - tmp_kernel_op_61)) + tmp_kernel_op_44*tmp_kernel_op_47*(tmp_kernel_op_45*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_71 - tmp_kernel_op_63) + tmp_kernel_op_46*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_71 - tmp_kernel_op_65));
             _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_3 + _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       const real_t tmp_moved_constant_0 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_7;
       const real_t tmp_moved_constant_1 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_2 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_7;
       const real_t tmp_moved_constant_3 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_4 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_23;
       const real_t tmp_moved_constant_5 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_16;
       const real_t tmp_moved_constant_6 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_23;
       const real_t tmp_moved_constant_7 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_16;
       const real_t tmp_moved_constant_8 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_39;
       const real_t tmp_moved_constant_9 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_32;
       const real_t tmp_moved_constant_10 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_39;
       const real_t tmp_moved_constant_11 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_32;
       {
          /* FaceType.BLUE */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t delta_dof_0 = _data_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t delta_dof_1 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t delta_dof_2 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t delta_dof_3 = _data_deltaEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t delta_dof_4 = _data_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t delta_dof_5 = _data_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t ux_dof_3 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t uy_dof_3 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t tmp_kernel_op_13 = tmp_kernel_op_1*ux_dof_3 + tmp_kernel_op_10*ux_dof_2 + tmp_kernel_op_11*ux_dof_4 + tmp_kernel_op_12*ux_dof_5 + tmp_kernel_op_6*ux_dof_0 + tmp_kernel_op_9*ux_dof_1;
             const real_t tmp_kernel_op_14 = tmp_kernel_op_1*uy_dof_3 + tmp_kernel_op_10*uy_dof_2 + tmp_kernel_op_11*uy_dof_4 + tmp_kernel_op_12*uy_dof_5 + tmp_kernel_op_6*uy_dof_0 + tmp_kernel_op_9*uy_dof_1;
             const real_t tmp_kernel_op_15 = abs_det_jac_affine_BLUE*(delta_dof_0*tmp_kernel_op_6 + delta_dof_1*tmp_kernel_op_9 + delta_dof_2*tmp_kernel_op_10 + delta_dof_3*tmp_kernel_op_1 + delta_dof_4*tmp_kernel_op_11 + delta_dof_5*tmp_kernel_op_12)*0.16666666666666666;
             const real_t tmp_kernel_op_29 = tmp_kernel_op_17*ux_dof_3 + tmp_kernel_op_22*ux_dof_0 + tmp_kernel_op_25*ux_dof_1 + tmp_kernel_op_26*ux_dof_2 + tmp_kernel_op_27*ux_dof_4 + tmp_kernel_op_28*ux_dof_5;
             const real_t tmp_kernel_op_30 = tmp_kernel_op_17*uy_dof_3 + tmp_kernel_op_22*uy_dof_0 + tmp_kernel_op_25*uy_dof_1 + tmp_kernel_op_26*uy_dof_2 + tmp_kernel_op_27*uy_dof_4 + tmp_kernel_op_28*uy_dof_5;
             const real_t tmp_kernel_op_31 = abs_det_jac_affine_BLUE*(delta_dof_0*tmp_kernel_op_22 + delta_dof_1*tmp_kernel_op_25 + delta_dof_2*tmp_kernel_op_26 + delta_dof_3*tmp_kernel_op_17 + delta_dof_4*tmp_kernel_op_27 + delta_dof_5*tmp_kernel_op_28)*0.16666666666666666;
             const real_t tmp_kernel_op_45 = tmp_kernel_op_33*ux_dof_3 + tmp_kernel_op_38*ux_dof_0 + tmp_kernel_op_41*ux_dof_1 + tmp_kernel_op_42*ux_dof_2 + tmp_kernel_op_43*ux_dof_4 + tmp_kernel_op_44*ux_dof_5;
             const real_t tmp_kernel_op_46 = tmp_kernel_op_33*uy_dof_3 + tmp_kernel_op_38*uy_dof_0 + tmp_kernel_op_41*uy_dof_1 + tmp_kernel_op_42*uy_dof_2 + tmp_kernel_op_43*uy_dof_4 + tmp_kernel_op_44*uy_dof_5;
             const real_t tmp_kernel_op_47 = abs_det_jac_affine_BLUE*(delta_dof_0*tmp_kernel_op_38 + delta_dof_1*tmp_kernel_op_41 + delta_dof_2*tmp_kernel_op_42 + delta_dof_3*tmp_kernel_op_33 + delta_dof_4*tmp_kernel_op_43 + delta_dof_5*tmp_kernel_op_44)*0.16666666666666666;
             const real_t elMatDiag_0 = tmp_kernel_op_15*tmp_kernel_op_6*(tmp_kernel_op_13*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_8 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_8) + tmp_kernel_op_14*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_8 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_8)) + tmp_kernel_op_22*tmp_kernel_op_31*(tmp_kernel_op_29*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_24 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_24) + tmp_kernel_op_30*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_24 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_24)) + tmp_kernel_op_38*tmp_kernel_op_47*(tmp_kernel_op_45*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_40 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_40) + tmp_kernel_op_46*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_40 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_40));
             const real_t elMatDiag_1 = tmp_kernel_op_15*tmp_kernel_op_9*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_13*tmp_kernel_op_48 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_14*tmp_kernel_op_48) + tmp_kernel_op_25*tmp_kernel_op_31*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_29*tmp_kernel_op_49 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_30*tmp_kernel_op_49) + tmp_kernel_op_41*tmp_kernel_op_47*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_45*tmp_kernel_op_50 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_46*tmp_kernel_op_50);
             const real_t elMatDiag_2 = tmp_kernel_op_10*tmp_kernel_op_15*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_13*tmp_kernel_op_51 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_14*tmp_kernel_op_51) + tmp_kernel_op_26*tmp_kernel_op_31*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_29*tmp_kernel_op_52 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_30*tmp_kernel_op_52) + tmp_kernel_op_42*tmp_kernel_op_47*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_45*tmp_kernel_op_53 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_46*tmp_kernel_op_53);
             const real_t elMatDiag_3 = tmp_kernel_op_1*tmp_kernel_op_15*(tmp_kernel_op_13*(tmp_moved_constant_0 + tmp_moved_constant_1) + tmp_kernel_op_14*(tmp_moved_constant_2 + tmp_moved_constant_3)) + tmp_kernel_op_17*tmp_kernel_op_31*(tmp_kernel_op_29*(tmp_moved_constant_4 + tmp_moved_constant_5) + tmp_kernel_op_30*(tmp_moved_constant_6 + tmp_moved_constant_7)) + tmp_kernel_op_33*tmp_kernel_op_47*(tmp_kernel_op_45*(tmp_moved_constant_8 + tmp_moved_constant_9) + tmp_kernel_op_46*(tmp_moved_constant_10 + tmp_moved_constant_11));
             const real_t elMatDiag_4 = tmp_kernel_op_11*tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_66 - tmp_moved_constant_0) + tmp_kernel_op_14*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_66 - tmp_moved_constant_2)) + tmp_kernel_op_27*tmp_kernel_op_31*(tmp_kernel_op_29*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_67 - tmp_moved_constant_4) + tmp_kernel_op_30*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_67 - tmp_moved_constant_6)) + tmp_kernel_op_43*tmp_kernel_op_47*(tmp_kernel_op_45*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_68 - tmp_moved_constant_8) + tmp_kernel_op_46*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_68 - tmp_moved_constant_10));
             const real_t elMatDiag_5 = tmp_kernel_op_12*tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_69 - tmp_moved_constant_1) + tmp_kernel_op_14*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_69 - tmp_moved_constant_3)) + tmp_kernel_op_28*tmp_kernel_op_31*(tmp_kernel_op_29*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_70 - tmp_moved_constant_5) + tmp_kernel_op_30*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_70 - tmp_moved_constant_7)) + tmp_kernel_op_44*tmp_kernel_op_47*(tmp_kernel_op_45*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_71 - tmp_moved_constant_9) + tmp_kernel_op_46*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_71 - tmp_moved_constant_11));
             _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_3 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
