/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2ElementwiseSupgMass.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseSupgMass::toMatrix_P2ElementwiseSupgMass_macro_2D( real_t * RESTRICT  _data_deltaEdge, real_t * RESTRICT  _data_deltaVertex, idx_t * RESTRICT  _data_dstEdge, idx_t * RESTRICT  _data_dstVertex, idx_t * RESTRICT  _data_srcEdge, idx_t * RESTRICT  _data_srcVertex, real_t * RESTRICT  _data_uxEdge, real_t * RESTRICT  _data_uxVertex, real_t * RESTRICT  _data_uyEdge, real_t * RESTRICT  _data_uyVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       const real_t tmp_kernel_op_0 = 0.66666666666666663;
       const real_t tmp_kernel_op_1 = tmp_kernel_op_0*0.66666666666666663;
       const real_t tmp_kernel_op_2 = 0.027777777777777776;
       const real_t tmp_kernel_op_3 = tmp_kernel_op_2*2.0;
       const real_t tmp_kernel_op_4 = 0.44444444444444442;
       const real_t tmp_kernel_op_5 = tmp_kernel_op_4*2.0;
       const real_t tmp_kernel_op_6 = tmp_kernel_op_1 + tmp_kernel_op_3 + tmp_kernel_op_5 - 1.5;
       const real_t tmp_kernel_op_7 = 2.6666666666666665;
       const real_t tmp_kernel_op_8 = tmp_kernel_op_0 + tmp_kernel_op_7 - 3.0;
       const real_t tmp_kernel_op_9 = tmp_kernel_op_3 - 0.16666666666666666;
       const real_t tmp_kernel_op_10 = tmp_kernel_op_5 - 0.66666666666666663;
       const real_t tmp_kernel_op_11 = -tmp_kernel_op_1 + tmp_kernel_op_4*-4.0 + tmp_kernel_op_7;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_0 - tmp_kernel_op_1 + tmp_kernel_op_2*-4.0;
       const real_t tmp_kernel_op_17 = 2.6666666666666665;
       const real_t tmp_kernel_op_18 = tmp_kernel_op_17*0.16666666666666666;
       const real_t tmp_kernel_op_19 = 0.44444444444444442;
       const real_t tmp_kernel_op_20 = tmp_kernel_op_19*2.0;
       const real_t tmp_kernel_op_21 = 0.027777777777777776;
       const real_t tmp_kernel_op_22 = tmp_kernel_op_21*2.0;
       const real_t tmp_kernel_op_23 = tmp_kernel_op_18 + tmp_kernel_op_20 + tmp_kernel_op_22 - 1.5;
       const real_t tmp_kernel_op_24 = 0.66666666666666663;
       const real_t tmp_kernel_op_25 = tmp_kernel_op_17 + tmp_kernel_op_24 - 3.0;
       const real_t tmp_kernel_op_26 = tmp_kernel_op_20 - 0.66666666666666663;
       const real_t tmp_kernel_op_27 = tmp_kernel_op_22 - 0.16666666666666666;
       const real_t tmp_kernel_op_28 = -tmp_kernel_op_18 + tmp_kernel_op_21*-4.0 + tmp_kernel_op_24;
       const real_t tmp_kernel_op_29 = tmp_kernel_op_17 - tmp_kernel_op_18 + tmp_kernel_op_19*-4.0;
       const real_t tmp_kernel_op_34 = 0.66666666666666663;
       const real_t tmp_kernel_op_35 = tmp_kernel_op_34*0.16666666666666666;
       const real_t tmp_kernel_op_36 = 0.027777777777777776;
       const real_t tmp_kernel_op_37 = tmp_kernel_op_36*2.0;
       const real_t tmp_kernel_op_38 = 0.027777777777777776;
       const real_t tmp_kernel_op_39 = tmp_kernel_op_38*2.0;
       const real_t tmp_kernel_op_40 = tmp_kernel_op_35 + tmp_kernel_op_37 + tmp_kernel_op_39;
       const real_t tmp_kernel_op_41 = 0.66666666666666663;
       const real_t tmp_kernel_op_42 = tmp_kernel_op_34 + tmp_kernel_op_41 - 3.0;
       const real_t tmp_kernel_op_43 = tmp_kernel_op_37 - 0.16666666666666666;
       const real_t tmp_kernel_op_44 = tmp_kernel_op_39 - 0.16666666666666666;
       const real_t tmp_kernel_op_45 = -tmp_kernel_op_35 + tmp_kernel_op_38*-4.0 + tmp_kernel_op_41;
       const real_t tmp_kernel_op_46 = tmp_kernel_op_34 - tmp_kernel_op_35 + tmp_kernel_op_36*-4.0;
       const real_t tmp_kernel_op_51 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_53 = tmp_kernel_op_17 - 1.0;
       const real_t tmp_kernel_op_55 = tmp_kernel_op_34 - 1.0;
       const real_t tmp_kernel_op_57 = tmp_kernel_op_7 - 1.0;
       const real_t tmp_kernel_op_59 = tmp_kernel_op_24 - 1.0;
       const real_t tmp_kernel_op_61 = tmp_kernel_op_41 - 1.0;
       const real_t tmp_kernel_op_63 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_7;
       const real_t tmp_kernel_op_64 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_65 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_7;
       const real_t tmp_kernel_op_66 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_68 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_24;
       const real_t tmp_kernel_op_69 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_17;
       const real_t tmp_kernel_op_70 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_24;
       const real_t tmp_kernel_op_71 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_17;
       const real_t tmp_kernel_op_73 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_41;
       const real_t tmp_kernel_op_74 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_34;
       const real_t tmp_kernel_op_75 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_41;
       const real_t tmp_kernel_op_76 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_34;
       const real_t tmp_kernel_op_78 = -tmp_kernel_op_0 - 1.333333333333333;
       const real_t tmp_kernel_op_80 = -tmp_kernel_op_17 + 2.666666666666667;
       const real_t tmp_kernel_op_82 = -tmp_kernel_op_34 + 2.666666666666667;
       const real_t tmp_kernel_op_84 = -tmp_kernel_op_7 + 2.666666666666667;
       const real_t tmp_kernel_op_86 = -tmp_kernel_op_24 - 1.333333333333333;
       const real_t tmp_kernel_op_88 = -tmp_kernel_op_41 + 2.666666666666667;
       {
          /* FaceType.GRAY */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t delta_dof_0 = _data_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t delta_dof_1 = _data_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t delta_dof_2 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t delta_dof_3 = _data_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t delta_dof_4 = _data_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t delta_dof_5 = _data_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ux_dof_3 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t uy_dof_3 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t tmp_kernel_op_13 = tmp_kernel_op_1*ux_dof_3 + tmp_kernel_op_10*ux_dof_2 + tmp_kernel_op_11*ux_dof_4 + tmp_kernel_op_12*ux_dof_5 + tmp_kernel_op_6*ux_dof_0 + tmp_kernel_op_9*ux_dof_1;
             const real_t tmp_kernel_op_14 = tmp_kernel_op_1*uy_dof_3 + tmp_kernel_op_10*uy_dof_2 + tmp_kernel_op_11*uy_dof_4 + tmp_kernel_op_12*uy_dof_5 + tmp_kernel_op_6*uy_dof_0 + tmp_kernel_op_9*uy_dof_1;
             const real_t tmp_kernel_op_15 = abs_det_jac_affine_GRAY*(delta_dof_0*tmp_kernel_op_6 + delta_dof_1*tmp_kernel_op_9 + delta_dof_2*tmp_kernel_op_10 + delta_dof_3*tmp_kernel_op_1 + delta_dof_4*tmp_kernel_op_11 + delta_dof_5*tmp_kernel_op_12)*0.16666666666666666;
             const real_t tmp_kernel_op_16 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_8 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_8) + tmp_kernel_op_14*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_8 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_8));
             const real_t tmp_kernel_op_30 = tmp_kernel_op_18*ux_dof_3 + tmp_kernel_op_23*ux_dof_0 + tmp_kernel_op_26*ux_dof_1 + tmp_kernel_op_27*ux_dof_2 + tmp_kernel_op_28*ux_dof_4 + tmp_kernel_op_29*ux_dof_5;
             const real_t tmp_kernel_op_31 = tmp_kernel_op_18*uy_dof_3 + tmp_kernel_op_23*uy_dof_0 + tmp_kernel_op_26*uy_dof_1 + tmp_kernel_op_27*uy_dof_2 + tmp_kernel_op_28*uy_dof_4 + tmp_kernel_op_29*uy_dof_5;
             const real_t tmp_kernel_op_32 = abs_det_jac_affine_GRAY*(delta_dof_0*tmp_kernel_op_23 + delta_dof_1*tmp_kernel_op_26 + delta_dof_2*tmp_kernel_op_27 + delta_dof_3*tmp_kernel_op_18 + delta_dof_4*tmp_kernel_op_28 + delta_dof_5*tmp_kernel_op_29)*0.16666666666666666;
             const real_t tmp_kernel_op_33 = tmp_kernel_op_32*(tmp_kernel_op_30*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_25 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_25) + tmp_kernel_op_31*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_25 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_25));
             const real_t tmp_kernel_op_47 = tmp_kernel_op_35*ux_dof_3 + tmp_kernel_op_40*ux_dof_0 + tmp_kernel_op_43*ux_dof_1 + tmp_kernel_op_44*ux_dof_2 + tmp_kernel_op_45*ux_dof_4 + tmp_kernel_op_46*ux_dof_5;
             const real_t tmp_kernel_op_48 = tmp_kernel_op_35*uy_dof_3 + tmp_kernel_op_40*uy_dof_0 + tmp_kernel_op_43*uy_dof_1 + tmp_kernel_op_44*uy_dof_2 + tmp_kernel_op_45*uy_dof_4 + tmp_kernel_op_46*uy_dof_5;
             const real_t tmp_kernel_op_49 = abs_det_jac_affine_GRAY*(delta_dof_0*tmp_kernel_op_40 + delta_dof_1*tmp_kernel_op_43 + delta_dof_2*tmp_kernel_op_44 + delta_dof_3*tmp_kernel_op_35 + delta_dof_4*tmp_kernel_op_45 + delta_dof_5*tmp_kernel_op_46)*0.16666666666666666;
             const real_t tmp_kernel_op_50 = tmp_kernel_op_49*(tmp_kernel_op_47*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_42 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_42) + tmp_kernel_op_48*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_42 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_42));
             const real_t tmp_kernel_op_52 = tmp_kernel_op_15*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_13*tmp_kernel_op_51 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_14*tmp_kernel_op_51);
             const real_t tmp_kernel_op_54 = tmp_kernel_op_32*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_30*tmp_kernel_op_53 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_31*tmp_kernel_op_53);
             const real_t tmp_kernel_op_56 = tmp_kernel_op_49*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_47*tmp_kernel_op_55 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_48*tmp_kernel_op_55);
             const real_t tmp_kernel_op_58 = tmp_kernel_op_15*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_13*tmp_kernel_op_57 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_14*tmp_kernel_op_57);
             const real_t tmp_kernel_op_60 = tmp_kernel_op_32*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_30*tmp_kernel_op_59 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_31*tmp_kernel_op_59);
             const real_t tmp_kernel_op_62 = tmp_kernel_op_49*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_47*tmp_kernel_op_61 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_48*tmp_kernel_op_61);
             const real_t tmp_kernel_op_67 = tmp_kernel_op_15*(tmp_kernel_op_13*(tmp_kernel_op_63 + tmp_kernel_op_64) + tmp_kernel_op_14*(tmp_kernel_op_65 + tmp_kernel_op_66));
             const real_t tmp_kernel_op_72 = tmp_kernel_op_32*(tmp_kernel_op_30*(tmp_kernel_op_68 + tmp_kernel_op_69) + tmp_kernel_op_31*(tmp_kernel_op_70 + tmp_kernel_op_71));
             const real_t tmp_kernel_op_77 = tmp_kernel_op_49*(tmp_kernel_op_47*(tmp_kernel_op_73 + tmp_kernel_op_74) + tmp_kernel_op_48*(tmp_kernel_op_75 + tmp_kernel_op_76));
             const real_t tmp_kernel_op_79 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_78 - tmp_kernel_op_63) + tmp_kernel_op_14*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_78 - tmp_kernel_op_65));
             const real_t tmp_kernel_op_81 = tmp_kernel_op_32*(tmp_kernel_op_30*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_80 - tmp_kernel_op_68) + tmp_kernel_op_31*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_80 - tmp_kernel_op_70));
             const real_t tmp_kernel_op_83 = tmp_kernel_op_49*(tmp_kernel_op_47*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_82 - tmp_kernel_op_73) + tmp_kernel_op_48*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_82 - tmp_kernel_op_75));
             const real_t tmp_kernel_op_85 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_84 - tmp_kernel_op_64) + tmp_kernel_op_14*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_84 - tmp_kernel_op_66));
             const real_t tmp_kernel_op_87 = tmp_kernel_op_32*(tmp_kernel_op_30*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_86 - tmp_kernel_op_69) + tmp_kernel_op_31*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_86 - tmp_kernel_op_71));
             const real_t tmp_kernel_op_89 = tmp_kernel_op_49*(tmp_kernel_op_47*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_88 - tmp_kernel_op_74) + tmp_kernel_op_48*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_88 - tmp_kernel_op_76));
             const real_t elMat_0_0 = tmp_kernel_op_16*tmp_kernel_op_6 + tmp_kernel_op_23*tmp_kernel_op_33 + tmp_kernel_op_40*tmp_kernel_op_50;
             const real_t elMat_0_1 = tmp_kernel_op_16*tmp_kernel_op_9 + tmp_kernel_op_26*tmp_kernel_op_33 + tmp_kernel_op_43*tmp_kernel_op_50;
             const real_t elMat_0_2 = tmp_kernel_op_10*tmp_kernel_op_16 + tmp_kernel_op_27*tmp_kernel_op_33 + tmp_kernel_op_44*tmp_kernel_op_50;
             const real_t elMat_0_3 = tmp_kernel_op_1*tmp_kernel_op_16 + tmp_kernel_op_18*tmp_kernel_op_33 + tmp_kernel_op_35*tmp_kernel_op_50;
             const real_t elMat_0_4 = tmp_kernel_op_11*tmp_kernel_op_16 + tmp_kernel_op_28*tmp_kernel_op_33 + tmp_kernel_op_45*tmp_kernel_op_50;
             const real_t elMat_0_5 = tmp_kernel_op_12*tmp_kernel_op_16 + tmp_kernel_op_29*tmp_kernel_op_33 + tmp_kernel_op_46*tmp_kernel_op_50;
             const real_t elMat_1_0 = tmp_kernel_op_23*tmp_kernel_op_54 + tmp_kernel_op_40*tmp_kernel_op_56 + tmp_kernel_op_52*tmp_kernel_op_6;
             const real_t elMat_1_1 = tmp_kernel_op_26*tmp_kernel_op_54 + tmp_kernel_op_43*tmp_kernel_op_56 + tmp_kernel_op_52*tmp_kernel_op_9;
             const real_t elMat_1_2 = tmp_kernel_op_10*tmp_kernel_op_52 + tmp_kernel_op_27*tmp_kernel_op_54 + tmp_kernel_op_44*tmp_kernel_op_56;
             const real_t elMat_1_3 = tmp_kernel_op_1*tmp_kernel_op_52 + tmp_kernel_op_18*tmp_kernel_op_54 + tmp_kernel_op_35*tmp_kernel_op_56;
             const real_t elMat_1_4 = tmp_kernel_op_11*tmp_kernel_op_52 + tmp_kernel_op_28*tmp_kernel_op_54 + tmp_kernel_op_45*tmp_kernel_op_56;
             const real_t elMat_1_5 = tmp_kernel_op_12*tmp_kernel_op_52 + tmp_kernel_op_29*tmp_kernel_op_54 + tmp_kernel_op_46*tmp_kernel_op_56;
             const real_t elMat_2_0 = tmp_kernel_op_23*tmp_kernel_op_60 + tmp_kernel_op_40*tmp_kernel_op_62 + tmp_kernel_op_58*tmp_kernel_op_6;
             const real_t elMat_2_1 = tmp_kernel_op_26*tmp_kernel_op_60 + tmp_kernel_op_43*tmp_kernel_op_62 + tmp_kernel_op_58*tmp_kernel_op_9;
             const real_t elMat_2_2 = tmp_kernel_op_10*tmp_kernel_op_58 + tmp_kernel_op_27*tmp_kernel_op_60 + tmp_kernel_op_44*tmp_kernel_op_62;
             const real_t elMat_2_3 = tmp_kernel_op_1*tmp_kernel_op_58 + tmp_kernel_op_18*tmp_kernel_op_60 + tmp_kernel_op_35*tmp_kernel_op_62;
             const real_t elMat_2_4 = tmp_kernel_op_11*tmp_kernel_op_58 + tmp_kernel_op_28*tmp_kernel_op_60 + tmp_kernel_op_45*tmp_kernel_op_62;
             const real_t elMat_2_5 = tmp_kernel_op_12*tmp_kernel_op_58 + tmp_kernel_op_29*tmp_kernel_op_60 + tmp_kernel_op_46*tmp_kernel_op_62;
             const real_t elMat_3_0 = tmp_kernel_op_23*tmp_kernel_op_72 + tmp_kernel_op_40*tmp_kernel_op_77 + tmp_kernel_op_6*tmp_kernel_op_67;
             const real_t elMat_3_1 = tmp_kernel_op_26*tmp_kernel_op_72 + tmp_kernel_op_43*tmp_kernel_op_77 + tmp_kernel_op_67*tmp_kernel_op_9;
             const real_t elMat_3_2 = tmp_kernel_op_10*tmp_kernel_op_67 + tmp_kernel_op_27*tmp_kernel_op_72 + tmp_kernel_op_44*tmp_kernel_op_77;
             const real_t elMat_3_3 = tmp_kernel_op_1*tmp_kernel_op_67 + tmp_kernel_op_18*tmp_kernel_op_72 + tmp_kernel_op_35*tmp_kernel_op_77;
             const real_t elMat_3_4 = tmp_kernel_op_11*tmp_kernel_op_67 + tmp_kernel_op_28*tmp_kernel_op_72 + tmp_kernel_op_45*tmp_kernel_op_77;
             const real_t elMat_3_5 = tmp_kernel_op_12*tmp_kernel_op_67 + tmp_kernel_op_29*tmp_kernel_op_72 + tmp_kernel_op_46*tmp_kernel_op_77;
             const real_t elMat_4_0 = tmp_kernel_op_23*tmp_kernel_op_81 + tmp_kernel_op_40*tmp_kernel_op_83 + tmp_kernel_op_6*tmp_kernel_op_79;
             const real_t elMat_4_1 = tmp_kernel_op_26*tmp_kernel_op_81 + tmp_kernel_op_43*tmp_kernel_op_83 + tmp_kernel_op_79*tmp_kernel_op_9;
             const real_t elMat_4_2 = tmp_kernel_op_10*tmp_kernel_op_79 + tmp_kernel_op_27*tmp_kernel_op_81 + tmp_kernel_op_44*tmp_kernel_op_83;
             const real_t elMat_4_3 = tmp_kernel_op_1*tmp_kernel_op_79 + tmp_kernel_op_18*tmp_kernel_op_81 + tmp_kernel_op_35*tmp_kernel_op_83;
             const real_t elMat_4_4 = tmp_kernel_op_11*tmp_kernel_op_79 + tmp_kernel_op_28*tmp_kernel_op_81 + tmp_kernel_op_45*tmp_kernel_op_83;
             const real_t elMat_4_5 = tmp_kernel_op_12*tmp_kernel_op_79 + tmp_kernel_op_29*tmp_kernel_op_81 + tmp_kernel_op_46*tmp_kernel_op_83;
             const real_t elMat_5_0 = tmp_kernel_op_23*tmp_kernel_op_87 + tmp_kernel_op_40*tmp_kernel_op_89 + tmp_kernel_op_6*tmp_kernel_op_85;
             const real_t elMat_5_1 = tmp_kernel_op_26*tmp_kernel_op_87 + tmp_kernel_op_43*tmp_kernel_op_89 + tmp_kernel_op_85*tmp_kernel_op_9;
             const real_t elMat_5_2 = tmp_kernel_op_10*tmp_kernel_op_85 + tmp_kernel_op_27*tmp_kernel_op_87 + tmp_kernel_op_44*tmp_kernel_op_89;
             const real_t elMat_5_3 = tmp_kernel_op_1*tmp_kernel_op_85 + tmp_kernel_op_18*tmp_kernel_op_87 + tmp_kernel_op_35*tmp_kernel_op_89;
             const real_t elMat_5_4 = tmp_kernel_op_11*tmp_kernel_op_85 + tmp_kernel_op_28*tmp_kernel_op_87 + tmp_kernel_op_45*tmp_kernel_op_89;
             const real_t elMat_5_5 = tmp_kernel_op_12*tmp_kernel_op_85 + tmp_kernel_op_29*tmp_kernel_op_87 + tmp_kernel_op_46*tmp_kernel_op_89;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< real_t > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[3] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_1_0));
             _data_mat[7] = ((real_t)(elMat_1_1));
             _data_mat[8] = ((real_t)(elMat_1_2));
             _data_mat[9] = ((real_t)(elMat_1_3));
             _data_mat[10] = ((real_t)(elMat_1_4));
             _data_mat[11] = ((real_t)(elMat_1_5));
             _data_mat[12] = ((real_t)(elMat_2_0));
             _data_mat[13] = ((real_t)(elMat_2_1));
             _data_mat[14] = ((real_t)(elMat_2_2));
             _data_mat[15] = ((real_t)(elMat_2_3));
             _data_mat[16] = ((real_t)(elMat_2_4));
             _data_mat[17] = ((real_t)(elMat_2_5));
             _data_mat[18] = ((real_t)(elMat_3_0));
             _data_mat[19] = ((real_t)(elMat_3_1));
             _data_mat[20] = ((real_t)(elMat_3_2));
             _data_mat[21] = ((real_t)(elMat_3_3));
             _data_mat[22] = ((real_t)(elMat_3_4));
             _data_mat[23] = ((real_t)(elMat_3_5));
             _data_mat[24] = ((real_t)(elMat_4_0));
             _data_mat[25] = ((real_t)(elMat_4_1));
             _data_mat[26] = ((real_t)(elMat_4_2));
             _data_mat[27] = ((real_t)(elMat_4_3));
             _data_mat[28] = ((real_t)(elMat_4_4));
             _data_mat[29] = ((real_t)(elMat_4_5));
             _data_mat[30] = ((real_t)(elMat_5_0));
             _data_mat[31] = ((real_t)(elMat_5_1));
             _data_mat[32] = ((real_t)(elMat_5_2));
             _data_mat[33] = ((real_t)(elMat_5_3));
             _data_mat[34] = ((real_t)(elMat_5_4));
             _data_mat[35] = ((real_t)(elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       const real_t tmp_moved_constant_0 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_7;
       const real_t tmp_moved_constant_1 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_2 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_7;
       const real_t tmp_moved_constant_3 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_4 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_24;
       const real_t tmp_moved_constant_5 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_17;
       const real_t tmp_moved_constant_6 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_24;
       const real_t tmp_moved_constant_7 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_17;
       const real_t tmp_moved_constant_8 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_41;
       const real_t tmp_moved_constant_9 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_34;
       const real_t tmp_moved_constant_10 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_41;
       const real_t tmp_moved_constant_11 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_34;
       {
          /* FaceType.BLUE */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t delta_dof_0 = _data_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t delta_dof_1 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t delta_dof_2 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t delta_dof_3 = _data_deltaEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t delta_dof_4 = _data_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t delta_dof_5 = _data_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t ux_dof_3 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t uy_dof_3 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t tmp_kernel_op_13 = tmp_kernel_op_1*ux_dof_3 + tmp_kernel_op_10*ux_dof_2 + tmp_kernel_op_11*ux_dof_4 + tmp_kernel_op_12*ux_dof_5 + tmp_kernel_op_6*ux_dof_0 + tmp_kernel_op_9*ux_dof_1;
             const real_t tmp_kernel_op_14 = tmp_kernel_op_1*uy_dof_3 + tmp_kernel_op_10*uy_dof_2 + tmp_kernel_op_11*uy_dof_4 + tmp_kernel_op_12*uy_dof_5 + tmp_kernel_op_6*uy_dof_0 + tmp_kernel_op_9*uy_dof_1;
             const real_t tmp_kernel_op_15 = abs_det_jac_affine_BLUE*(delta_dof_0*tmp_kernel_op_6 + delta_dof_1*tmp_kernel_op_9 + delta_dof_2*tmp_kernel_op_10 + delta_dof_3*tmp_kernel_op_1 + delta_dof_4*tmp_kernel_op_11 + delta_dof_5*tmp_kernel_op_12)*0.16666666666666666;
             const real_t tmp_kernel_op_16 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_8 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_8) + tmp_kernel_op_14*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_8 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_8));
             const real_t tmp_kernel_op_30 = tmp_kernel_op_18*ux_dof_3 + tmp_kernel_op_23*ux_dof_0 + tmp_kernel_op_26*ux_dof_1 + tmp_kernel_op_27*ux_dof_2 + tmp_kernel_op_28*ux_dof_4 + tmp_kernel_op_29*ux_dof_5;
             const real_t tmp_kernel_op_31 = tmp_kernel_op_18*uy_dof_3 + tmp_kernel_op_23*uy_dof_0 + tmp_kernel_op_26*uy_dof_1 + tmp_kernel_op_27*uy_dof_2 + tmp_kernel_op_28*uy_dof_4 + tmp_kernel_op_29*uy_dof_5;
             const real_t tmp_kernel_op_32 = abs_det_jac_affine_BLUE*(delta_dof_0*tmp_kernel_op_23 + delta_dof_1*tmp_kernel_op_26 + delta_dof_2*tmp_kernel_op_27 + delta_dof_3*tmp_kernel_op_18 + delta_dof_4*tmp_kernel_op_28 + delta_dof_5*tmp_kernel_op_29)*0.16666666666666666;
             const real_t tmp_kernel_op_33 = tmp_kernel_op_32*(tmp_kernel_op_30*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_25 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_25) + tmp_kernel_op_31*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_25 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_25));
             const real_t tmp_kernel_op_47 = tmp_kernel_op_35*ux_dof_3 + tmp_kernel_op_40*ux_dof_0 + tmp_kernel_op_43*ux_dof_1 + tmp_kernel_op_44*ux_dof_2 + tmp_kernel_op_45*ux_dof_4 + tmp_kernel_op_46*ux_dof_5;
             const real_t tmp_kernel_op_48 = tmp_kernel_op_35*uy_dof_3 + tmp_kernel_op_40*uy_dof_0 + tmp_kernel_op_43*uy_dof_1 + tmp_kernel_op_44*uy_dof_2 + tmp_kernel_op_45*uy_dof_4 + tmp_kernel_op_46*uy_dof_5;
             const real_t tmp_kernel_op_49 = abs_det_jac_affine_BLUE*(delta_dof_0*tmp_kernel_op_40 + delta_dof_1*tmp_kernel_op_43 + delta_dof_2*tmp_kernel_op_44 + delta_dof_3*tmp_kernel_op_35 + delta_dof_4*tmp_kernel_op_45 + delta_dof_5*tmp_kernel_op_46)*0.16666666666666666;
             const real_t tmp_kernel_op_50 = tmp_kernel_op_49*(tmp_kernel_op_47*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_42 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_42) + tmp_kernel_op_48*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_42 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_42));
             const real_t tmp_kernel_op_52 = tmp_kernel_op_15*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_13*tmp_kernel_op_51 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_14*tmp_kernel_op_51);
             const real_t tmp_kernel_op_54 = tmp_kernel_op_32*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_30*tmp_kernel_op_53 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_31*tmp_kernel_op_53);
             const real_t tmp_kernel_op_56 = tmp_kernel_op_49*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_47*tmp_kernel_op_55 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_48*tmp_kernel_op_55);
             const real_t tmp_kernel_op_58 = tmp_kernel_op_15*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_13*tmp_kernel_op_57 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_14*tmp_kernel_op_57);
             const real_t tmp_kernel_op_60 = tmp_kernel_op_32*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_30*tmp_kernel_op_59 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_31*tmp_kernel_op_59);
             const real_t tmp_kernel_op_62 = tmp_kernel_op_49*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_47*tmp_kernel_op_61 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_48*tmp_kernel_op_61);
             const real_t tmp_kernel_op_67 = tmp_kernel_op_15*(tmp_kernel_op_13*(tmp_moved_constant_0 + tmp_moved_constant_1) + tmp_kernel_op_14*(tmp_moved_constant_2 + tmp_moved_constant_3));
             const real_t tmp_kernel_op_72 = tmp_kernel_op_32*(tmp_kernel_op_30*(tmp_moved_constant_4 + tmp_moved_constant_5) + tmp_kernel_op_31*(tmp_moved_constant_6 + tmp_moved_constant_7));
             const real_t tmp_kernel_op_77 = tmp_kernel_op_49*(tmp_kernel_op_47*(tmp_moved_constant_8 + tmp_moved_constant_9) + tmp_kernel_op_48*(tmp_moved_constant_10 + tmp_moved_constant_11));
             const real_t tmp_kernel_op_79 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_78 - tmp_moved_constant_0) + tmp_kernel_op_14*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_78 - tmp_moved_constant_2));
             const real_t tmp_kernel_op_81 = tmp_kernel_op_32*(tmp_kernel_op_30*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_80 - tmp_moved_constant_4) + tmp_kernel_op_31*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_80 - tmp_moved_constant_6));
             const real_t tmp_kernel_op_83 = tmp_kernel_op_49*(tmp_kernel_op_47*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_82 - tmp_moved_constant_8) + tmp_kernel_op_48*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_82 - tmp_moved_constant_10));
             const real_t tmp_kernel_op_85 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_84 - tmp_moved_constant_1) + tmp_kernel_op_14*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_84 - tmp_moved_constant_3));
             const real_t tmp_kernel_op_87 = tmp_kernel_op_32*(tmp_kernel_op_30*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_86 - tmp_moved_constant_5) + tmp_kernel_op_31*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_86 - tmp_moved_constant_7));
             const real_t tmp_kernel_op_89 = tmp_kernel_op_49*(tmp_kernel_op_47*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_88 - tmp_moved_constant_9) + tmp_kernel_op_48*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_88 - tmp_moved_constant_11));
             const real_t elMat_0_0 = tmp_kernel_op_16*tmp_kernel_op_6 + tmp_kernel_op_23*tmp_kernel_op_33 + tmp_kernel_op_40*tmp_kernel_op_50;
             const real_t elMat_0_1 = tmp_kernel_op_16*tmp_kernel_op_9 + tmp_kernel_op_26*tmp_kernel_op_33 + tmp_kernel_op_43*tmp_kernel_op_50;
             const real_t elMat_0_2 = tmp_kernel_op_10*tmp_kernel_op_16 + tmp_kernel_op_27*tmp_kernel_op_33 + tmp_kernel_op_44*tmp_kernel_op_50;
             const real_t elMat_0_3 = tmp_kernel_op_1*tmp_kernel_op_16 + tmp_kernel_op_18*tmp_kernel_op_33 + tmp_kernel_op_35*tmp_kernel_op_50;
             const real_t elMat_0_4 = tmp_kernel_op_11*tmp_kernel_op_16 + tmp_kernel_op_28*tmp_kernel_op_33 + tmp_kernel_op_45*tmp_kernel_op_50;
             const real_t elMat_0_5 = tmp_kernel_op_12*tmp_kernel_op_16 + tmp_kernel_op_29*tmp_kernel_op_33 + tmp_kernel_op_46*tmp_kernel_op_50;
             const real_t elMat_1_0 = tmp_kernel_op_23*tmp_kernel_op_54 + tmp_kernel_op_40*tmp_kernel_op_56 + tmp_kernel_op_52*tmp_kernel_op_6;
             const real_t elMat_1_1 = tmp_kernel_op_26*tmp_kernel_op_54 + tmp_kernel_op_43*tmp_kernel_op_56 + tmp_kernel_op_52*tmp_kernel_op_9;
             const real_t elMat_1_2 = tmp_kernel_op_10*tmp_kernel_op_52 + tmp_kernel_op_27*tmp_kernel_op_54 + tmp_kernel_op_44*tmp_kernel_op_56;
             const real_t elMat_1_3 = tmp_kernel_op_1*tmp_kernel_op_52 + tmp_kernel_op_18*tmp_kernel_op_54 + tmp_kernel_op_35*tmp_kernel_op_56;
             const real_t elMat_1_4 = tmp_kernel_op_11*tmp_kernel_op_52 + tmp_kernel_op_28*tmp_kernel_op_54 + tmp_kernel_op_45*tmp_kernel_op_56;
             const real_t elMat_1_5 = tmp_kernel_op_12*tmp_kernel_op_52 + tmp_kernel_op_29*tmp_kernel_op_54 + tmp_kernel_op_46*tmp_kernel_op_56;
             const real_t elMat_2_0 = tmp_kernel_op_23*tmp_kernel_op_60 + tmp_kernel_op_40*tmp_kernel_op_62 + tmp_kernel_op_58*tmp_kernel_op_6;
             const real_t elMat_2_1 = tmp_kernel_op_26*tmp_kernel_op_60 + tmp_kernel_op_43*tmp_kernel_op_62 + tmp_kernel_op_58*tmp_kernel_op_9;
             const real_t elMat_2_2 = tmp_kernel_op_10*tmp_kernel_op_58 + tmp_kernel_op_27*tmp_kernel_op_60 + tmp_kernel_op_44*tmp_kernel_op_62;
             const real_t elMat_2_3 = tmp_kernel_op_1*tmp_kernel_op_58 + tmp_kernel_op_18*tmp_kernel_op_60 + tmp_kernel_op_35*tmp_kernel_op_62;
             const real_t elMat_2_4 = tmp_kernel_op_11*tmp_kernel_op_58 + tmp_kernel_op_28*tmp_kernel_op_60 + tmp_kernel_op_45*tmp_kernel_op_62;
             const real_t elMat_2_5 = tmp_kernel_op_12*tmp_kernel_op_58 + tmp_kernel_op_29*tmp_kernel_op_60 + tmp_kernel_op_46*tmp_kernel_op_62;
             const real_t elMat_3_0 = tmp_kernel_op_23*tmp_kernel_op_72 + tmp_kernel_op_40*tmp_kernel_op_77 + tmp_kernel_op_6*tmp_kernel_op_67;
             const real_t elMat_3_1 = tmp_kernel_op_26*tmp_kernel_op_72 + tmp_kernel_op_43*tmp_kernel_op_77 + tmp_kernel_op_67*tmp_kernel_op_9;
             const real_t elMat_3_2 = tmp_kernel_op_10*tmp_kernel_op_67 + tmp_kernel_op_27*tmp_kernel_op_72 + tmp_kernel_op_44*tmp_kernel_op_77;
             const real_t elMat_3_3 = tmp_kernel_op_1*tmp_kernel_op_67 + tmp_kernel_op_18*tmp_kernel_op_72 + tmp_kernel_op_35*tmp_kernel_op_77;
             const real_t elMat_3_4 = tmp_kernel_op_11*tmp_kernel_op_67 + tmp_kernel_op_28*tmp_kernel_op_72 + tmp_kernel_op_45*tmp_kernel_op_77;
             const real_t elMat_3_5 = tmp_kernel_op_12*tmp_kernel_op_67 + tmp_kernel_op_29*tmp_kernel_op_72 + tmp_kernel_op_46*tmp_kernel_op_77;
             const real_t elMat_4_0 = tmp_kernel_op_23*tmp_kernel_op_81 + tmp_kernel_op_40*tmp_kernel_op_83 + tmp_kernel_op_6*tmp_kernel_op_79;
             const real_t elMat_4_1 = tmp_kernel_op_26*tmp_kernel_op_81 + tmp_kernel_op_43*tmp_kernel_op_83 + tmp_kernel_op_79*tmp_kernel_op_9;
             const real_t elMat_4_2 = tmp_kernel_op_10*tmp_kernel_op_79 + tmp_kernel_op_27*tmp_kernel_op_81 + tmp_kernel_op_44*tmp_kernel_op_83;
             const real_t elMat_4_3 = tmp_kernel_op_1*tmp_kernel_op_79 + tmp_kernel_op_18*tmp_kernel_op_81 + tmp_kernel_op_35*tmp_kernel_op_83;
             const real_t elMat_4_4 = tmp_kernel_op_11*tmp_kernel_op_79 + tmp_kernel_op_28*tmp_kernel_op_81 + tmp_kernel_op_45*tmp_kernel_op_83;
             const real_t elMat_4_5 = tmp_kernel_op_12*tmp_kernel_op_79 + tmp_kernel_op_29*tmp_kernel_op_81 + tmp_kernel_op_46*tmp_kernel_op_83;
             const real_t elMat_5_0 = tmp_kernel_op_23*tmp_kernel_op_87 + tmp_kernel_op_40*tmp_kernel_op_89 + tmp_kernel_op_6*tmp_kernel_op_85;
             const real_t elMat_5_1 = tmp_kernel_op_26*tmp_kernel_op_87 + tmp_kernel_op_43*tmp_kernel_op_89 + tmp_kernel_op_85*tmp_kernel_op_9;
             const real_t elMat_5_2 = tmp_kernel_op_10*tmp_kernel_op_85 + tmp_kernel_op_27*tmp_kernel_op_87 + tmp_kernel_op_44*tmp_kernel_op_89;
             const real_t elMat_5_3 = tmp_kernel_op_1*tmp_kernel_op_85 + tmp_kernel_op_18*tmp_kernel_op_87 + tmp_kernel_op_35*tmp_kernel_op_89;
             const real_t elMat_5_4 = tmp_kernel_op_11*tmp_kernel_op_85 + tmp_kernel_op_28*tmp_kernel_op_87 + tmp_kernel_op_45*tmp_kernel_op_89;
             const real_t elMat_5_5 = tmp_kernel_op_12*tmp_kernel_op_85 + tmp_kernel_op_29*tmp_kernel_op_87 + tmp_kernel_op_46*tmp_kernel_op_89;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< real_t > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_1_0));
             _data_mat[7] = ((real_t)(elMat_1_1));
             _data_mat[8] = ((real_t)(elMat_1_2));
             _data_mat[9] = ((real_t)(elMat_1_3));
             _data_mat[10] = ((real_t)(elMat_1_4));
             _data_mat[11] = ((real_t)(elMat_1_5));
             _data_mat[12] = ((real_t)(elMat_2_0));
             _data_mat[13] = ((real_t)(elMat_2_1));
             _data_mat[14] = ((real_t)(elMat_2_2));
             _data_mat[15] = ((real_t)(elMat_2_3));
             _data_mat[16] = ((real_t)(elMat_2_4));
             _data_mat[17] = ((real_t)(elMat_2_5));
             _data_mat[18] = ((real_t)(elMat_3_0));
             _data_mat[19] = ((real_t)(elMat_3_1));
             _data_mat[20] = ((real_t)(elMat_3_2));
             _data_mat[21] = ((real_t)(elMat_3_3));
             _data_mat[22] = ((real_t)(elMat_3_4));
             _data_mat[23] = ((real_t)(elMat_3_5));
             _data_mat[24] = ((real_t)(elMat_4_0));
             _data_mat[25] = ((real_t)(elMat_4_1));
             _data_mat[26] = ((real_t)(elMat_4_2));
             _data_mat[27] = ((real_t)(elMat_4_3));
             _data_mat[28] = ((real_t)(elMat_4_4));
             _data_mat[29] = ((real_t)(elMat_4_5));
             _data_mat[30] = ((real_t)(elMat_5_0));
             _data_mat[31] = ((real_t)(elMat_5_1));
             _data_mat[32] = ((real_t)(elMat_5_2));
             _data_mat[33] = ((real_t)(elMat_5_3));
             _data_mat[34] = ((real_t)(elMat_5_4));
             _data_mat[35] = ((real_t)(elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
