/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2ElementwiseAdvection.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseAdvection::apply_P2ElementwiseAdvection_macro_2D( real_t * RESTRICT  _data_cpEdge, real_t * RESTRICT  _data_cpVertex, real_t * RESTRICT  _data_dstEdge, real_t * RESTRICT  _data_dstVertex, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t * RESTRICT  _data_uxEdge, real_t * RESTRICT  _data_uxVertex, real_t * RESTRICT  _data_uyEdge, real_t * RESTRICT  _data_uyVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       const real_t tmp_kernel_op_0 = 1.3333333333333333;
       const real_t tmp_kernel_op_1 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_2 = tmp_kernel_op_0*0.33333333333333331;
       const real_t tmp_kernel_op_3 = 0.1111111111111111;
       const real_t tmp_kernel_op_4 = tmp_kernel_op_3*2.0;
       const real_t tmp_kernel_op_5 = tmp_kernel_op_4 - 0.33333333333333331;
       const real_t tmp_kernel_op_6 = 0.1111111111111111;
       const real_t tmp_kernel_op_7 = tmp_kernel_op_6*2.0;
       const real_t tmp_kernel_op_8 = tmp_kernel_op_7 - 0.33333333333333331;
       const real_t tmp_kernel_op_9 = 1.3333333333333333;
       const real_t tmp_kernel_op_10 = -tmp_kernel_op_2 + tmp_kernel_op_6*-4.0 + tmp_kernel_op_9;
       const real_t tmp_kernel_op_11 = tmp_kernel_op_0 - tmp_kernel_op_2 + tmp_kernel_op_3*-4.0;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_2 + tmp_kernel_op_4 + tmp_kernel_op_7 - 1.0;
       const real_t tmp_kernel_op_18 = 0.80000000000000004;
       const real_t tmp_kernel_op_19 = tmp_kernel_op_18 - 1.0;
       const real_t tmp_kernel_op_20 = tmp_kernel_op_18*0.59999999999999998;
       const real_t tmp_kernel_op_21 = 0.040000000000000008;
       const real_t tmp_kernel_op_22 = tmp_kernel_op_21*2.0;
       const real_t tmp_kernel_op_23 = tmp_kernel_op_22 - 0.20000000000000001;
       const real_t tmp_kernel_op_24 = 0.35999999999999999;
       const real_t tmp_kernel_op_25 = tmp_kernel_op_24*2.0;
       const real_t tmp_kernel_op_26 = tmp_kernel_op_25 - 0.59999999999999998;
       const real_t tmp_kernel_op_27 = 2.3999999999999999;
       const real_t tmp_kernel_op_28 = -tmp_kernel_op_20 + tmp_kernel_op_24*-4.0 + tmp_kernel_op_27;
       const real_t tmp_kernel_op_29 = tmp_kernel_op_18 - tmp_kernel_op_20 + tmp_kernel_op_21*-4.0;
       const real_t tmp_kernel_op_30 = tmp_kernel_op_20 + tmp_kernel_op_22 + tmp_kernel_op_25 - 1.3999999999999999;
       const real_t tmp_kernel_op_36 = 2.3999999999999999;
       const real_t tmp_kernel_op_37 = tmp_kernel_op_36 - 1.0;
       const real_t tmp_kernel_op_38 = tmp_kernel_op_36*0.20000000000000001;
       const real_t tmp_kernel_op_39 = 0.35999999999999999;
       const real_t tmp_kernel_op_40 = tmp_kernel_op_39*2.0;
       const real_t tmp_kernel_op_41 = tmp_kernel_op_40 - 0.59999999999999998;
       const real_t tmp_kernel_op_42 = 0.040000000000000008;
       const real_t tmp_kernel_op_43 = tmp_kernel_op_42*2.0;
       const real_t tmp_kernel_op_44 = tmp_kernel_op_43 - 0.20000000000000001;
       const real_t tmp_kernel_op_45 = 0.80000000000000004;
       const real_t tmp_kernel_op_46 = -tmp_kernel_op_38 + tmp_kernel_op_42*-4.0 + tmp_kernel_op_45;
       const real_t tmp_kernel_op_47 = tmp_kernel_op_36 - tmp_kernel_op_38 + tmp_kernel_op_39*-4.0;
       const real_t tmp_kernel_op_48 = tmp_kernel_op_38 + tmp_kernel_op_40 + tmp_kernel_op_43 - 1.3999999999999999;
       const real_t tmp_kernel_op_54 = 0.80000000000000004;
       const real_t tmp_kernel_op_55 = tmp_kernel_op_54 - 1.0;
       const real_t tmp_kernel_op_56 = tmp_kernel_op_54*0.20000000000000001;
       const real_t tmp_kernel_op_57 = 0.040000000000000008;
       const real_t tmp_kernel_op_58 = tmp_kernel_op_57*2.0;
       const real_t tmp_kernel_op_59 = tmp_kernel_op_58 - 0.20000000000000001;
       const real_t tmp_kernel_op_60 = 0.040000000000000008;
       const real_t tmp_kernel_op_61 = tmp_kernel_op_60*2.0;
       const real_t tmp_kernel_op_62 = tmp_kernel_op_61 - 0.20000000000000001;
       const real_t tmp_kernel_op_63 = 0.80000000000000004;
       const real_t tmp_kernel_op_64 = -tmp_kernel_op_56 + tmp_kernel_op_60*-4.0 + tmp_kernel_op_63;
       const real_t tmp_kernel_op_65 = tmp_kernel_op_54 - tmp_kernel_op_56 + tmp_kernel_op_57*-4.0;
       const real_t tmp_kernel_op_66 = tmp_kernel_op_56 + tmp_kernel_op_58 + tmp_kernel_op_61 - 0.20000000000000018;
       const real_t tmp_kernel_op_72 = tmp_kernel_op_9 - 1.0;
       const real_t tmp_kernel_op_74 = tmp_kernel_op_27 - 1.0;
       const real_t tmp_kernel_op_76 = tmp_kernel_op_45 - 1.0;
       const real_t tmp_kernel_op_78 = tmp_kernel_op_63 - 1.0;
       const real_t tmp_kernel_op_80 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_9;
       const real_t tmp_kernel_op_81 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_82 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_9;
       const real_t tmp_kernel_op_83 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_85 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_27;
       const real_t tmp_kernel_op_86 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_18;
       const real_t tmp_kernel_op_87 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_27;
       const real_t tmp_kernel_op_88 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_18;
       const real_t tmp_kernel_op_90 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_45;
       const real_t tmp_kernel_op_91 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_36;
       const real_t tmp_kernel_op_92 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_45;
       const real_t tmp_kernel_op_93 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_36;
       const real_t tmp_kernel_op_95 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_63;
       const real_t tmp_kernel_op_96 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_54;
       const real_t tmp_kernel_op_97 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_63;
       const real_t tmp_kernel_op_98 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_54;
       const real_t tmp_kernel_op_100 = -tmp_kernel_op_0 + 1.3333333333333335;
       const real_t tmp_kernel_op_102 = -tmp_kernel_op_18 - 0.79999999999999982;
       const real_t tmp_kernel_op_104 = -tmp_kernel_op_36 + 2.3999999999999999;
       const real_t tmp_kernel_op_106 = -tmp_kernel_op_54 + 2.3999999999999999;
       const real_t tmp_kernel_op_108 = -tmp_kernel_op_9 + 1.3333333333333335;
       const real_t tmp_kernel_op_110 = -tmp_kernel_op_27 + 2.3999999999999999;
       const real_t tmp_kernel_op_112 = -tmp_kernel_op_45 - 0.79999999999999982;
       const real_t tmp_kernel_op_114 = -tmp_kernel_op_63 + 2.3999999999999999;
       const real_t tmp_kernel_op_116 = tmp_kernel_op_0 + tmp_kernel_op_9 - 3.0;
       const real_t tmp_kernel_op_118 = tmp_kernel_op_18 + tmp_kernel_op_27 - 3.0;
       const real_t tmp_kernel_op_120 = tmp_kernel_op_36 + tmp_kernel_op_45 - 3.0;
       const real_t tmp_kernel_op_122 = tmp_kernel_op_54 + tmp_kernel_op_63 - 3.0;
       {
          /* FaceType.GRAY */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d cp_dof_0 = _mm256_loadu_pd(& _data_cpVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d cp_dof_1 = _mm256_loadu_pd(& _data_cpVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d cp_dof_2 = _mm256_loadu_pd(& _data_cpVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d cp_dof_3 = _mm256_loadu_pd(& _data_cpEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d cp_dof_4 = _mm256_loadu_pd(& _data_cpEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d cp_dof_5 = _mm256_loadu_pd(& _data_cpEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d ux_dof_0 = _mm256_loadu_pd(& _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d ux_dof_1 = _mm256_loadu_pd(& _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d ux_dof_2 = _mm256_loadu_pd(& _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d ux_dof_3 = _mm256_loadu_pd(& _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d ux_dof_4 = _mm256_loadu_pd(& _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d ux_dof_5 = _mm256_loadu_pd(& _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d uy_dof_0 = _mm256_loadu_pd(& _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d uy_dof_1 = _mm256_loadu_pd(& _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d uy_dof_2 = _mm256_loadu_pd(& _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d uy_dof_3 = _mm256_loadu_pd(& _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d uy_dof_4 = _mm256_loadu_pd(& _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d uy_dof_5 = _mm256_loadu_pd(& _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d tmp_kernel_op_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(ux_dof_4,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(ux_dof_5,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(ux_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(ux_dof_3,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(ux_dof_1,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_mul_pd(ux_dof_2,_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8)));
                const __m256d tmp_kernel_op_14 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(uy_dof_4,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(uy_dof_5,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(uy_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(uy_dof_3,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(uy_dof_1,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_mul_pd(uy_dof_2,_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8)));
                const __m256d tmp_kernel_op_15 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_14,_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)));
                const __m256d tmp_kernel_op_16 = _mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(cp_dof_4,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(cp_dof_5,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(cp_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(cp_dof_3,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(cp_dof_1,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_mul_pd(cp_dof_2,_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))),_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY));
                const __m256d tmp_kernel_op_17 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12));
                const __m256d tmp_kernel_op_31 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(ux_dof_3,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)),_mm256_mul_pd(ux_dof_1,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23))),_mm256_mul_pd(ux_dof_2,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(ux_dof_4,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_mul_pd(ux_dof_5,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(ux_dof_0,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(uy_dof_3,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)),_mm256_mul_pd(uy_dof_1,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23))),_mm256_mul_pd(uy_dof_2,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(uy_dof_4,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_mul_pd(uy_dof_5,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(uy_dof_0,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)));
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY)),_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY)),_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)));
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(cp_dof_3,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)),_mm256_mul_pd(cp_dof_1,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23))),_mm256_mul_pd(cp_dof_2,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(cp_dof_4,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_mul_pd(cp_dof_5,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(cp_dof_0,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY));
                const __m256d tmp_kernel_op_35 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(ux_dof_3,_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38)),_mm256_mul_pd(ux_dof_1,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41))),_mm256_mul_pd(ux_dof_2,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(ux_dof_4,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(ux_dof_5,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(ux_dof_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(uy_dof_3,_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38)),_mm256_mul_pd(uy_dof_1,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41))),_mm256_mul_pd(uy_dof_2,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(uy_dof_4,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(uy_dof_5,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(uy_dof_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48)));
                const __m256d tmp_kernel_op_51 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_49,_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37)));
                const __m256d tmp_kernel_op_52 = _mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(cp_dof_3,_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38)),_mm256_mul_pd(cp_dof_1,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41))),_mm256_mul_pd(cp_dof_2,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(cp_dof_4,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(cp_dof_5,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(cp_dof_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY));
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48));
                const __m256d tmp_kernel_op_67 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(ux_dof_3,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(ux_dof_1,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(ux_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(ux_dof_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(ux_dof_5,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(ux_dof_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_68 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(uy_dof_3,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(uy_dof_1,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(uy_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(uy_dof_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(uy_dof_5,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(uy_dof_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_69 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY)),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY)),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)));
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(cp_dof_3,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(cp_dof_1,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(cp_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(cp_dof_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(cp_dof_5,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(cp_dof_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66))),_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY,abs_det_jac_affine_GRAY));
                const __m256d tmp_kernel_op_71 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66));
                const __m256d tmp_kernel_op_73 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY)),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_14,_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY)),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)));
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY)),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY)),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)));
                const __m256d tmp_kernel_op_77 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_49,_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY)),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY)),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)));
                const __m256d tmp_kernel_op_79 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY)),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY)),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78)));
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))));
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85),_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86))),_mm256_mul_pd(tmp_kernel_op_32,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87),_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88))));
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_49,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92),_mm256_set_pd(tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93))));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95),_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97),_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))));
                const __m256d tmp_kernel_op_101 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)))));
                const __m256d tmp_kernel_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)))),_mm256_mul_pd(tmp_kernel_op_32,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)))));
                const __m256d tmp_kernel_op_105 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_49,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)))));
                const __m256d tmp_kernel_op_107 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106)))));
                const __m256d tmp_kernel_op_109 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)))));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)))),_mm256_mul_pd(tmp_kernel_op_32,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)))));
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_49,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112)))));
                const __m256d tmp_kernel_op_115 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114)))));
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)))));
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118)))),_mm256_mul_pd(tmp_kernel_op_32,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118)))));
                const __m256d tmp_kernel_op_121 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_49,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120)))));
                const __m256d tmp_kernel_op_123 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122)))));
                const __m256d tmp_kernel_op_124 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5));
                const __m256d tmp_kernel_op_125 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23));
                const __m256d tmp_kernel_op_126 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41));
                const __m256d tmp_kernel_op_127 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59));
                const __m256d tmp_kernel_op_128 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8));
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44));
                const __m256d tmp_kernel_op_131 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62));
                const __m256d tmp_kernel_op_132 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_133 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20));
                const __m256d tmp_kernel_op_134 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38));
                const __m256d tmp_kernel_op_135 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10));
                const __m256d tmp_kernel_op_137 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28));
                const __m256d tmp_kernel_op_138 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46));
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64));
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_141 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29));
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47));
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_17),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_35)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_53)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_71))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_17),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_35)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_53)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_17),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_35)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_53)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,tmp_kernel_op_17),_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35)),_mm256_mul_pd(tmp_kernel_op_51,tmp_kernel_op_53)),_mm256_mul_pd(tmp_kernel_op_69,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_53,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_53,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_99))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_124),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_125)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_126)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_127))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_124),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_125)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_126)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_127)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_124),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_125)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_126)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_127)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_15),_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_33)),_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_51)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_69)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_99))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_128),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_129)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_130)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_131))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_128),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_129)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_130)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_131)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_128),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_129)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_130)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_131)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_15),_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_33)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_51)),_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_69)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_99))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_133)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_134)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_135))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_133)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_134)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_135)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_133)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_134)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_135)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_15),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_33)),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_51)),_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_69)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_99))));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_136),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_137)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_138)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_139))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_136),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_137)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_138)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_139)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_136),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_137)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_138)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_139)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_15),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_33)),_mm256_mul_pd(tmp_kernel_op_138,tmp_kernel_op_51)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_69)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_138,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_138,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_99))));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_140),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_141)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_142)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_143))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_140),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_141)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_142)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_143)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_140),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_141)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_142)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_143)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_15),_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_33)),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_51)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_69)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_99))));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_3 = _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t cp_dof_0 = _data_cpVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t cp_dof_1 = _data_cpVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t cp_dof_2 = _data_cpVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t cp_dof_3 = _data_cpEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t cp_dof_4 = _data_cpEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t cp_dof_5 = _data_cpEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t ux_dof_1 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t ux_dof_3 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t uy_dof_1 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t uy_dof_3 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t tmp_kernel_op_13 = tmp_kernel_op_10*ux_dof_4 + tmp_kernel_op_11*ux_dof_5 + tmp_kernel_op_12*ux_dof_0 + tmp_kernel_op_2*ux_dof_3 + tmp_kernel_op_5*ux_dof_1 + tmp_kernel_op_8*ux_dof_2;
                const real_t tmp_kernel_op_14 = tmp_kernel_op_10*uy_dof_4 + tmp_kernel_op_11*uy_dof_5 + tmp_kernel_op_12*uy_dof_0 + tmp_kernel_op_2*uy_dof_3 + tmp_kernel_op_5*uy_dof_1 + tmp_kernel_op_8*uy_dof_2;
                const real_t tmp_kernel_op_15 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_1*tmp_kernel_op_13 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_1*tmp_kernel_op_14;
                const real_t tmp_kernel_op_16 = abs_det_jac_affine_GRAY*(cp_dof_0*tmp_kernel_op_12 + cp_dof_1*tmp_kernel_op_5 + cp_dof_2*tmp_kernel_op_8 + cp_dof_3*tmp_kernel_op_2 + cp_dof_4*tmp_kernel_op_10 + cp_dof_5*tmp_kernel_op_11)*-0.28125;
                const real_t tmp_kernel_op_17 = tmp_kernel_op_12*tmp_kernel_op_16;
                const real_t tmp_kernel_op_31 = tmp_kernel_op_20*ux_dof_3 + tmp_kernel_op_23*ux_dof_1 + tmp_kernel_op_26*ux_dof_2 + tmp_kernel_op_28*ux_dof_4 + tmp_kernel_op_29*ux_dof_5 + tmp_kernel_op_30*ux_dof_0;
                const real_t tmp_kernel_op_32 = tmp_kernel_op_20*uy_dof_3 + tmp_kernel_op_23*uy_dof_1 + tmp_kernel_op_26*uy_dof_2 + tmp_kernel_op_28*uy_dof_4 + tmp_kernel_op_29*uy_dof_5 + tmp_kernel_op_30*uy_dof_0;
                const real_t tmp_kernel_op_33 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_19*tmp_kernel_op_31 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_19*tmp_kernel_op_32;
                const real_t tmp_kernel_op_34 = abs_det_jac_affine_GRAY*(cp_dof_0*tmp_kernel_op_30 + cp_dof_1*tmp_kernel_op_23 + cp_dof_2*tmp_kernel_op_26 + cp_dof_3*tmp_kernel_op_20 + cp_dof_4*tmp_kernel_op_28 + cp_dof_5*tmp_kernel_op_29)*0.26041666666666669;
                const real_t tmp_kernel_op_35 = tmp_kernel_op_30*tmp_kernel_op_34;
                const real_t tmp_kernel_op_49 = tmp_kernel_op_38*ux_dof_3 + tmp_kernel_op_41*ux_dof_1 + tmp_kernel_op_44*ux_dof_2 + tmp_kernel_op_46*ux_dof_4 + tmp_kernel_op_47*ux_dof_5 + tmp_kernel_op_48*ux_dof_0;
                const real_t tmp_kernel_op_50 = tmp_kernel_op_38*uy_dof_3 + tmp_kernel_op_41*uy_dof_1 + tmp_kernel_op_44*uy_dof_2 + tmp_kernel_op_46*uy_dof_4 + tmp_kernel_op_47*uy_dof_5 + tmp_kernel_op_48*uy_dof_0;
                const real_t tmp_kernel_op_51 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_37*tmp_kernel_op_49 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_37*tmp_kernel_op_50;
                const real_t tmp_kernel_op_52 = abs_det_jac_affine_GRAY*(cp_dof_0*tmp_kernel_op_48 + cp_dof_1*tmp_kernel_op_41 + cp_dof_2*tmp_kernel_op_44 + cp_dof_3*tmp_kernel_op_38 + cp_dof_4*tmp_kernel_op_46 + cp_dof_5*tmp_kernel_op_47)*0.26041666666666669;
                const real_t tmp_kernel_op_53 = tmp_kernel_op_48*tmp_kernel_op_52;
                const real_t tmp_kernel_op_67 = tmp_kernel_op_56*ux_dof_3 + tmp_kernel_op_59*ux_dof_1 + tmp_kernel_op_62*ux_dof_2 + tmp_kernel_op_64*ux_dof_4 + tmp_kernel_op_65*ux_dof_5 + tmp_kernel_op_66*ux_dof_0;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_56*uy_dof_3 + tmp_kernel_op_59*uy_dof_1 + tmp_kernel_op_62*uy_dof_2 + tmp_kernel_op_64*uy_dof_4 + tmp_kernel_op_65*uy_dof_5 + tmp_kernel_op_66*uy_dof_0;
                const real_t tmp_kernel_op_69 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_55*tmp_kernel_op_67 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_55*tmp_kernel_op_68;
                const real_t tmp_kernel_op_70 = abs_det_jac_affine_GRAY*(cp_dof_0*tmp_kernel_op_66 + cp_dof_1*tmp_kernel_op_59 + cp_dof_2*tmp_kernel_op_62 + cp_dof_3*tmp_kernel_op_56 + cp_dof_4*tmp_kernel_op_64 + cp_dof_5*tmp_kernel_op_65)*0.26041666666666669;
                const real_t tmp_kernel_op_71 = tmp_kernel_op_66*tmp_kernel_op_70;
                const real_t tmp_kernel_op_73 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_13*tmp_kernel_op_72 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_14*tmp_kernel_op_72;
                const real_t tmp_kernel_op_75 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_31*tmp_kernel_op_74 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_32*tmp_kernel_op_74;
                const real_t tmp_kernel_op_77 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_49*tmp_kernel_op_76 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_50*tmp_kernel_op_76;
                const real_t tmp_kernel_op_79 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_67*tmp_kernel_op_78 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_68*tmp_kernel_op_78;
                const real_t tmp_kernel_op_84 = tmp_kernel_op_13*(tmp_kernel_op_80 + tmp_kernel_op_81) + tmp_kernel_op_14*(tmp_kernel_op_82 + tmp_kernel_op_83);
                const real_t tmp_kernel_op_89 = tmp_kernel_op_31*(tmp_kernel_op_85 + tmp_kernel_op_86) + tmp_kernel_op_32*(tmp_kernel_op_87 + tmp_kernel_op_88);
                const real_t tmp_kernel_op_94 = tmp_kernel_op_49*(tmp_kernel_op_90 + tmp_kernel_op_91) + tmp_kernel_op_50*(tmp_kernel_op_92 + tmp_kernel_op_93);
                const real_t tmp_kernel_op_99 = tmp_kernel_op_67*(tmp_kernel_op_95 + tmp_kernel_op_96) + tmp_kernel_op_68*(tmp_kernel_op_97 + tmp_kernel_op_98);
                const real_t tmp_kernel_op_101 = tmp_kernel_op_13*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_100 - tmp_kernel_op_80) + tmp_kernel_op_14*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_100 - tmp_kernel_op_82);
                const real_t tmp_kernel_op_103 = tmp_kernel_op_31*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_102 - tmp_kernel_op_85) + tmp_kernel_op_32*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_102 - tmp_kernel_op_87);
                const real_t tmp_kernel_op_105 = tmp_kernel_op_49*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_104 - tmp_kernel_op_90) + tmp_kernel_op_50*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_104 - tmp_kernel_op_92);
                const real_t tmp_kernel_op_107 = tmp_kernel_op_67*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_106 - tmp_kernel_op_95) + tmp_kernel_op_68*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_106 - tmp_kernel_op_97);
                const real_t tmp_kernel_op_109 = tmp_kernel_op_13*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_108 - tmp_kernel_op_81) + tmp_kernel_op_14*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_108 - tmp_kernel_op_83);
                const real_t tmp_kernel_op_111 = tmp_kernel_op_31*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_110 - tmp_kernel_op_86) + tmp_kernel_op_32*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_110 - tmp_kernel_op_88);
                const real_t tmp_kernel_op_113 = tmp_kernel_op_49*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_112 - tmp_kernel_op_91) + tmp_kernel_op_50*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_112 - tmp_kernel_op_93);
                const real_t tmp_kernel_op_115 = tmp_kernel_op_67*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_114 - tmp_kernel_op_96) + tmp_kernel_op_68*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_114 - tmp_kernel_op_98);
                const real_t tmp_kernel_op_117 = tmp_kernel_op_13*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_116 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_116) + tmp_kernel_op_14*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_116 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_116);
                const real_t tmp_kernel_op_119 = tmp_kernel_op_31*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_118 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_118) + tmp_kernel_op_32*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_118 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_118);
                const real_t tmp_kernel_op_121 = tmp_kernel_op_49*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_120 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_120) + tmp_kernel_op_50*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_120 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_120);
                const real_t tmp_kernel_op_123 = tmp_kernel_op_67*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_122 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_122) + tmp_kernel_op_68*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_122 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_122);
                const real_t tmp_kernel_op_124 = tmp_kernel_op_16*tmp_kernel_op_5;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_23*tmp_kernel_op_34;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_41*tmp_kernel_op_52;
                const real_t tmp_kernel_op_127 = tmp_kernel_op_59*tmp_kernel_op_70;
                const real_t tmp_kernel_op_128 = tmp_kernel_op_16*tmp_kernel_op_8;
                const real_t tmp_kernel_op_129 = tmp_kernel_op_26*tmp_kernel_op_34;
                const real_t tmp_kernel_op_130 = tmp_kernel_op_44*tmp_kernel_op_52;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_62*tmp_kernel_op_70;
                const real_t tmp_kernel_op_132 = tmp_kernel_op_16*tmp_kernel_op_2;
                const real_t tmp_kernel_op_133 = tmp_kernel_op_20*tmp_kernel_op_34;
                const real_t tmp_kernel_op_134 = tmp_kernel_op_38*tmp_kernel_op_52;
                const real_t tmp_kernel_op_135 = tmp_kernel_op_56*tmp_kernel_op_70;
                const real_t tmp_kernel_op_136 = tmp_kernel_op_10*tmp_kernel_op_16;
                const real_t tmp_kernel_op_137 = tmp_kernel_op_28*tmp_kernel_op_34;
                const real_t tmp_kernel_op_138 = tmp_kernel_op_46*tmp_kernel_op_52;
                const real_t tmp_kernel_op_139 = tmp_kernel_op_64*tmp_kernel_op_70;
                const real_t tmp_kernel_op_140 = tmp_kernel_op_11*tmp_kernel_op_16;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_29*tmp_kernel_op_34;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_47*tmp_kernel_op_52;
                const real_t tmp_kernel_op_143 = tmp_kernel_op_65*tmp_kernel_op_70;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_17 + tmp_kernel_op_119*tmp_kernel_op_35 + tmp_kernel_op_121*tmp_kernel_op_53 + tmp_kernel_op_123*tmp_kernel_op_71) + src_dof_1*(tmp_kernel_op_15*tmp_kernel_op_17 + tmp_kernel_op_33*tmp_kernel_op_35 + tmp_kernel_op_51*tmp_kernel_op_53 + tmp_kernel_op_69*tmp_kernel_op_71) + src_dof_2*(tmp_kernel_op_17*tmp_kernel_op_73 + tmp_kernel_op_35*tmp_kernel_op_75 + tmp_kernel_op_53*tmp_kernel_op_77 + tmp_kernel_op_71*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_17*tmp_kernel_op_84 + tmp_kernel_op_35*tmp_kernel_op_89 + tmp_kernel_op_53*tmp_kernel_op_94 + tmp_kernel_op_71*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_17 + tmp_kernel_op_103*tmp_kernel_op_35 + tmp_kernel_op_105*tmp_kernel_op_53 + tmp_kernel_op_107*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_17 + tmp_kernel_op_111*tmp_kernel_op_35 + tmp_kernel_op_113*tmp_kernel_op_53 + tmp_kernel_op_115*tmp_kernel_op_71);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_124 + tmp_kernel_op_119*tmp_kernel_op_125 + tmp_kernel_op_121*tmp_kernel_op_126 + tmp_kernel_op_123*tmp_kernel_op_127) + src_dof_1*(tmp_kernel_op_124*tmp_kernel_op_15 + tmp_kernel_op_125*tmp_kernel_op_33 + tmp_kernel_op_126*tmp_kernel_op_51 + tmp_kernel_op_127*tmp_kernel_op_69) + src_dof_2*(tmp_kernel_op_124*tmp_kernel_op_73 + tmp_kernel_op_125*tmp_kernel_op_75 + tmp_kernel_op_126*tmp_kernel_op_77 + tmp_kernel_op_127*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_124*tmp_kernel_op_84 + tmp_kernel_op_125*tmp_kernel_op_89 + tmp_kernel_op_126*tmp_kernel_op_94 + tmp_kernel_op_127*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_124 + tmp_kernel_op_103*tmp_kernel_op_125 + tmp_kernel_op_105*tmp_kernel_op_126 + tmp_kernel_op_107*tmp_kernel_op_127) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_124 + tmp_kernel_op_111*tmp_kernel_op_125 + tmp_kernel_op_113*tmp_kernel_op_126 + tmp_kernel_op_115*tmp_kernel_op_127);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_128 + tmp_kernel_op_119*tmp_kernel_op_129 + tmp_kernel_op_121*tmp_kernel_op_130 + tmp_kernel_op_123*tmp_kernel_op_131) + src_dof_1*(tmp_kernel_op_128*tmp_kernel_op_15 + tmp_kernel_op_129*tmp_kernel_op_33 + tmp_kernel_op_130*tmp_kernel_op_51 + tmp_kernel_op_131*tmp_kernel_op_69) + src_dof_2*(tmp_kernel_op_128*tmp_kernel_op_73 + tmp_kernel_op_129*tmp_kernel_op_75 + tmp_kernel_op_130*tmp_kernel_op_77 + tmp_kernel_op_131*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_128*tmp_kernel_op_84 + tmp_kernel_op_129*tmp_kernel_op_89 + tmp_kernel_op_130*tmp_kernel_op_94 + tmp_kernel_op_131*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_128 + tmp_kernel_op_103*tmp_kernel_op_129 + tmp_kernel_op_105*tmp_kernel_op_130 + tmp_kernel_op_107*tmp_kernel_op_131) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_128 + tmp_kernel_op_111*tmp_kernel_op_129 + tmp_kernel_op_113*tmp_kernel_op_130 + tmp_kernel_op_115*tmp_kernel_op_131);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_132 + tmp_kernel_op_119*tmp_kernel_op_133 + tmp_kernel_op_121*tmp_kernel_op_134 + tmp_kernel_op_123*tmp_kernel_op_135) + src_dof_1*(tmp_kernel_op_132*tmp_kernel_op_15 + tmp_kernel_op_133*tmp_kernel_op_33 + tmp_kernel_op_134*tmp_kernel_op_51 + tmp_kernel_op_135*tmp_kernel_op_69) + src_dof_2*(tmp_kernel_op_132*tmp_kernel_op_73 + tmp_kernel_op_133*tmp_kernel_op_75 + tmp_kernel_op_134*tmp_kernel_op_77 + tmp_kernel_op_135*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_132*tmp_kernel_op_84 + tmp_kernel_op_133*tmp_kernel_op_89 + tmp_kernel_op_134*tmp_kernel_op_94 + tmp_kernel_op_135*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_132 + tmp_kernel_op_103*tmp_kernel_op_133 + tmp_kernel_op_105*tmp_kernel_op_134 + tmp_kernel_op_107*tmp_kernel_op_135) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_132 + tmp_kernel_op_111*tmp_kernel_op_133 + tmp_kernel_op_113*tmp_kernel_op_134 + tmp_kernel_op_115*tmp_kernel_op_135);
                const real_t elMatVec_4 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_136 + tmp_kernel_op_119*tmp_kernel_op_137 + tmp_kernel_op_121*tmp_kernel_op_138 + tmp_kernel_op_123*tmp_kernel_op_139) + src_dof_1*(tmp_kernel_op_136*tmp_kernel_op_15 + tmp_kernel_op_137*tmp_kernel_op_33 + tmp_kernel_op_138*tmp_kernel_op_51 + tmp_kernel_op_139*tmp_kernel_op_69) + src_dof_2*(tmp_kernel_op_136*tmp_kernel_op_73 + tmp_kernel_op_137*tmp_kernel_op_75 + tmp_kernel_op_138*tmp_kernel_op_77 + tmp_kernel_op_139*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_136*tmp_kernel_op_84 + tmp_kernel_op_137*tmp_kernel_op_89 + tmp_kernel_op_138*tmp_kernel_op_94 + tmp_kernel_op_139*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_136 + tmp_kernel_op_103*tmp_kernel_op_137 + tmp_kernel_op_105*tmp_kernel_op_138 + tmp_kernel_op_107*tmp_kernel_op_139) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_136 + tmp_kernel_op_111*tmp_kernel_op_137 + tmp_kernel_op_113*tmp_kernel_op_138 + tmp_kernel_op_115*tmp_kernel_op_139);
                const real_t elMatVec_5 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_140 + tmp_kernel_op_119*tmp_kernel_op_141 + tmp_kernel_op_121*tmp_kernel_op_142 + tmp_kernel_op_123*tmp_kernel_op_143) + src_dof_1*(tmp_kernel_op_140*tmp_kernel_op_15 + tmp_kernel_op_141*tmp_kernel_op_33 + tmp_kernel_op_142*tmp_kernel_op_51 + tmp_kernel_op_143*tmp_kernel_op_69) + src_dof_2*(tmp_kernel_op_140*tmp_kernel_op_73 + tmp_kernel_op_141*tmp_kernel_op_75 + tmp_kernel_op_142*tmp_kernel_op_77 + tmp_kernel_op_143*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_140*tmp_kernel_op_84 + tmp_kernel_op_141*tmp_kernel_op_89 + tmp_kernel_op_142*tmp_kernel_op_94 + tmp_kernel_op_143*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_140 + tmp_kernel_op_103*tmp_kernel_op_141 + tmp_kernel_op_105*tmp_kernel_op_142 + tmp_kernel_op_107*tmp_kernel_op_143) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_140 + tmp_kernel_op_111*tmp_kernel_op_141 + tmp_kernel_op_113*tmp_kernel_op_142 + tmp_kernel_op_115*tmp_kernel_op_143);
                _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_3 + _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       const real_t tmp_moved_constant_0 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_9;
       const real_t tmp_moved_constant_1 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_2 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_9;
       const real_t tmp_moved_constant_3 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_4 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_27;
       const real_t tmp_moved_constant_5 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_18;
       const real_t tmp_moved_constant_6 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_27;
       const real_t tmp_moved_constant_7 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_18;
       const real_t tmp_moved_constant_8 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_45;
       const real_t tmp_moved_constant_9 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_36;
       const real_t tmp_moved_constant_10 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_45;
       const real_t tmp_moved_constant_11 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_36;
       const real_t tmp_moved_constant_12 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_63;
       const real_t tmp_moved_constant_13 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_54;
       const real_t tmp_moved_constant_14 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_63;
       const real_t tmp_moved_constant_15 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_54;
       {
          /* FaceType.BLUE */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d cp_dof_0 = _mm256_loadu_pd(& _data_cpVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d cp_dof_1 = _mm256_loadu_pd(& _data_cpVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d cp_dof_2 = _mm256_loadu_pd(& _data_cpVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d cp_dof_3 = _mm256_loadu_pd(& _data_cpEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d cp_dof_4 = _mm256_loadu_pd(& _data_cpEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d cp_dof_5 = _mm256_loadu_pd(& _data_cpEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d ux_dof_0 = _mm256_loadu_pd(& _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d ux_dof_1 = _mm256_loadu_pd(& _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d ux_dof_2 = _mm256_loadu_pd(& _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d ux_dof_3 = _mm256_loadu_pd(& _data_uxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d ux_dof_4 = _mm256_loadu_pd(& _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d ux_dof_5 = _mm256_loadu_pd(& _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d uy_dof_0 = _mm256_loadu_pd(& _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d uy_dof_1 = _mm256_loadu_pd(& _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d uy_dof_2 = _mm256_loadu_pd(& _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d uy_dof_3 = _mm256_loadu_pd(& _data_uyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d uy_dof_4 = _mm256_loadu_pd(& _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d uy_dof_5 = _mm256_loadu_pd(& _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d tmp_kernel_op_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(ux_dof_4,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(ux_dof_5,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(ux_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(ux_dof_3,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(ux_dof_1,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_mul_pd(ux_dof_2,_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8)));
                const __m256d tmp_kernel_op_14 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(uy_dof_4,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(uy_dof_5,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(uy_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(uy_dof_3,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(uy_dof_1,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_mul_pd(uy_dof_2,_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8)));
                const __m256d tmp_kernel_op_15 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_14,_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE)),_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)));
                const __m256d tmp_kernel_op_16 = _mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(cp_dof_4,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(cp_dof_5,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(cp_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(cp_dof_3,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(cp_dof_1,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_mul_pd(cp_dof_2,_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))),_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE));
                const __m256d tmp_kernel_op_17 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12));
                const __m256d tmp_kernel_op_31 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(ux_dof_3,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)),_mm256_mul_pd(ux_dof_1,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23))),_mm256_mul_pd(ux_dof_2,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(ux_dof_4,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_mul_pd(ux_dof_5,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(ux_dof_0,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(uy_dof_3,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)),_mm256_mul_pd(uy_dof_1,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23))),_mm256_mul_pd(uy_dof_2,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(uy_dof_4,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_mul_pd(uy_dof_5,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(uy_dof_0,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)));
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE)),_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE)),_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)));
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(cp_dof_3,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)),_mm256_mul_pd(cp_dof_1,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23))),_mm256_mul_pd(cp_dof_2,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(cp_dof_4,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_mul_pd(cp_dof_5,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(cp_dof_0,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE));
                const __m256d tmp_kernel_op_35 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(ux_dof_3,_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38)),_mm256_mul_pd(ux_dof_1,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41))),_mm256_mul_pd(ux_dof_2,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(ux_dof_4,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(ux_dof_5,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(ux_dof_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(uy_dof_3,_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38)),_mm256_mul_pd(uy_dof_1,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41))),_mm256_mul_pd(uy_dof_2,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(uy_dof_4,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(uy_dof_5,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(uy_dof_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48)));
                const __m256d tmp_kernel_op_51 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_49,_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37)));
                const __m256d tmp_kernel_op_52 = _mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(cp_dof_3,_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38)),_mm256_mul_pd(cp_dof_1,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41))),_mm256_mul_pd(cp_dof_2,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(cp_dof_4,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(cp_dof_5,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(cp_dof_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE));
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48));
                const __m256d tmp_kernel_op_67 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(ux_dof_3,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(ux_dof_1,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(ux_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(ux_dof_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(ux_dof_5,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(ux_dof_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_68 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(uy_dof_3,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(uy_dof_1,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(uy_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(uy_dof_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(uy_dof_5,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(uy_dof_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_69 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE)),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE)),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)));
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(cp_dof_3,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(cp_dof_1,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(cp_dof_2,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62))),_mm256_mul_pd(cp_dof_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(cp_dof_5,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(cp_dof_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66))),_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE,abs_det_jac_affine_BLUE));
                const __m256d tmp_kernel_op_71 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66));
                const __m256d tmp_kernel_op_73 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE)),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_14,_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE)),_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)));
                const __m256d tmp_kernel_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE)),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE)),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)));
                const __m256d tmp_kernel_op_77 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_49,_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE)),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE)),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)));
                const __m256d tmp_kernel_op_79 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE)),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE)),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78)));
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0),_mm256_set_pd(tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2),_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))));
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4),_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5))),_mm256_mul_pd(tmp_kernel_op_32,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6),_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))));
                const __m256d tmp_kernel_op_94 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10),_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_49,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8),_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12),_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14),_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15))));
                const __m256d tmp_kernel_op_101 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)))));
                const __m256d tmp_kernel_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)))),_mm256_mul_pd(tmp_kernel_op_32,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)))));
                const __m256d tmp_kernel_op_105 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)))),_mm256_mul_pd(tmp_kernel_op_49,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)))));
                const __m256d tmp_kernel_op_107 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106)))));
                const __m256d tmp_kernel_op_109 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)))));
                const __m256d tmp_kernel_op_111 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)))),_mm256_mul_pd(tmp_kernel_op_32,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)))));
                const __m256d tmp_kernel_op_113 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112)))),_mm256_mul_pd(tmp_kernel_op_49,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112)))));
                const __m256d tmp_kernel_op_115 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114)))));
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)))));
                const __m256d tmp_kernel_op_119 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118)))),_mm256_mul_pd(tmp_kernel_op_32,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118,tmp_kernel_op_118)))));
                const __m256d tmp_kernel_op_121 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_49,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120)))),_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120,tmp_kernel_op_120)))));
                const __m256d tmp_kernel_op_123 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122)))));
                const __m256d tmp_kernel_op_124 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5));
                const __m256d tmp_kernel_op_125 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23));
                const __m256d tmp_kernel_op_126 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41));
                const __m256d tmp_kernel_op_127 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59));
                const __m256d tmp_kernel_op_128 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8));
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44));
                const __m256d tmp_kernel_op_131 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62));
                const __m256d tmp_kernel_op_132 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_133 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20));
                const __m256d tmp_kernel_op_134 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38));
                const __m256d tmp_kernel_op_135 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10));
                const __m256d tmp_kernel_op_137 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28));
                const __m256d tmp_kernel_op_138 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46));
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64));
                const __m256d tmp_kernel_op_140 = _mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_141 = _mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29));
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47));
                const __m256d tmp_kernel_op_143 = _mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_17),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_35)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_53)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_71))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_17),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_35)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_53)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_17),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_35)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_53)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_15,tmp_kernel_op_17),_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35)),_mm256_mul_pd(tmp_kernel_op_51,tmp_kernel_op_53)),_mm256_mul_pd(tmp_kernel_op_69,tmp_kernel_op_71)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_53,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_53,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_99))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_124),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_125)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_126)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_127))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_124),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_125)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_126)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_127)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_124),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_125)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_126)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_127)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_15),_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_33)),_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_51)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_69)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_124,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_127,tmp_kernel_op_99))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_128),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_129)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_130)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_131))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_128),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_129)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_130)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_131)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_128),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_129)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_130)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_131)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_15),_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_33)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_51)),_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_69)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_129,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_99))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_133)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_134)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_135))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_133)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_134)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_135)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_132),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_133)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_134)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_135)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_15),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_33)),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_51)),_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_69)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_133,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_134,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_135,tmp_kernel_op_99))));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_136),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_137)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_138)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_139))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_136),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_137)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_138)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_139)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_136),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_137)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_138)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_139)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_15),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_33)),_mm256_mul_pd(tmp_kernel_op_138,tmp_kernel_op_51)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_69)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_138,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_136,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_137,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_138,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_139,tmp_kernel_op_99))));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_140),_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_141)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_142)),_mm256_mul_pd(tmp_kernel_op_107,tmp_kernel_op_143))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_109,tmp_kernel_op_140),_mm256_mul_pd(tmp_kernel_op_111,tmp_kernel_op_141)),_mm256_mul_pd(tmp_kernel_op_113,tmp_kernel_op_142)),_mm256_mul_pd(tmp_kernel_op_115,tmp_kernel_op_143)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_117,tmp_kernel_op_140),_mm256_mul_pd(tmp_kernel_op_119,tmp_kernel_op_141)),_mm256_mul_pd(tmp_kernel_op_121,tmp_kernel_op_142)),_mm256_mul_pd(tmp_kernel_op_123,tmp_kernel_op_143)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_15),_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_33)),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_51)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_69)))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_73),_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_75)),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_77)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_79)))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_89)),_mm256_mul_pd(tmp_kernel_op_142,tmp_kernel_op_94)),_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_99))));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t src_dof_3 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t cp_dof_0 = _data_cpVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t cp_dof_1 = _data_cpVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t cp_dof_2 = _data_cpVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t cp_dof_3 = _data_cpEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t cp_dof_4 = _data_cpEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t cp_dof_5 = _data_cpEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t ux_dof_1 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t ux_dof_3 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t uy_dof_1 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t uy_dof_3 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t tmp_kernel_op_13 = tmp_kernel_op_10*ux_dof_4 + tmp_kernel_op_11*ux_dof_5 + tmp_kernel_op_12*ux_dof_0 + tmp_kernel_op_2*ux_dof_3 + tmp_kernel_op_5*ux_dof_1 + tmp_kernel_op_8*ux_dof_2;
                const real_t tmp_kernel_op_14 = tmp_kernel_op_10*uy_dof_4 + tmp_kernel_op_11*uy_dof_5 + tmp_kernel_op_12*uy_dof_0 + tmp_kernel_op_2*uy_dof_3 + tmp_kernel_op_5*uy_dof_1 + tmp_kernel_op_8*uy_dof_2;
                const real_t tmp_kernel_op_15 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_1*tmp_kernel_op_13 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_1*tmp_kernel_op_14;
                const real_t tmp_kernel_op_16 = abs_det_jac_affine_BLUE*(cp_dof_0*tmp_kernel_op_12 + cp_dof_1*tmp_kernel_op_5 + cp_dof_2*tmp_kernel_op_8 + cp_dof_3*tmp_kernel_op_2 + cp_dof_4*tmp_kernel_op_10 + cp_dof_5*tmp_kernel_op_11)*-0.28125;
                const real_t tmp_kernel_op_17 = tmp_kernel_op_12*tmp_kernel_op_16;
                const real_t tmp_kernel_op_31 = tmp_kernel_op_20*ux_dof_3 + tmp_kernel_op_23*ux_dof_1 + tmp_kernel_op_26*ux_dof_2 + tmp_kernel_op_28*ux_dof_4 + tmp_kernel_op_29*ux_dof_5 + tmp_kernel_op_30*ux_dof_0;
                const real_t tmp_kernel_op_32 = tmp_kernel_op_20*uy_dof_3 + tmp_kernel_op_23*uy_dof_1 + tmp_kernel_op_26*uy_dof_2 + tmp_kernel_op_28*uy_dof_4 + tmp_kernel_op_29*uy_dof_5 + tmp_kernel_op_30*uy_dof_0;
                const real_t tmp_kernel_op_33 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_19*tmp_kernel_op_31 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_19*tmp_kernel_op_32;
                const real_t tmp_kernel_op_34 = abs_det_jac_affine_BLUE*(cp_dof_0*tmp_kernel_op_30 + cp_dof_1*tmp_kernel_op_23 + cp_dof_2*tmp_kernel_op_26 + cp_dof_3*tmp_kernel_op_20 + cp_dof_4*tmp_kernel_op_28 + cp_dof_5*tmp_kernel_op_29)*0.26041666666666669;
                const real_t tmp_kernel_op_35 = tmp_kernel_op_30*tmp_kernel_op_34;
                const real_t tmp_kernel_op_49 = tmp_kernel_op_38*ux_dof_3 + tmp_kernel_op_41*ux_dof_1 + tmp_kernel_op_44*ux_dof_2 + tmp_kernel_op_46*ux_dof_4 + tmp_kernel_op_47*ux_dof_5 + tmp_kernel_op_48*ux_dof_0;
                const real_t tmp_kernel_op_50 = tmp_kernel_op_38*uy_dof_3 + tmp_kernel_op_41*uy_dof_1 + tmp_kernel_op_44*uy_dof_2 + tmp_kernel_op_46*uy_dof_4 + tmp_kernel_op_47*uy_dof_5 + tmp_kernel_op_48*uy_dof_0;
                const real_t tmp_kernel_op_51 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_37*tmp_kernel_op_49 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_37*tmp_kernel_op_50;
                const real_t tmp_kernel_op_52 = abs_det_jac_affine_BLUE*(cp_dof_0*tmp_kernel_op_48 + cp_dof_1*tmp_kernel_op_41 + cp_dof_2*tmp_kernel_op_44 + cp_dof_3*tmp_kernel_op_38 + cp_dof_4*tmp_kernel_op_46 + cp_dof_5*tmp_kernel_op_47)*0.26041666666666669;
                const real_t tmp_kernel_op_53 = tmp_kernel_op_48*tmp_kernel_op_52;
                const real_t tmp_kernel_op_67 = tmp_kernel_op_56*ux_dof_3 + tmp_kernel_op_59*ux_dof_1 + tmp_kernel_op_62*ux_dof_2 + tmp_kernel_op_64*ux_dof_4 + tmp_kernel_op_65*ux_dof_5 + tmp_kernel_op_66*ux_dof_0;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_56*uy_dof_3 + tmp_kernel_op_59*uy_dof_1 + tmp_kernel_op_62*uy_dof_2 + tmp_kernel_op_64*uy_dof_4 + tmp_kernel_op_65*uy_dof_5 + tmp_kernel_op_66*uy_dof_0;
                const real_t tmp_kernel_op_69 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_55*tmp_kernel_op_67 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_55*tmp_kernel_op_68;
                const real_t tmp_kernel_op_70 = abs_det_jac_affine_BLUE*(cp_dof_0*tmp_kernel_op_66 + cp_dof_1*tmp_kernel_op_59 + cp_dof_2*tmp_kernel_op_62 + cp_dof_3*tmp_kernel_op_56 + cp_dof_4*tmp_kernel_op_64 + cp_dof_5*tmp_kernel_op_65)*0.26041666666666669;
                const real_t tmp_kernel_op_71 = tmp_kernel_op_66*tmp_kernel_op_70;
                const real_t tmp_kernel_op_73 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_13*tmp_kernel_op_72 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_14*tmp_kernel_op_72;
                const real_t tmp_kernel_op_75 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_31*tmp_kernel_op_74 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_32*tmp_kernel_op_74;
                const real_t tmp_kernel_op_77 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_49*tmp_kernel_op_76 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_50*tmp_kernel_op_76;
                const real_t tmp_kernel_op_79 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_67*tmp_kernel_op_78 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_68*tmp_kernel_op_78;
                const real_t tmp_kernel_op_84 = tmp_kernel_op_13*(tmp_moved_constant_0 + tmp_moved_constant_1) + tmp_kernel_op_14*(tmp_moved_constant_2 + tmp_moved_constant_3);
                const real_t tmp_kernel_op_89 = tmp_kernel_op_31*(tmp_moved_constant_4 + tmp_moved_constant_5) + tmp_kernel_op_32*(tmp_moved_constant_6 + tmp_moved_constant_7);
                const real_t tmp_kernel_op_94 = tmp_kernel_op_49*(tmp_moved_constant_8 + tmp_moved_constant_9) + tmp_kernel_op_50*(tmp_moved_constant_10 + tmp_moved_constant_11);
                const real_t tmp_kernel_op_99 = tmp_kernel_op_67*(tmp_moved_constant_12 + tmp_moved_constant_13) + tmp_kernel_op_68*(tmp_moved_constant_14 + tmp_moved_constant_15);
                const real_t tmp_kernel_op_101 = tmp_kernel_op_13*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_100 - tmp_moved_constant_0) + tmp_kernel_op_14*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_100 - tmp_moved_constant_2);
                const real_t tmp_kernel_op_103 = tmp_kernel_op_31*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_102 - tmp_moved_constant_4) + tmp_kernel_op_32*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_102 - tmp_moved_constant_6);
                const real_t tmp_kernel_op_105 = tmp_kernel_op_49*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_104 - tmp_moved_constant_8) + tmp_kernel_op_50*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_104 - tmp_moved_constant_10);
                const real_t tmp_kernel_op_107 = tmp_kernel_op_67*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_106 - tmp_moved_constant_12) + tmp_kernel_op_68*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_106 - tmp_moved_constant_14);
                const real_t tmp_kernel_op_109 = tmp_kernel_op_13*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_108 - tmp_moved_constant_1) + tmp_kernel_op_14*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_108 - tmp_moved_constant_3);
                const real_t tmp_kernel_op_111 = tmp_kernel_op_31*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_110 - tmp_moved_constant_5) + tmp_kernel_op_32*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_110 - tmp_moved_constant_7);
                const real_t tmp_kernel_op_113 = tmp_kernel_op_49*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_112 - tmp_moved_constant_9) + tmp_kernel_op_50*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_112 - tmp_moved_constant_11);
                const real_t tmp_kernel_op_115 = tmp_kernel_op_67*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_114 - tmp_moved_constant_13) + tmp_kernel_op_68*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_114 - tmp_moved_constant_15);
                const real_t tmp_kernel_op_117 = tmp_kernel_op_13*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_116 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_116) + tmp_kernel_op_14*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_116 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_116);
                const real_t tmp_kernel_op_119 = tmp_kernel_op_31*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_118 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_118) + tmp_kernel_op_32*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_118 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_118);
                const real_t tmp_kernel_op_121 = tmp_kernel_op_49*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_120 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_120) + tmp_kernel_op_50*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_120 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_120);
                const real_t tmp_kernel_op_123 = tmp_kernel_op_67*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_122 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_122) + tmp_kernel_op_68*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_122 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_122);
                const real_t tmp_kernel_op_124 = tmp_kernel_op_16*tmp_kernel_op_5;
                const real_t tmp_kernel_op_125 = tmp_kernel_op_23*tmp_kernel_op_34;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_41*tmp_kernel_op_52;
                const real_t tmp_kernel_op_127 = tmp_kernel_op_59*tmp_kernel_op_70;
                const real_t tmp_kernel_op_128 = tmp_kernel_op_16*tmp_kernel_op_8;
                const real_t tmp_kernel_op_129 = tmp_kernel_op_26*tmp_kernel_op_34;
                const real_t tmp_kernel_op_130 = tmp_kernel_op_44*tmp_kernel_op_52;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_62*tmp_kernel_op_70;
                const real_t tmp_kernel_op_132 = tmp_kernel_op_16*tmp_kernel_op_2;
                const real_t tmp_kernel_op_133 = tmp_kernel_op_20*tmp_kernel_op_34;
                const real_t tmp_kernel_op_134 = tmp_kernel_op_38*tmp_kernel_op_52;
                const real_t tmp_kernel_op_135 = tmp_kernel_op_56*tmp_kernel_op_70;
                const real_t tmp_kernel_op_136 = tmp_kernel_op_10*tmp_kernel_op_16;
                const real_t tmp_kernel_op_137 = tmp_kernel_op_28*tmp_kernel_op_34;
                const real_t tmp_kernel_op_138 = tmp_kernel_op_46*tmp_kernel_op_52;
                const real_t tmp_kernel_op_139 = tmp_kernel_op_64*tmp_kernel_op_70;
                const real_t tmp_kernel_op_140 = tmp_kernel_op_11*tmp_kernel_op_16;
                const real_t tmp_kernel_op_141 = tmp_kernel_op_29*tmp_kernel_op_34;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_47*tmp_kernel_op_52;
                const real_t tmp_kernel_op_143 = tmp_kernel_op_65*tmp_kernel_op_70;
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_17 + tmp_kernel_op_119*tmp_kernel_op_35 + tmp_kernel_op_121*tmp_kernel_op_53 + tmp_kernel_op_123*tmp_kernel_op_71) + src_dof_1*(tmp_kernel_op_15*tmp_kernel_op_17 + tmp_kernel_op_33*tmp_kernel_op_35 + tmp_kernel_op_51*tmp_kernel_op_53 + tmp_kernel_op_69*tmp_kernel_op_71) + src_dof_2*(tmp_kernel_op_17*tmp_kernel_op_73 + tmp_kernel_op_35*tmp_kernel_op_75 + tmp_kernel_op_53*tmp_kernel_op_77 + tmp_kernel_op_71*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_17*tmp_kernel_op_84 + tmp_kernel_op_35*tmp_kernel_op_89 + tmp_kernel_op_53*tmp_kernel_op_94 + tmp_kernel_op_71*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_17 + tmp_kernel_op_103*tmp_kernel_op_35 + tmp_kernel_op_105*tmp_kernel_op_53 + tmp_kernel_op_107*tmp_kernel_op_71) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_17 + tmp_kernel_op_111*tmp_kernel_op_35 + tmp_kernel_op_113*tmp_kernel_op_53 + tmp_kernel_op_115*tmp_kernel_op_71);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_124 + tmp_kernel_op_119*tmp_kernel_op_125 + tmp_kernel_op_121*tmp_kernel_op_126 + tmp_kernel_op_123*tmp_kernel_op_127) + src_dof_1*(tmp_kernel_op_124*tmp_kernel_op_15 + tmp_kernel_op_125*tmp_kernel_op_33 + tmp_kernel_op_126*tmp_kernel_op_51 + tmp_kernel_op_127*tmp_kernel_op_69) + src_dof_2*(tmp_kernel_op_124*tmp_kernel_op_73 + tmp_kernel_op_125*tmp_kernel_op_75 + tmp_kernel_op_126*tmp_kernel_op_77 + tmp_kernel_op_127*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_124*tmp_kernel_op_84 + tmp_kernel_op_125*tmp_kernel_op_89 + tmp_kernel_op_126*tmp_kernel_op_94 + tmp_kernel_op_127*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_124 + tmp_kernel_op_103*tmp_kernel_op_125 + tmp_kernel_op_105*tmp_kernel_op_126 + tmp_kernel_op_107*tmp_kernel_op_127) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_124 + tmp_kernel_op_111*tmp_kernel_op_125 + tmp_kernel_op_113*tmp_kernel_op_126 + tmp_kernel_op_115*tmp_kernel_op_127);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_128 + tmp_kernel_op_119*tmp_kernel_op_129 + tmp_kernel_op_121*tmp_kernel_op_130 + tmp_kernel_op_123*tmp_kernel_op_131) + src_dof_1*(tmp_kernel_op_128*tmp_kernel_op_15 + tmp_kernel_op_129*tmp_kernel_op_33 + tmp_kernel_op_130*tmp_kernel_op_51 + tmp_kernel_op_131*tmp_kernel_op_69) + src_dof_2*(tmp_kernel_op_128*tmp_kernel_op_73 + tmp_kernel_op_129*tmp_kernel_op_75 + tmp_kernel_op_130*tmp_kernel_op_77 + tmp_kernel_op_131*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_128*tmp_kernel_op_84 + tmp_kernel_op_129*tmp_kernel_op_89 + tmp_kernel_op_130*tmp_kernel_op_94 + tmp_kernel_op_131*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_128 + tmp_kernel_op_103*tmp_kernel_op_129 + tmp_kernel_op_105*tmp_kernel_op_130 + tmp_kernel_op_107*tmp_kernel_op_131) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_128 + tmp_kernel_op_111*tmp_kernel_op_129 + tmp_kernel_op_113*tmp_kernel_op_130 + tmp_kernel_op_115*tmp_kernel_op_131);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_132 + tmp_kernel_op_119*tmp_kernel_op_133 + tmp_kernel_op_121*tmp_kernel_op_134 + tmp_kernel_op_123*tmp_kernel_op_135) + src_dof_1*(tmp_kernel_op_132*tmp_kernel_op_15 + tmp_kernel_op_133*tmp_kernel_op_33 + tmp_kernel_op_134*tmp_kernel_op_51 + tmp_kernel_op_135*tmp_kernel_op_69) + src_dof_2*(tmp_kernel_op_132*tmp_kernel_op_73 + tmp_kernel_op_133*tmp_kernel_op_75 + tmp_kernel_op_134*tmp_kernel_op_77 + tmp_kernel_op_135*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_132*tmp_kernel_op_84 + tmp_kernel_op_133*tmp_kernel_op_89 + tmp_kernel_op_134*tmp_kernel_op_94 + tmp_kernel_op_135*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_132 + tmp_kernel_op_103*tmp_kernel_op_133 + tmp_kernel_op_105*tmp_kernel_op_134 + tmp_kernel_op_107*tmp_kernel_op_135) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_132 + tmp_kernel_op_111*tmp_kernel_op_133 + tmp_kernel_op_113*tmp_kernel_op_134 + tmp_kernel_op_115*tmp_kernel_op_135);
                const real_t elMatVec_4 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_136 + tmp_kernel_op_119*tmp_kernel_op_137 + tmp_kernel_op_121*tmp_kernel_op_138 + tmp_kernel_op_123*tmp_kernel_op_139) + src_dof_1*(tmp_kernel_op_136*tmp_kernel_op_15 + tmp_kernel_op_137*tmp_kernel_op_33 + tmp_kernel_op_138*tmp_kernel_op_51 + tmp_kernel_op_139*tmp_kernel_op_69) + src_dof_2*(tmp_kernel_op_136*tmp_kernel_op_73 + tmp_kernel_op_137*tmp_kernel_op_75 + tmp_kernel_op_138*tmp_kernel_op_77 + tmp_kernel_op_139*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_136*tmp_kernel_op_84 + tmp_kernel_op_137*tmp_kernel_op_89 + tmp_kernel_op_138*tmp_kernel_op_94 + tmp_kernel_op_139*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_136 + tmp_kernel_op_103*tmp_kernel_op_137 + tmp_kernel_op_105*tmp_kernel_op_138 + tmp_kernel_op_107*tmp_kernel_op_139) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_136 + tmp_kernel_op_111*tmp_kernel_op_137 + tmp_kernel_op_113*tmp_kernel_op_138 + tmp_kernel_op_115*tmp_kernel_op_139);
                const real_t elMatVec_5 = src_dof_0*(tmp_kernel_op_117*tmp_kernel_op_140 + tmp_kernel_op_119*tmp_kernel_op_141 + tmp_kernel_op_121*tmp_kernel_op_142 + tmp_kernel_op_123*tmp_kernel_op_143) + src_dof_1*(tmp_kernel_op_140*tmp_kernel_op_15 + tmp_kernel_op_141*tmp_kernel_op_33 + tmp_kernel_op_142*tmp_kernel_op_51 + tmp_kernel_op_143*tmp_kernel_op_69) + src_dof_2*(tmp_kernel_op_140*tmp_kernel_op_73 + tmp_kernel_op_141*tmp_kernel_op_75 + tmp_kernel_op_142*tmp_kernel_op_77 + tmp_kernel_op_143*tmp_kernel_op_79) + src_dof_3*(tmp_kernel_op_140*tmp_kernel_op_84 + tmp_kernel_op_141*tmp_kernel_op_89 + tmp_kernel_op_142*tmp_kernel_op_94 + tmp_kernel_op_143*tmp_kernel_op_99) + src_dof_4*(tmp_kernel_op_101*tmp_kernel_op_140 + tmp_kernel_op_103*tmp_kernel_op_141 + tmp_kernel_op_105*tmp_kernel_op_142 + tmp_kernel_op_107*tmp_kernel_op_143) + src_dof_5*(tmp_kernel_op_109*tmp_kernel_op_140 + tmp_kernel_op_111*tmp_kernel_op_141 + tmp_kernel_op_113*tmp_kernel_op_142 + tmp_kernel_op_115*tmp_kernel_op_143);
                _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_3 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
