/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

































#include "../P2VectorElementwiseEpsilonP0Viscosity.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseEpsilonP0Viscosity::apply_P2VectorElementwiseEpsilonP0Viscosity_macro_3D( real_t * RESTRICT  _data_dst_edge_0, real_t * RESTRICT  _data_dst_edge_1, real_t * RESTRICT  _data_dst_edge_2, real_t * RESTRICT  _data_dst_vertex_0, real_t * RESTRICT  _data_dst_vertex_1, real_t * RESTRICT  _data_dst_vertex_2, real_t * RESTRICT  _data_mu, real_t * RESTRICT  _data_src_edge_0, real_t * RESTRICT  _data_src_edge_1, real_t * RESTRICT  _data_src_edge_2, real_t * RESTRICT  _data_src_vertex_0, real_t * RESTRICT  _data_src_vertex_1, real_t * RESTRICT  _data_src_vertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t _data_q_w [] = {0.041666666666666657, 0.041666666666666657, 0.041666666666666657, 0.041666666666666657};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_0_0_WHITE_UP [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_UP [] = {((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787) + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-1.2 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-1.2 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663) + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787) + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-1.2 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-1.2 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663) + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997894 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991574)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-3.577708763999663)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-1.2 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-1.2 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991552)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-1.2 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-1.2 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991552)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997888 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991552 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991552)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-1.2 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-1.2 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_0_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_0_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_0_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_2_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_2_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*3.5999999999999988 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-1.2 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-1.2 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_1_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_1_WHITE_UP*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_1_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_0_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_0_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_1_1_WHITE_UP*0.22360679774997883 + jac_affine_inv_2_1_WHITE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*1.7999999999999994 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_1_2_WHITE_UP*0.8944271909999153 + jac_affine_inv_2_2_WHITE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_UP*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-3.577708763999663 + jac_affine_inv_1_2_WHITE_UP*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.40000000000000008 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_UP*-2.6832815729997472)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_0_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_0_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.40000000000000008 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_UP*-2.6832815729997472)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_1_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_1_WHITE_UP*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_2_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_UP*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*0.20000000000000004 + jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_UP*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_UP*-2.6832815729997472)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_1_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*(jac_affine_inv_2_0_WHITE_UP*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_UP*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_UP*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*3.5777087639996634)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_1_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_0_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_UP*0.89442719099991586 + jac_affine_inv_1_1_WHITE_UP*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_UP*3.5777087639996634 + jac_affine_inv_1_2_WHITE_UP*-1.105572809000084 + jac_affine_inv_2_2_WHITE_UP*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_WHITE_UP[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_UP[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
             const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
             const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
             const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
             const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
             const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
             const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
             const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
             const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
             const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
             const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
             const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
             const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
             const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
             const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
             const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
             const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
             const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
             const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
             const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
             const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_14 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_15 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_16 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_17 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_18 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_19 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_24 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_25 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_26 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_27 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_28 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_29 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_0_0_WHITE_DOWN [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_DOWN [] = {((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-1.2 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-1.2 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-1.2 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-1.2 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991574)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-1.2 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-1.2 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991552)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-1.2 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-1.2 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991552)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991552)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-1.2 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-1.2 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*3.5999999999999988 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-1.2 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-1.2 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_WHITE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_WHITE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_WHITE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_WHITE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_WHITE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_WHITE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_WHITE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_WHITE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_WHITE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.40000000000000008 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_WHITE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_WHITE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_WHITE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_WHITE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_WHITE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_WHITE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_1_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*(jac_affine_inv_2_0_WHITE_DOWN*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_WHITE_DOWN*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_WHITE_DOWN*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_WHITE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_WHITE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_WHITE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_WHITE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_WHITE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_WHITE_DOWN*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge - 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 2)*(micro_edges_per_macro_edge - 1)) / (6)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 2)*(-ctr_2 + micro_edges_per_macro_edge - 1)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_WHITE_DOWN[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
             const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
             const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
             const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
             const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
             const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
             const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
             const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
             const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
             const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
             const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
             const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
             const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
             const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
             const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
             const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
             const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
             const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
             const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
             const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
             const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_9 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_14 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_15 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_16 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_17 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_18 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_19 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_24 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_25 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_26 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_27 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_28 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_29 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_0_0_BLUE_UP [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_UP [] = {((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787) + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-1.2 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-1.2 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663) + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787) + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-1.2 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-1.2 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663) + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997894 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991574)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-3.577708763999663)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-1.2 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-1.2 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991552)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-1.2 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-1.2 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991552)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997888 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991552 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991552)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-1.2 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-1.2 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_0_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_0_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_0_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_2_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_2_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*3.5999999999999988 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-1.2 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-1.2 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_1_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_1_BLUE_UP*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_1_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_0_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_0_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_1_1_BLUE_UP*0.22360679774997883 + jac_affine_inv_2_1_BLUE_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*1.7999999999999994 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_1_2_BLUE_UP*0.8944271909999153 + jac_affine_inv_2_2_BLUE_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_UP*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_UP*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-3.577708763999663 + jac_affine_inv_1_2_BLUE_UP*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.40000000000000008 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_UP*-2.6832815729997472)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_0_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_0_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.40000000000000008 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_UP*-2.6832815729997472)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_1_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_1_BLUE_UP*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_2_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_UP*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_UP*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*0.20000000000000004 + jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_UP*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_UP*-2.6832815729997472)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_1_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*(jac_affine_inv_2_0_BLUE_UP*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_UP*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_UP*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*3.5777087639996634)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_1_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_0_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_UP*0.89442719099991586 + jac_affine_inv_1_1_BLUE_UP*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_UP*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_UP*3.5777087639996634 + jac_affine_inv_1_2_BLUE_UP*-1.105572809000084 + jac_affine_inv_2_2_BLUE_UP*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_BLUE_UP[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_UP[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
             const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
             const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
             const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
             const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
             const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
             const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
             const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
             const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
             const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
             const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
             const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
             const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
             const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
             const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
             const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
             const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
             const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
             const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
             const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
             const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_8 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_14 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_15 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_16 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_17 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_18 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_19 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_24 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_25 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_26 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_27 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_28 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_29 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_0_0_BLUE_DOWN [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_DOWN [] = {((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-1.2 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-1.2 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-1.2 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-1.2 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997894 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991574)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-1.2 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-1.2 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991552)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-1.2 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-1.2 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991552)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997888 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991552 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991552)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-1.2 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-1.2 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_0_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_0_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_0_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_2_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_2_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*3.5999999999999988 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-1.2 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-1.2 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_1_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_1_BLUE_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_1_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_0_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_0_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_1_1_BLUE_DOWN*0.22360679774997883 + jac_affine_inv_2_1_BLUE_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_1_2_BLUE_DOWN*0.8944271909999153 + jac_affine_inv_2_2_BLUE_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_BLUE_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_BLUE_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-3.577708763999663 + jac_affine_inv_1_2_BLUE_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_BLUE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_0_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_0_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.40000000000000008 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_BLUE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_1_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_1_BLUE_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_2_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_BLUE_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_BLUE_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*0.20000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_BLUE_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_BLUE_DOWN*-2.6832815729997472)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_1_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*(jac_affine_inv_2_0_BLUE_DOWN*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_BLUE_DOWN*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_BLUE_DOWN*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_1_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_0_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_BLUE_DOWN*0.89442719099991586 + jac_affine_inv_1_1_BLUE_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_BLUE_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_BLUE_DOWN*3.5777087639996634 + jac_affine_inv_1_2_BLUE_DOWN*-1.105572809000084 + jac_affine_inv_2_2_BLUE_DOWN*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 2)*(micro_edges_per_macro_edge - 1)) / (6)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_BLUE_DOWN[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
             const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
             const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
             const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
             const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
             const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
             const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
             const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
             const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
             const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
             const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
             const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
             const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
             const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
             const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
             const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
             const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
             const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
             const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
             const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
             const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_14 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_15 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_16 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_17 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_18 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_19 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_24 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_25 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_26 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_27 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_28 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_29 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_0_0_GREEN_UP [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_UP [] = {((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787) + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-1.2 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-1.2 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663) + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787) + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-1.2 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-1.2 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663) + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997894 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991574)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-3.577708763999663)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-1.2 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-1.2 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991552)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-1.2 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-1.2 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991552)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997888 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991552 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991552)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-1.2 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-1.2 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_0_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_0_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_0_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_2_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_2_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*3.5999999999999988 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-1.2 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-1.2 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_1_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_1_GREEN_UP*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_1_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_0_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_0_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_1_1_GREEN_UP*0.22360679774997883 + jac_affine_inv_2_1_GREEN_UP*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*1.7999999999999994 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_1_2_GREEN_UP*0.8944271909999153 + jac_affine_inv_2_2_GREEN_UP*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_UP*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_UP*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-3.577708763999663 + jac_affine_inv_1_2_GREEN_UP*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.40000000000000008 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_UP*-2.6832815729997472)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_0_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_0_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.40000000000000008 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_UP*-2.6832815729997472)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_1_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_1_GREEN_UP*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_2_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_UP*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_UP*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*0.20000000000000004 + jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_UP*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_UP*-2.6832815729997472)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_1_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*(jac_affine_inv_2_0_GREEN_UP*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_UP*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_UP*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*3.5777087639996634)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_1_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_0_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_UP*0.89442719099991586 + jac_affine_inv_1_1_GREEN_UP*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_UP*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_UP*3.5777087639996634 + jac_affine_inv_1_2_GREEN_UP*-1.105572809000084 + jac_affine_inv_2_2_GREEN_UP*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_GREEN_UP[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_UP[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
             const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
             const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
             const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
             const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
             const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
             const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
             const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
             const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
             const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
             const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
             const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
             const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
             const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
             const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
             const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
             const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
             const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
             const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
             const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
             const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_14 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_15 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_16 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_17 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_18 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_19 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_24 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_25 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_26 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_27 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_28 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_29 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_0_0_GREEN_DOWN [] = {1.0, 1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_DOWN [] = {((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-1.2 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-1.2 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-1.2 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-1.2 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997894 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997894)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-0.89442719099991574)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991574)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-3.577708763999663)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-1.2 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-1.2 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991552)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776) + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-1.2 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-1.2 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991552)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997888 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997888)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_1_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991552 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991552)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-1.2 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-1.2 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_0_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_0_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_0_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765) + (jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_2_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_2_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*3.5999999999999988 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*1.7999999999999994))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-1.2 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-1.2 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*1.7999999999999994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-0.59999999999999998)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_1_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_1_GREEN_DOWN*0.8944271909999153) + (jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_1_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-4.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_2_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_2_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_0_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_0_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_1_1_GREEN_DOWN*0.22360679774997883 + jac_affine_inv_2_1_GREEN_DOWN*0.22360679774997883)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*1.7999999999999994 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*3.5999999999999988))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*-0.59999999999999998 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*-1.2))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*1.3416407864998736 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*1.3416407864998736))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*1.1102230246251565e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*1.1102230246251565e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_1_2_GREEN_DOWN*0.8944271909999153 + jac_affine_inv_2_2_GREEN_DOWN*0.8944271909999153)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.6832815729997472 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*2.6832815729997472))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*4.4408920985006262e-16)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*4.4408920985006262e-16 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_0_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_0_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.89442719099991574 + jac_affine_inv_1_1_GREEN_DOWN*-1.1708203932499368 + jac_affine_inv_2_1_GREEN_DOWN*-1.1708203932499368)*(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-3.577708763999663 + jac_affine_inv_1_2_GREEN_DOWN*-4.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-4.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_0_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_0_GREEN_DOWN*-2.6832815729997472)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_0_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_0_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_2_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_2_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.40000000000000008 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.40000000000000008 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.20000000000000004))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.20000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_1_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_1_GREEN_DOWN*-2.6832815729997472)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202) + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_1_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_1_GREEN_DOWN*-1.105572809000084) + (jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_2_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_2_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_0_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_0_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_1_1_GREEN_DOWN*-0.67082039324993681 + jac_affine_inv_2_1_GREEN_DOWN*-0.67082039324993681)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*0.20000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*0.20000000000000004 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*0.40000000000000008))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*-0.44721359549995798 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*-0.44721359549995798))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*0.89442719099991586)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_1_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*2.0)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_1_2_GREEN_DOWN*-2.6832815729997472 + jac_affine_inv_2_2_GREEN_DOWN*-2.6832815729997472)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_0_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_1_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_1_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*(jac_affine_inv_2_0_GREEN_DOWN*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_1_GREEN_DOWN*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*-0.89442719099991597 + jac_affine_inv_2_2_GREEN_DOWN*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*-0.89442719099991597))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*3.5777087639996634)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_1_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084)*(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)))), ((real_t)(abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_0_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_0_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_1_GREEN_DOWN*0.89442719099991586 + jac_affine_inv_1_1_GREEN_DOWN*-0.27639320225002101 + jac_affine_inv_2_1_GREEN_DOWN*-0.27639320225002101)*(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)*2.0 + (jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)*(jac_affine_inv_0_2_GREEN_DOWN*3.5777087639996634 + jac_affine_inv_1_2_GREEN_DOWN*-1.105572809000084 + jac_affine_inv_2_2_GREEN_DOWN*-1.105572809000084))))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_7 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_9 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_15 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_17 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_19 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_25 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_27 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_29 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 2)*(micro_edges_per_macro_edge - 1)) / (6)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_0_12 = 0.0;
             real_t q_acc_0_13 = 0.0;
             real_t q_acc_0_14 = 0.0;
             real_t q_acc_0_15 = 0.0;
             real_t q_acc_0_16 = 0.0;
             real_t q_acc_0_17 = 0.0;
             real_t q_acc_0_18 = 0.0;
             real_t q_acc_0_19 = 0.0;
             real_t q_acc_0_20 = 0.0;
             real_t q_acc_0_21 = 0.0;
             real_t q_acc_0_22 = 0.0;
             real_t q_acc_0_23 = 0.0;
             real_t q_acc_0_24 = 0.0;
             real_t q_acc_0_25 = 0.0;
             real_t q_acc_0_26 = 0.0;
             real_t q_acc_0_27 = 0.0;
             real_t q_acc_0_28 = 0.0;
             real_t q_acc_0_29 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_1_12 = 0.0;
             real_t q_acc_1_13 = 0.0;
             real_t q_acc_1_14 = 0.0;
             real_t q_acc_1_15 = 0.0;
             real_t q_acc_1_16 = 0.0;
             real_t q_acc_1_17 = 0.0;
             real_t q_acc_1_18 = 0.0;
             real_t q_acc_1_19 = 0.0;
             real_t q_acc_1_20 = 0.0;
             real_t q_acc_1_21 = 0.0;
             real_t q_acc_1_22 = 0.0;
             real_t q_acc_1_23 = 0.0;
             real_t q_acc_1_24 = 0.0;
             real_t q_acc_1_25 = 0.0;
             real_t q_acc_1_26 = 0.0;
             real_t q_acc_1_27 = 0.0;
             real_t q_acc_1_28 = 0.0;
             real_t q_acc_1_29 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_2_12 = 0.0;
             real_t q_acc_2_13 = 0.0;
             real_t q_acc_2_14 = 0.0;
             real_t q_acc_2_15 = 0.0;
             real_t q_acc_2_16 = 0.0;
             real_t q_acc_2_17 = 0.0;
             real_t q_acc_2_18 = 0.0;
             real_t q_acc_2_19 = 0.0;
             real_t q_acc_2_20 = 0.0;
             real_t q_acc_2_21 = 0.0;
             real_t q_acc_2_22 = 0.0;
             real_t q_acc_2_23 = 0.0;
             real_t q_acc_2_24 = 0.0;
             real_t q_acc_2_25 = 0.0;
             real_t q_acc_2_26 = 0.0;
             real_t q_acc_2_27 = 0.0;
             real_t q_acc_2_28 = 0.0;
             real_t q_acc_2_29 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_3_12 = 0.0;
             real_t q_acc_3_13 = 0.0;
             real_t q_acc_3_14 = 0.0;
             real_t q_acc_3_15 = 0.0;
             real_t q_acc_3_16 = 0.0;
             real_t q_acc_3_17 = 0.0;
             real_t q_acc_3_18 = 0.0;
             real_t q_acc_3_19 = 0.0;
             real_t q_acc_3_20 = 0.0;
             real_t q_acc_3_21 = 0.0;
             real_t q_acc_3_22 = 0.0;
             real_t q_acc_3_23 = 0.0;
             real_t q_acc_3_24 = 0.0;
             real_t q_acc_3_25 = 0.0;
             real_t q_acc_3_26 = 0.0;
             real_t q_acc_3_27 = 0.0;
             real_t q_acc_3_28 = 0.0;
             real_t q_acc_3_29 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_4_12 = 0.0;
             real_t q_acc_4_13 = 0.0;
             real_t q_acc_4_14 = 0.0;
             real_t q_acc_4_15 = 0.0;
             real_t q_acc_4_16 = 0.0;
             real_t q_acc_4_17 = 0.0;
             real_t q_acc_4_18 = 0.0;
             real_t q_acc_4_19 = 0.0;
             real_t q_acc_4_20 = 0.0;
             real_t q_acc_4_21 = 0.0;
             real_t q_acc_4_22 = 0.0;
             real_t q_acc_4_23 = 0.0;
             real_t q_acc_4_24 = 0.0;
             real_t q_acc_4_25 = 0.0;
             real_t q_acc_4_26 = 0.0;
             real_t q_acc_4_27 = 0.0;
             real_t q_acc_4_28 = 0.0;
             real_t q_acc_4_29 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_5_12 = 0.0;
             real_t q_acc_5_13 = 0.0;
             real_t q_acc_5_14 = 0.0;
             real_t q_acc_5_15 = 0.0;
             real_t q_acc_5_16 = 0.0;
             real_t q_acc_5_17 = 0.0;
             real_t q_acc_5_18 = 0.0;
             real_t q_acc_5_19 = 0.0;
             real_t q_acc_5_20 = 0.0;
             real_t q_acc_5_21 = 0.0;
             real_t q_acc_5_22 = 0.0;
             real_t q_acc_5_23 = 0.0;
             real_t q_acc_5_24 = 0.0;
             real_t q_acc_5_25 = 0.0;
             real_t q_acc_5_26 = 0.0;
             real_t q_acc_5_27 = 0.0;
             real_t q_acc_5_28 = 0.0;
             real_t q_acc_5_29 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_6_12 = 0.0;
             real_t q_acc_6_13 = 0.0;
             real_t q_acc_6_14 = 0.0;
             real_t q_acc_6_15 = 0.0;
             real_t q_acc_6_16 = 0.0;
             real_t q_acc_6_17 = 0.0;
             real_t q_acc_6_18 = 0.0;
             real_t q_acc_6_19 = 0.0;
             real_t q_acc_6_20 = 0.0;
             real_t q_acc_6_21 = 0.0;
             real_t q_acc_6_22 = 0.0;
             real_t q_acc_6_23 = 0.0;
             real_t q_acc_6_24 = 0.0;
             real_t q_acc_6_25 = 0.0;
             real_t q_acc_6_26 = 0.0;
             real_t q_acc_6_27 = 0.0;
             real_t q_acc_6_28 = 0.0;
             real_t q_acc_6_29 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_7_12 = 0.0;
             real_t q_acc_7_13 = 0.0;
             real_t q_acc_7_14 = 0.0;
             real_t q_acc_7_15 = 0.0;
             real_t q_acc_7_16 = 0.0;
             real_t q_acc_7_17 = 0.0;
             real_t q_acc_7_18 = 0.0;
             real_t q_acc_7_19 = 0.0;
             real_t q_acc_7_20 = 0.0;
             real_t q_acc_7_21 = 0.0;
             real_t q_acc_7_22 = 0.0;
             real_t q_acc_7_23 = 0.0;
             real_t q_acc_7_24 = 0.0;
             real_t q_acc_7_25 = 0.0;
             real_t q_acc_7_26 = 0.0;
             real_t q_acc_7_27 = 0.0;
             real_t q_acc_7_28 = 0.0;
             real_t q_acc_7_29 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_8_12 = 0.0;
             real_t q_acc_8_13 = 0.0;
             real_t q_acc_8_14 = 0.0;
             real_t q_acc_8_15 = 0.0;
             real_t q_acc_8_16 = 0.0;
             real_t q_acc_8_17 = 0.0;
             real_t q_acc_8_18 = 0.0;
             real_t q_acc_8_19 = 0.0;
             real_t q_acc_8_20 = 0.0;
             real_t q_acc_8_21 = 0.0;
             real_t q_acc_8_22 = 0.0;
             real_t q_acc_8_23 = 0.0;
             real_t q_acc_8_24 = 0.0;
             real_t q_acc_8_25 = 0.0;
             real_t q_acc_8_26 = 0.0;
             real_t q_acc_8_27 = 0.0;
             real_t q_acc_8_28 = 0.0;
             real_t q_acc_8_29 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_9_12 = 0.0;
             real_t q_acc_9_13 = 0.0;
             real_t q_acc_9_14 = 0.0;
             real_t q_acc_9_15 = 0.0;
             real_t q_acc_9_16 = 0.0;
             real_t q_acc_9_17 = 0.0;
             real_t q_acc_9_18 = 0.0;
             real_t q_acc_9_19 = 0.0;
             real_t q_acc_9_20 = 0.0;
             real_t q_acc_9_21 = 0.0;
             real_t q_acc_9_22 = 0.0;
             real_t q_acc_9_23 = 0.0;
             real_t q_acc_9_24 = 0.0;
             real_t q_acc_9_25 = 0.0;
             real_t q_acc_9_26 = 0.0;
             real_t q_acc_9_27 = 0.0;
             real_t q_acc_9_28 = 0.0;
             real_t q_acc_9_29 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_10_12 = 0.0;
             real_t q_acc_10_13 = 0.0;
             real_t q_acc_10_14 = 0.0;
             real_t q_acc_10_15 = 0.0;
             real_t q_acc_10_16 = 0.0;
             real_t q_acc_10_17 = 0.0;
             real_t q_acc_10_18 = 0.0;
             real_t q_acc_10_19 = 0.0;
             real_t q_acc_10_20 = 0.0;
             real_t q_acc_10_21 = 0.0;
             real_t q_acc_10_22 = 0.0;
             real_t q_acc_10_23 = 0.0;
             real_t q_acc_10_24 = 0.0;
             real_t q_acc_10_25 = 0.0;
             real_t q_acc_10_26 = 0.0;
             real_t q_acc_10_27 = 0.0;
             real_t q_acc_10_28 = 0.0;
             real_t q_acc_10_29 = 0.0;
             real_t q_acc_11_11 = 0.0;
             real_t q_acc_11_12 = 0.0;
             real_t q_acc_11_13 = 0.0;
             real_t q_acc_11_14 = 0.0;
             real_t q_acc_11_15 = 0.0;
             real_t q_acc_11_16 = 0.0;
             real_t q_acc_11_17 = 0.0;
             real_t q_acc_11_18 = 0.0;
             real_t q_acc_11_19 = 0.0;
             real_t q_acc_11_20 = 0.0;
             real_t q_acc_11_21 = 0.0;
             real_t q_acc_11_22 = 0.0;
             real_t q_acc_11_23 = 0.0;
             real_t q_acc_11_24 = 0.0;
             real_t q_acc_11_25 = 0.0;
             real_t q_acc_11_26 = 0.0;
             real_t q_acc_11_27 = 0.0;
             real_t q_acc_11_28 = 0.0;
             real_t q_acc_11_29 = 0.0;
             real_t q_acc_12_12 = 0.0;
             real_t q_acc_12_13 = 0.0;
             real_t q_acc_12_14 = 0.0;
             real_t q_acc_12_15 = 0.0;
             real_t q_acc_12_16 = 0.0;
             real_t q_acc_12_17 = 0.0;
             real_t q_acc_12_18 = 0.0;
             real_t q_acc_12_19 = 0.0;
             real_t q_acc_12_20 = 0.0;
             real_t q_acc_12_21 = 0.0;
             real_t q_acc_12_22 = 0.0;
             real_t q_acc_12_23 = 0.0;
             real_t q_acc_12_24 = 0.0;
             real_t q_acc_12_25 = 0.0;
             real_t q_acc_12_26 = 0.0;
             real_t q_acc_12_27 = 0.0;
             real_t q_acc_12_28 = 0.0;
             real_t q_acc_12_29 = 0.0;
             real_t q_acc_13_13 = 0.0;
             real_t q_acc_13_14 = 0.0;
             real_t q_acc_13_15 = 0.0;
             real_t q_acc_13_16 = 0.0;
             real_t q_acc_13_17 = 0.0;
             real_t q_acc_13_18 = 0.0;
             real_t q_acc_13_19 = 0.0;
             real_t q_acc_13_20 = 0.0;
             real_t q_acc_13_21 = 0.0;
             real_t q_acc_13_22 = 0.0;
             real_t q_acc_13_23 = 0.0;
             real_t q_acc_13_24 = 0.0;
             real_t q_acc_13_25 = 0.0;
             real_t q_acc_13_26 = 0.0;
             real_t q_acc_13_27 = 0.0;
             real_t q_acc_13_28 = 0.0;
             real_t q_acc_13_29 = 0.0;
             real_t q_acc_14_14 = 0.0;
             real_t q_acc_14_15 = 0.0;
             real_t q_acc_14_16 = 0.0;
             real_t q_acc_14_17 = 0.0;
             real_t q_acc_14_18 = 0.0;
             real_t q_acc_14_19 = 0.0;
             real_t q_acc_14_20 = 0.0;
             real_t q_acc_14_21 = 0.0;
             real_t q_acc_14_22 = 0.0;
             real_t q_acc_14_23 = 0.0;
             real_t q_acc_14_24 = 0.0;
             real_t q_acc_14_25 = 0.0;
             real_t q_acc_14_26 = 0.0;
             real_t q_acc_14_27 = 0.0;
             real_t q_acc_14_28 = 0.0;
             real_t q_acc_14_29 = 0.0;
             real_t q_acc_15_15 = 0.0;
             real_t q_acc_15_16 = 0.0;
             real_t q_acc_15_17 = 0.0;
             real_t q_acc_15_18 = 0.0;
             real_t q_acc_15_19 = 0.0;
             real_t q_acc_15_20 = 0.0;
             real_t q_acc_15_21 = 0.0;
             real_t q_acc_15_22 = 0.0;
             real_t q_acc_15_23 = 0.0;
             real_t q_acc_15_24 = 0.0;
             real_t q_acc_15_25 = 0.0;
             real_t q_acc_15_26 = 0.0;
             real_t q_acc_15_27 = 0.0;
             real_t q_acc_15_28 = 0.0;
             real_t q_acc_15_29 = 0.0;
             real_t q_acc_16_16 = 0.0;
             real_t q_acc_16_17 = 0.0;
             real_t q_acc_16_18 = 0.0;
             real_t q_acc_16_19 = 0.0;
             real_t q_acc_16_20 = 0.0;
             real_t q_acc_16_21 = 0.0;
             real_t q_acc_16_22 = 0.0;
             real_t q_acc_16_23 = 0.0;
             real_t q_acc_16_24 = 0.0;
             real_t q_acc_16_25 = 0.0;
             real_t q_acc_16_26 = 0.0;
             real_t q_acc_16_27 = 0.0;
             real_t q_acc_16_28 = 0.0;
             real_t q_acc_16_29 = 0.0;
             real_t q_acc_17_17 = 0.0;
             real_t q_acc_17_18 = 0.0;
             real_t q_acc_17_19 = 0.0;
             real_t q_acc_17_20 = 0.0;
             real_t q_acc_17_21 = 0.0;
             real_t q_acc_17_22 = 0.0;
             real_t q_acc_17_23 = 0.0;
             real_t q_acc_17_24 = 0.0;
             real_t q_acc_17_25 = 0.0;
             real_t q_acc_17_26 = 0.0;
             real_t q_acc_17_27 = 0.0;
             real_t q_acc_17_28 = 0.0;
             real_t q_acc_17_29 = 0.0;
             real_t q_acc_18_18 = 0.0;
             real_t q_acc_18_19 = 0.0;
             real_t q_acc_18_20 = 0.0;
             real_t q_acc_18_21 = 0.0;
             real_t q_acc_18_22 = 0.0;
             real_t q_acc_18_23 = 0.0;
             real_t q_acc_18_24 = 0.0;
             real_t q_acc_18_25 = 0.0;
             real_t q_acc_18_26 = 0.0;
             real_t q_acc_18_27 = 0.0;
             real_t q_acc_18_28 = 0.0;
             real_t q_acc_18_29 = 0.0;
             real_t q_acc_19_19 = 0.0;
             real_t q_acc_19_20 = 0.0;
             real_t q_acc_19_21 = 0.0;
             real_t q_acc_19_22 = 0.0;
             real_t q_acc_19_23 = 0.0;
             real_t q_acc_19_24 = 0.0;
             real_t q_acc_19_25 = 0.0;
             real_t q_acc_19_26 = 0.0;
             real_t q_acc_19_27 = 0.0;
             real_t q_acc_19_28 = 0.0;
             real_t q_acc_19_29 = 0.0;
             real_t q_acc_20_20 = 0.0;
             real_t q_acc_20_21 = 0.0;
             real_t q_acc_20_22 = 0.0;
             real_t q_acc_20_23 = 0.0;
             real_t q_acc_20_24 = 0.0;
             real_t q_acc_20_25 = 0.0;
             real_t q_acc_20_26 = 0.0;
             real_t q_acc_20_27 = 0.0;
             real_t q_acc_20_28 = 0.0;
             real_t q_acc_20_29 = 0.0;
             real_t q_acc_21_21 = 0.0;
             real_t q_acc_21_22 = 0.0;
             real_t q_acc_21_23 = 0.0;
             real_t q_acc_21_24 = 0.0;
             real_t q_acc_21_25 = 0.0;
             real_t q_acc_21_26 = 0.0;
             real_t q_acc_21_27 = 0.0;
             real_t q_acc_21_28 = 0.0;
             real_t q_acc_21_29 = 0.0;
             real_t q_acc_22_22 = 0.0;
             real_t q_acc_22_23 = 0.0;
             real_t q_acc_22_24 = 0.0;
             real_t q_acc_22_25 = 0.0;
             real_t q_acc_22_26 = 0.0;
             real_t q_acc_22_27 = 0.0;
             real_t q_acc_22_28 = 0.0;
             real_t q_acc_22_29 = 0.0;
             real_t q_acc_23_23 = 0.0;
             real_t q_acc_23_24 = 0.0;
             real_t q_acc_23_25 = 0.0;
             real_t q_acc_23_26 = 0.0;
             real_t q_acc_23_27 = 0.0;
             real_t q_acc_23_28 = 0.0;
             real_t q_acc_23_29 = 0.0;
             real_t q_acc_24_24 = 0.0;
             real_t q_acc_24_25 = 0.0;
             real_t q_acc_24_26 = 0.0;
             real_t q_acc_24_27 = 0.0;
             real_t q_acc_24_28 = 0.0;
             real_t q_acc_24_29 = 0.0;
             real_t q_acc_25_25 = 0.0;
             real_t q_acc_25_26 = 0.0;
             real_t q_acc_25_27 = 0.0;
             real_t q_acc_25_28 = 0.0;
             real_t q_acc_25_29 = 0.0;
             real_t q_acc_26_26 = 0.0;
             real_t q_acc_26_27 = 0.0;
             real_t q_acc_26_28 = 0.0;
             real_t q_acc_26_29 = 0.0;
             real_t q_acc_27_27 = 0.0;
             real_t q_acc_27_28 = 0.0;
             real_t q_acc_27_29 = 0.0;
             real_t q_acc_28_28 = 0.0;
             real_t q_acc_28_29 = 0.0;
             real_t q_acc_29_29 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_GREEN_DOWN[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 11];
                const real_t q_tmp_0_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 12];
                const real_t q_tmp_0_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 13];
                const real_t q_tmp_0_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 14];
                const real_t q_tmp_0_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 15];
                const real_t q_tmp_0_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 16];
                const real_t q_tmp_0_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 17];
                const real_t q_tmp_0_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 18];
                const real_t q_tmp_0_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 19];
                const real_t q_tmp_0_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 20];
                const real_t q_tmp_0_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 21];
                const real_t q_tmp_0_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 22];
                const real_t q_tmp_0_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 23];
                const real_t q_tmp_0_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 24];
                const real_t q_tmp_0_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 25];
                const real_t q_tmp_0_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 26];
                const real_t q_tmp_0_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 27];
                const real_t q_tmp_0_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 28];
                const real_t q_tmp_0_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 29];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 31];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 32];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 33];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 34];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 35];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 36];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 37];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 38];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 39];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 40];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 41];
                const real_t q_tmp_1_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 42];
                const real_t q_tmp_1_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 43];
                const real_t q_tmp_1_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 44];
                const real_t q_tmp_1_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 45];
                const real_t q_tmp_1_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 46];
                const real_t q_tmp_1_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 47];
                const real_t q_tmp_1_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 48];
                const real_t q_tmp_1_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 49];
                const real_t q_tmp_1_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 50];
                const real_t q_tmp_1_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 51];
                const real_t q_tmp_1_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 52];
                const real_t q_tmp_1_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 53];
                const real_t q_tmp_1_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 54];
                const real_t q_tmp_1_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 55];
                const real_t q_tmp_1_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 56];
                const real_t q_tmp_1_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 57];
                const real_t q_tmp_1_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 58];
                const real_t q_tmp_1_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 59];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 61];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 62];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 63];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 64];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 65];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 66];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 67];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 68];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 69];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 70];
                const real_t q_tmp_2_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 71];
                const real_t q_tmp_2_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 72];
                const real_t q_tmp_2_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 73];
                const real_t q_tmp_2_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 74];
                const real_t q_tmp_2_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 75];
                const real_t q_tmp_2_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 76];
                const real_t q_tmp_2_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 77];
                const real_t q_tmp_2_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 78];
                const real_t q_tmp_2_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 79];
                const real_t q_tmp_2_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 80];
                const real_t q_tmp_2_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 81];
                const real_t q_tmp_2_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 82];
                const real_t q_tmp_2_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 83];
                const real_t q_tmp_2_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 84];
                const real_t q_tmp_2_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 85];
                const real_t q_tmp_2_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 86];
                const real_t q_tmp_2_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 87];
                const real_t q_tmp_2_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 88];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 90];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 91];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 92];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 93];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 94];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 95];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 96];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 97];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 98];
                const real_t q_tmp_3_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 99];
                const real_t q_tmp_3_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 100];
                const real_t q_tmp_3_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 101];
                const real_t q_tmp_3_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 102];
                const real_t q_tmp_3_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 103];
                const real_t q_tmp_3_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 104];
                const real_t q_tmp_3_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 105];
                const real_t q_tmp_3_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 106];
                const real_t q_tmp_3_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 107];
                const real_t q_tmp_3_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 108];
                const real_t q_tmp_3_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 109];
                const real_t q_tmp_3_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 110];
                const real_t q_tmp_3_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 111];
                const real_t q_tmp_3_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 112];
                const real_t q_tmp_3_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 113];
                const real_t q_tmp_3_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 114];
                const real_t q_tmp_3_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 115];
                const real_t q_tmp_3_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 116];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 121];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 122];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 123];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 124];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 125];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 126];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 127];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 128];
                const real_t q_tmp_4_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 129];
                const real_t q_tmp_4_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 130];
                const real_t q_tmp_4_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 131];
                const real_t q_tmp_4_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 132];
                const real_t q_tmp_4_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 133];
                const real_t q_tmp_4_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 134];
                const real_t q_tmp_4_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 135];
                const real_t q_tmp_4_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 136];
                const real_t q_tmp_4_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 137];
                const real_t q_tmp_4_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 138];
                const real_t q_tmp_4_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 139];
                const real_t q_tmp_4_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 140];
                const real_t q_tmp_4_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 141];
                const real_t q_tmp_4_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 142];
                const real_t q_tmp_4_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 143];
                const real_t q_tmp_4_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 144];
                const real_t q_tmp_4_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 145];
                const real_t q_tmp_4_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 146];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 152];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 153];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 154];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 155];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 156];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 157];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 158];
                const real_t q_tmp_5_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 159];
                const real_t q_tmp_5_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 160];
                const real_t q_tmp_5_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 161];
                const real_t q_tmp_5_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 162];
                const real_t q_tmp_5_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 163];
                const real_t q_tmp_5_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 164];
                const real_t q_tmp_5_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 165];
                const real_t q_tmp_5_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 166];
                const real_t q_tmp_5_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 167];
                const real_t q_tmp_5_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 168];
                const real_t q_tmp_5_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 169];
                const real_t q_tmp_5_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 170];
                const real_t q_tmp_5_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 171];
                const real_t q_tmp_5_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 172];
                const real_t q_tmp_5_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 173];
                const real_t q_tmp_5_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 174];
                const real_t q_tmp_5_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 175];
                const real_t q_tmp_5_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 176];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 183];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 184];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 185];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 186];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 187];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 188];
                const real_t q_tmp_6_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 189];
                const real_t q_tmp_6_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 190];
                const real_t q_tmp_6_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 191];
                const real_t q_tmp_6_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 192];
                const real_t q_tmp_6_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 193];
                const real_t q_tmp_6_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 194];
                const real_t q_tmp_6_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 195];
                const real_t q_tmp_6_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 196];
                const real_t q_tmp_6_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 197];
                const real_t q_tmp_6_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 198];
                const real_t q_tmp_6_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 199];
                const real_t q_tmp_6_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 200];
                const real_t q_tmp_6_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 201];
                const real_t q_tmp_6_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 202];
                const real_t q_tmp_6_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 203];
                const real_t q_tmp_6_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 204];
                const real_t q_tmp_6_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 205];
                const real_t q_tmp_6_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 206];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 214];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 215];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 216];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 217];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 218];
                const real_t q_tmp_7_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 219];
                const real_t q_tmp_7_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 220];
                const real_t q_tmp_7_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 221];
                const real_t q_tmp_7_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 222];
                const real_t q_tmp_7_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 223];
                const real_t q_tmp_7_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 224];
                const real_t q_tmp_7_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 225];
                const real_t q_tmp_7_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 226];
                const real_t q_tmp_7_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 227];
                const real_t q_tmp_7_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 228];
                const real_t q_tmp_7_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 229];
                const real_t q_tmp_7_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 230];
                const real_t q_tmp_7_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 231];
                const real_t q_tmp_7_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 232];
                const real_t q_tmp_7_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 233];
                const real_t q_tmp_7_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 234];
                const real_t q_tmp_7_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 235];
                const real_t q_tmp_7_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 236];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 245];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 246];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 247];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 248];
                const real_t q_tmp_8_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 249];
                const real_t q_tmp_8_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 250];
                const real_t q_tmp_8_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 251];
                const real_t q_tmp_8_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 252];
                const real_t q_tmp_8_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 253];
                const real_t q_tmp_8_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 254];
                const real_t q_tmp_8_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 255];
                const real_t q_tmp_8_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 256];
                const real_t q_tmp_8_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 257];
                const real_t q_tmp_8_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 258];
                const real_t q_tmp_8_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 259];
                const real_t q_tmp_8_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 260];
                const real_t q_tmp_8_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 261];
                const real_t q_tmp_8_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 262];
                const real_t q_tmp_8_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 263];
                const real_t q_tmp_8_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 264];
                const real_t q_tmp_8_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 265];
                const real_t q_tmp_8_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 266];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 276];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 277];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 278];
                const real_t q_tmp_9_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 279];
                const real_t q_tmp_9_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 280];
                const real_t q_tmp_9_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 281];
                const real_t q_tmp_9_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 282];
                const real_t q_tmp_9_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 283];
                const real_t q_tmp_9_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 284];
                const real_t q_tmp_9_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 285];
                const real_t q_tmp_9_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 286];
                const real_t q_tmp_9_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 287];
                const real_t q_tmp_9_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 288];
                const real_t q_tmp_9_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 289];
                const real_t q_tmp_9_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 290];
                const real_t q_tmp_9_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 291];
                const real_t q_tmp_9_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 292];
                const real_t q_tmp_9_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 293];
                const real_t q_tmp_9_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 294];
                const real_t q_tmp_9_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 295];
                const real_t q_tmp_9_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 296];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 307];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 308];
                const real_t q_tmp_10_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 309];
                const real_t q_tmp_10_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 310];
                const real_t q_tmp_10_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 311];
                const real_t q_tmp_10_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 312];
                const real_t q_tmp_10_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 313];
                const real_t q_tmp_10_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 314];
                const real_t q_tmp_10_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 315];
                const real_t q_tmp_10_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 316];
                const real_t q_tmp_10_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 317];
                const real_t q_tmp_10_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 318];
                const real_t q_tmp_10_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 319];
                const real_t q_tmp_10_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 320];
                const real_t q_tmp_10_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 321];
                const real_t q_tmp_10_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 322];
                const real_t q_tmp_10_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 323];
                const real_t q_tmp_10_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 324];
                const real_t q_tmp_10_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 325];
                const real_t q_tmp_10_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 326];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 335];
                const real_t q_tmp_11_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 336];
                const real_t q_tmp_11_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 337];
                const real_t q_tmp_11_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 338];
                const real_t q_tmp_11_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 339];
                const real_t q_tmp_11_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 340];
                const real_t q_tmp_11_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 341];
                const real_t q_tmp_11_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 342];
                const real_t q_tmp_11_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 343];
                const real_t q_tmp_11_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 344];
                const real_t q_tmp_11_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 345];
                const real_t q_tmp_11_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 346];
                const real_t q_tmp_11_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 347];
                const real_t q_tmp_11_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 348];
                const real_t q_tmp_11_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 349];
                const real_t q_tmp_11_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 350];
                const real_t q_tmp_11_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 351];
                const real_t q_tmp_11_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 352];
                const real_t q_tmp_11_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 353];
                const real_t q_tmp_12_12 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 362];
                const real_t q_tmp_12_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 363];
                const real_t q_tmp_12_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 364];
                const real_t q_tmp_12_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 365];
                const real_t q_tmp_12_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 366];
                const real_t q_tmp_12_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 367];
                const real_t q_tmp_12_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 368];
                const real_t q_tmp_12_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 369];
                const real_t q_tmp_12_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 370];
                const real_t q_tmp_12_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 371];
                const real_t q_tmp_12_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 372];
                const real_t q_tmp_12_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 373];
                const real_t q_tmp_12_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 374];
                const real_t q_tmp_12_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 375];
                const real_t q_tmp_12_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 376];
                const real_t q_tmp_12_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 377];
                const real_t q_tmp_12_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 378];
                const real_t q_tmp_12_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 379];
                const real_t q_tmp_13_13 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 388];
                const real_t q_tmp_13_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 389];
                const real_t q_tmp_13_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 390];
                const real_t q_tmp_13_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 391];
                const real_t q_tmp_13_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 392];
                const real_t q_tmp_13_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 393];
                const real_t q_tmp_13_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 394];
                const real_t q_tmp_13_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 395];
                const real_t q_tmp_13_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 396];
                const real_t q_tmp_13_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 397];
                const real_t q_tmp_13_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 398];
                const real_t q_tmp_13_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 399];
                const real_t q_tmp_13_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 400];
                const real_t q_tmp_13_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 401];
                const real_t q_tmp_13_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 402];
                const real_t q_tmp_13_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 403];
                const real_t q_tmp_13_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 404];
                const real_t q_tmp_14_14 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 419];
                const real_t q_tmp_14_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 420];
                const real_t q_tmp_14_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 421];
                const real_t q_tmp_14_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 422];
                const real_t q_tmp_14_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 423];
                const real_t q_tmp_14_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 424];
                const real_t q_tmp_14_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 425];
                const real_t q_tmp_14_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 426];
                const real_t q_tmp_14_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 427];
                const real_t q_tmp_14_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 428];
                const real_t q_tmp_14_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 429];
                const real_t q_tmp_14_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 430];
                const real_t q_tmp_14_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 431];
                const real_t q_tmp_14_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 432];
                const real_t q_tmp_14_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 433];
                const real_t q_tmp_14_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 434];
                const real_t q_tmp_15_15 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 450];
                const real_t q_tmp_15_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 451];
                const real_t q_tmp_15_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 452];
                const real_t q_tmp_15_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 453];
                const real_t q_tmp_15_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 454];
                const real_t q_tmp_15_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 455];
                const real_t q_tmp_15_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 456];
                const real_t q_tmp_15_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 457];
                const real_t q_tmp_15_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 458];
                const real_t q_tmp_15_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 459];
                const real_t q_tmp_15_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 460];
                const real_t q_tmp_15_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 461];
                const real_t q_tmp_15_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 462];
                const real_t q_tmp_15_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 463];
                const real_t q_tmp_15_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 464];
                const real_t q_tmp_16_16 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 481];
                const real_t q_tmp_16_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 482];
                const real_t q_tmp_16_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 483];
                const real_t q_tmp_16_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 484];
                const real_t q_tmp_16_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 485];
                const real_t q_tmp_16_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 486];
                const real_t q_tmp_16_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 487];
                const real_t q_tmp_16_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 488];
                const real_t q_tmp_16_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 489];
                const real_t q_tmp_16_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 490];
                const real_t q_tmp_16_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 491];
                const real_t q_tmp_16_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 492];
                const real_t q_tmp_16_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 493];
                const real_t q_tmp_16_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 494];
                const real_t q_tmp_17_17 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 512];
                const real_t q_tmp_17_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 513];
                const real_t q_tmp_17_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 514];
                const real_t q_tmp_17_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 515];
                const real_t q_tmp_17_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 516];
                const real_t q_tmp_17_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 517];
                const real_t q_tmp_17_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 518];
                const real_t q_tmp_17_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 519];
                const real_t q_tmp_17_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 520];
                const real_t q_tmp_17_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 521];
                const real_t q_tmp_17_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 522];
                const real_t q_tmp_17_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 523];
                const real_t q_tmp_17_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 524];
                const real_t q_tmp_18_18 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 543];
                const real_t q_tmp_18_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 544];
                const real_t q_tmp_18_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 545];
                const real_t q_tmp_18_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 546];
                const real_t q_tmp_18_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 547];
                const real_t q_tmp_18_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 548];
                const real_t q_tmp_18_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 549];
                const real_t q_tmp_18_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 550];
                const real_t q_tmp_18_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 551];
                const real_t q_tmp_18_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 552];
                const real_t q_tmp_18_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 553];
                const real_t q_tmp_18_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 554];
                const real_t q_tmp_19_19 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 574];
                const real_t q_tmp_19_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 575];
                const real_t q_tmp_19_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 576];
                const real_t q_tmp_19_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 577];
                const real_t q_tmp_19_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 578];
                const real_t q_tmp_19_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 579];
                const real_t q_tmp_19_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 580];
                const real_t q_tmp_19_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 581];
                const real_t q_tmp_19_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 582];
                const real_t q_tmp_19_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 583];
                const real_t q_tmp_19_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 584];
                const real_t q_tmp_20_20 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 605];
                const real_t q_tmp_20_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 606];
                const real_t q_tmp_20_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 607];
                const real_t q_tmp_20_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 608];
                const real_t q_tmp_20_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 609];
                const real_t q_tmp_20_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 610];
                const real_t q_tmp_20_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 611];
                const real_t q_tmp_20_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 612];
                const real_t q_tmp_20_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 613];
                const real_t q_tmp_20_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 614];
                const real_t q_tmp_21_21 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 630];
                const real_t q_tmp_21_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 631];
                const real_t q_tmp_21_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 632];
                const real_t q_tmp_21_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 633];
                const real_t q_tmp_21_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 634];
                const real_t q_tmp_21_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 635];
                const real_t q_tmp_21_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 636];
                const real_t q_tmp_21_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 637];
                const real_t q_tmp_21_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 638];
                const real_t q_tmp_22_22 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 654];
                const real_t q_tmp_22_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 655];
                const real_t q_tmp_22_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 656];
                const real_t q_tmp_22_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 657];
                const real_t q_tmp_22_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 658];
                const real_t q_tmp_22_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 659];
                const real_t q_tmp_22_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 660];
                const real_t q_tmp_22_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 661];
                const real_t q_tmp_23_23 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 677];
                const real_t q_tmp_23_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 678];
                const real_t q_tmp_23_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 679];
                const real_t q_tmp_23_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 680];
                const real_t q_tmp_23_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 681];
                const real_t q_tmp_23_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 682];
                const real_t q_tmp_23_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 683];
                const real_t q_tmp_24_24 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 708];
                const real_t q_tmp_24_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 709];
                const real_t q_tmp_24_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 710];
                const real_t q_tmp_24_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 711];
                const real_t q_tmp_24_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 712];
                const real_t q_tmp_24_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 713];
                const real_t q_tmp_25_25 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 739];
                const real_t q_tmp_25_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 740];
                const real_t q_tmp_25_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 741];
                const real_t q_tmp_25_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 742];
                const real_t q_tmp_25_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 743];
                const real_t q_tmp_26_26 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 770];
                const real_t q_tmp_26_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 771];
                const real_t q_tmp_26_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 772];
                const real_t q_tmp_26_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 773];
                const real_t q_tmp_27_27 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 801];
                const real_t q_tmp_27_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 802];
                const real_t q_tmp_27_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 803];
                const real_t q_tmp_28_28 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 832];
                const real_t q_tmp_28_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 833];
                const real_t q_tmp_29_29 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[864*q + 863];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
             const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
             const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
             const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
             const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
             const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
             const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
             const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
             const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
             const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
             const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
             const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
             const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
             const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
             const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
             const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
             const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
             const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
             const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
             const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
             const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_6 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_14 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_15 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_16 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_17 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_18 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_19 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_24 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_25 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_26 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_27 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_28 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_29 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
